#include  <iostream>
#include  <stdio.h>
#include "htalib_serial.h"
#include  "helper.h"
#include "hta_helper.h"
#include "utility.h"
using namespace std;
typedef Triplet R;

void dgefb(int m, int n, HTA<double, 2, 1> a, int nb, HTA<int, 1 ,1> ipiv, int info){
  info = 0;
  int m1 = (m+nb-1)/nb-1;
  int n1 = (n+nb-1)/nb-1;
  int lda = nb;
  int bi, bj, bk;
  for(bj=0;bj<=n1;bj++){
    int ns = nb;
    /*
     * Factor column swath a{bj:m1, bj}
     */
    //    Triplet args [] ={Triplet(bj, m1), Triplet(bj, bj)};
    //    Shape<2> s = Shape<2>(args);
    timer_start(3);
    hta_dgetf2(a[R(bj, m1), R(bj,bj)], nb,ipiv[Tuple<1>(bj)], info);
    timer_stop(3);
    /*
     * Globalize pivot indices
     */
      /*
       * Forward pivot a{bj:m1,bk}
       */
      
   for(bk=bj+1; bk<=n1; bk++){
     int ks=nb;
     //     Triplet args1 [] ={Triplet(bj, m1), Triplet(bk, bk)};
     //      Shape<2> s1 = Shape<2>(args1);
      timer_start(4);
      hta_dlaswp( a[R(bj,m1), R(bk,bk)], nb, bj, ipiv[Tuple<1>(bj)], 1);
      timer_stop(4);

      /*
       * Solve L*X =a{bj,bk}
       */
   	timer_start(5);
	
	dllnu4(nb, ks, a[Tuple<2>(bj,bj)], lda, a[Tuple<2>(bj,bk)],lda);
	timer_stop(5);
	for(bi=bj+1;bi<=m1; bi++){
	  int ms = nb;
	  /*
	 * update a{bi,bk}=a{bi,bk}-a{bi,bj}*a{bj,bk}
	 */

	timer_start(6);
	dab4(ms, ks, nb, a[Tuple<2>(bi,bj)], lda, a[Tuple<2>(bj,bk)],lda, a[Tuple<2>(bi,bk)], lda);
	timer_stop(6);
      }
    }

    for(bi=0;bi<bj;bi++){
      /*
       * back pivot a{bj:m1,bi}
       */
      //      Triplet args2 [] ={Triplet(bj, m1), Triplet(bi, bi)};
      //      Shape<2> s2 = Shape<2>(args2);
      timer_start(7);
      hta_dlaswp(a[R(bj,m1),R(bi,bi)], lda, bj, ipiv[Tuple<1>(bj)], 1);
      timer_stop(7);
    } 
  }
}


int main(int argc, char** argv){
  if (argc <3){
    cout<< "Usage: "<<argv[0]<<" size, tile_num\n";
    return -1;
  }
  int n = atoi(argv[1]);
  int first_tiling = atoi(argv[2]);
  int tile_sz = n/first_tiling;
  

  Tuple<2> tiling []= {Tuple<2>(tile_sz, tile_sz), Tuple<2>(first_tiling, first_tiling)};
  Tuple<1> tiling1 [] = {Tuple<1>(tile_sz), Tuple<1>(first_tiling)};
  /* Clear timers */
  for (int i = 0; i< 64; i++){
    timer_clear(i);
  }
  timer_start(2);
  timer_start(0);

  HTA<double, 2, 1> htaa_tmp = HTA<double, 2, 1>::alloc(tiling, ROW);
  HTA<double, 2, 1> htaa = HTA<double, 2, 1>::alloc(tiling, TILE);
  // Create the input matrix to be factorized.
  double* dData = htaa_tmp.raw();
  for (int i = 0; i < n*n; i++){
    int x = i/n;
    int y = i%n;
    if(x>=n/2 && y >=n/2){
      dData[i]= n*n-i;
    }else{
      dData[i] = i-1;
    }
  }
  


  htaa = htaa_tmp;
  int info;
  
  HTA<int,1,1> ipiv = HTA<int, 1, 1>::alloc(tiling1, TILE);
    
  timer_stop(0);
  timer_start(1);
  dgefb(n, n, htaa, tile_sz, ipiv, info);
  timer_stop(1);
  timer_stop(2);

  cout<<timer_read(2)<<" ";  // total time
  cout<<timer_read(3)<<" ";  // dgetf2
  cout<<timer_read(5)<<" "; //dllnu4
  cout<<timer_read(4)+timer_read(7)<<" ";  //dlaswp
  cout<<timer_read(6)<<"\n";  //dab4

  return 0;
}      
