#ifndef __UTILITY_H__
#define __UTILITY_H__
#include <sys/time.h>
#include <unistd.h>
#include <stdio.h>


void wtime(double *t)
{
  static int sec = -1;
  struct timeval tv;
  gettimeofday(&tv, 0);
  if (sec < 0) sec = tv.tv_sec;
  *t = (tv.tv_sec - sec) + 1.0e-6*tv.tv_usec;
}

/*****************************************************************/
/******         E  L  A  P  S  E  D  _  T  I  M  E          ******/
/*****************************************************************/
double elapsed_time( void )
{
    double t;
    wtime( &t );
    return( t );
}

double start[64], elapsed[64];

/*****************************************************************/
/******            T  I  M  E  R  _  C  L  E  A  R          ******/
/*****************************************************************/
void timer_clear( int n )
{
    elapsed[n] = 0.0;
}

/*****************************************************************/
/******            T  I  M  E  R  _  S  T  A  R  T          ******/
/*****************************************************************/
void timer_start( int n )
{
    start[n] = elapsed_time();
}
/*****************************************************************/
/******            T  I  M  E  R  _  S  T  O  P             ******/
/*****************************************************************/
void timer_stop( int n )
{
    double t, now;
    now = elapsed_time();
    t = now - start[n];
    elapsed[n] += t;
}

/*****************************************************************/
/******            T  I  M  E  R  _  R  E  A  D             ******/
/*****************************************************************/
double timer_read( int n )
{
    return( elapsed[n] );
}


void print_matrix(double * data, int dim1, int dim2){
  int i, j;
  for ( i=0; i< dim1; i++){
    for ( j=0; j<dim2; j++){
      printf("%.1f ", data[dim2*i+j]);
    }
    printf("\n");
  }
  printf("\n");
}

/*void verify_result(const double *a, const double *b, double *result, int m, int k, int n){

  double alpha = 1.0;
  double beta = 1.0;    
  int lda = m;
  int ldb = k;
  int ldc = n;
  int i, j;
  double result1=0;
  double result2=0;
  double *c = (double*)malloc(sizeof(double)*m*n);

  for(i = 0; i< m*n; i++){
    c[i]=0.0;
  }
  cblas_dgemm (CblasRowMajor, CblasNoTrans, CblasNoTrans, m, n, k, alpha, a, lda, b, ldb, beta, c, ldc);
  for (i = 0; i< m; i++){
    result1 = 0.0;
    result2 = 0.0;
    for (j = 0; j < n; j++){
      result1 += result[i*n+j];
      result2 += c[i*n+j];
    }
    if((1-result2/result1)>1e-6 || (1-result2/result1)<-1e-6){
      printf("Verification failed in row %d. \n", i);
      printf("n: %d result: %f, standard: %f\n", n, result1, result2);
      return;
    }
  }
  printf("Verification passed. \n");
  free(c);
}

  */   

#endif //__UTILITY_H__
