struct JacuButs
{      
  void operator() (   HTA_2H v, 
		      HTA_2H u)
  {    
    double tmat[5][5];
    double tv[5];
    double tmp1, tmp, tmp2, tmp3;
   
 
    int step_u_0 = u.memMap().linearStep()[0];
    int step_u_1 = u.memMap().linearStep()[1];
    int step_u_2 = u.memMap().linearStep()[2];
    int step_u_3 = u.memMap().linearStep()[3];

    int step_v_0 = v.memMap().linearStep()[0];
    int step_v_1 = v.memMap().linearStep()[1];
    int step_v_2 = v.memMap().linearStep()[2];
    int step_v_3 = v.memMap().linearStep()[3];

    Tuple<4> size = v.shape().size();


    double a[5][5];
    double b[5][5];
    double c[5][5];
    double d[5][5];
    for (int i = size[0] - 3; i > 1; i--)
      for (int j = size[1] - 3; j > 1; j--)
	for (int k = size[2] - 3; k > 1; k--)
	  {
	   
	    tmp1 = 1.0 /  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (0)];
	    tmp2 = tmp1 * tmp1;
	    tmp3 = tmp1 * tmp2;

	    d[0][0] =  1.0
	      + dt * 2.0 * (   tx1 * dx1
			       + ty1 * dy1
			       + tz1 * dz1 );
	    d[0][1] =  0.0;
	    d[0][2] =  0.0;
	    d[0][3] =  0.0;
	    d[0][4] =  0.0;

	    d[1][0] =  dt * 2.0
	      * (  tx1 * ( - r43 * c34 * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)] )
		   + ty1 * ( -       c34 * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)] )
		   + tz1 * ( -       c34 * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)] ) );
	    d[1][1] =  1.0
	      + dt * 2.0 
	      * (  tx1 * r43 * c34 * tmp1
		   + ty1 *       c34 * tmp1
		   + tz1 *       c34 * tmp1 )
	      + dt * 2.0 * (   tx1 * dx2
			       + ty1 * dy2
			       + tz1 * dz2  );
	    d[1][2] = 0.0;
	    d[1][3] = 0.0;
	    d[1][4] = 0.0;

	    d[2][0] = dt * 2.0
	      * (  tx1 * ( -       c34 * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)] )
		   + ty1 * ( - r43 * c34 * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)] )
		   + tz1 * ( -       c34 * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)] ) );
	    d[2][1] = 0.0;
	    d[2][2] = 1.0
	      + dt * 2.0
	      * (  tx1 *       c34 * tmp1
		   + ty1 * r43 * c34 * tmp1
		   + tz1 *       c34 * tmp1 )
	      + dt * 2.0 * (  tx1 * dx3
			      + ty1 * dy3
			      + tz1 * dz3 );
	    d[2][3] = 0.0;
	    d[2][4] = 0.0;

	    d[3][0] = dt * 2.0
	      * (  tx1 * ( -       c34 * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)] )
		   + ty1 * ( -       c34 * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)] )
		   + tz1 * ( - r43 * c34 * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)] ) );
	    d[3][1] = 0.0;
	    d[3][2] = 0.0;
	    d[3][3] = 1.0
	      + dt * 2.0
	      * (  tx1 *       c34 * tmp1
		   + ty1 *       c34 * tmp1
		   + tz1 * r43 * c34 * tmp1 )
	      + dt * 2.0 * (  tx1 * dx4
			      + ty1 * dy4
			      + tz1 * dz4 );
	    d[3][4] = 0.0;

	    d[4][0] = dt * 2.0
	      * ( tx1 * ( - ( r43*c34 - c1345 ) * tmp3 * ( pow2( 
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)]) )
			  - ( c34 - c1345 ) * tmp3 * ( pow2( 
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)]) )
			  - ( c34 - c1345 ) * tmp3 * ( pow2( 
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)]) )
			  - ( c1345 ) * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (4)] )
		  + ty1 * ( - ( c34 - c1345 ) * tmp3 * ( pow2( 
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)]) )
			    - ( r43*c34 - c1345 ) * tmp3 * ( pow2( 
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)]) )
			    - ( c34 - c1345 ) * tmp3 * ( pow2( 
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)]) )
			    - ( c1345 ) * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (4)] )
		  + tz1 * ( - ( c34 - c1345 ) * tmp3 * ( pow2( 
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)]) )
			    - ( c34 - c1345 ) * tmp3 * ( pow2( 
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)]) )
			    - ( r43*c34 - c1345 ) * tmp3 * ( pow2( 
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)]) )
			    - ( c1345 ) * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (4)] ) );
	    d[4][1] = dt * 2.0
	      * ( tx1 * ( r43*c34 - c1345 ) * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)]
		  + ty1 * (     c34 - c1345 ) * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)]
		  + tz1 * (     c34 - c1345 ) * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)] );
	    d[4][2] = dt * 2.0
	      * ( tx1 * ( c34 - c1345 ) * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)]
		  + ty1 * ( r43*c34 -c1345 ) * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)]
		  + tz1 * ( c34 - c1345 ) * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)] );
	    d[4][3] = dt * 2.0
	      * ( tx1 * ( c34 - c1345 ) * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)]
		  + ty1 * ( c34 - c1345 ) * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)]
		  + tz1 * ( r43*c34 - c1345 ) * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)] );
	    d[4][4] = 1.0
	      + dt * 2.0 * ( tx1 * c1345 * tmp1
			     + ty1 * c1345 * tmp1
			     + tz1 * c1345 * tmp1 )
	      + dt * 2.0 * (  tx1 * dx5
			      +  ty1 * dy5
			      +  tz1 * dz5 );
  
    
	    tmp1 = 1.0 /  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (0)];
	    tmp2 = tmp1 * tmp1;
	    tmp3 = tmp1 * tmp2;
    
	    a[0][0] = - dt * tx1 * dx1;
	    a[0][1] =   dt * tx2;
	    a[0][2] =   0.0;
	    a[0][3] =   0.0;
	    a[0][4] =   0.0;
    
	    a[1][0] =  dt * tx2
	      * ( - (  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)] * tmp1 ) *(  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)] * tmp1 )
		  + C2 * 0.50 * (   
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)] *  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)]
				   +  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)] *  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)]
				   +  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)] *  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)] ) * tmp2 )
	      - dt * tx1 * ( - r43 * c34 * tmp2 *  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)] );
	    a[1][1] =  dt * tx2
	      * ( ( 2.0 - C2 ) * (  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)] * tmp1 ) )
	      - dt * tx1 * ( r43 * c34 * tmp1 )
	      - dt * tx1 * dx2;
	    a[1][2] =  dt * tx2
	      * ( - C2 * (  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)] * tmp1 ) );
	    a[1][3] =  dt * tx2
	      * ( - C2 * (  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)] * tmp1 ) );
	    a[1][4] =  dt * tx2 * C2 ;
    
	    a[2][0] =  dt * tx2
	      * ( - (  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)] *  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)] ) * tmp2 )
	      - dt * tx1 * ( - c34 * tmp2 *  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)] );
	    a[2][1] =  dt * tx2 * (  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)] * tmp1 );
	    a[2][2] =  dt * tx2 * (  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)] * tmp1 )
	      - dt * tx1 * ( c34 * tmp1 )
	      - dt * tx1 * dx3;
	    a[2][3] = 0.0;
	    a[2][4] = 0.0;
    
	    a[3][0] = dt * tx2
	      * ( - (  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)]* 
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)] ) * tmp2 )
	      - dt * tx1 * ( - c34 * tmp2 *  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)] );
	    a[3][1] = dt * tx2 * (  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)] * tmp1 );
	    a[3][2] = 0.0;
	    a[3][3] = dt * tx2 * (  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)] * tmp1 )
	      - dt * tx1 * ( c34 * tmp1 )
	      - dt * tx1 * dx4;
	    a[3][4] = 0.0;
    
	    a[4][0] = dt * tx2
	      * ( ( C2 * (   
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)] *  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)]
			    +  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)] *  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)]
			    +  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)] *  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)] ) * tmp2
		    - C1 * (  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (4)] * tmp1 ) )
		  * (  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)] * tmp1 ) )
	      - dt * tx1
	      * ( - ( r43*c34 - c1345 ) * tmp3 * ( pow2( 
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)]) )
		  - (     c34 - c1345 ) * tmp3 * ( pow2( 
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)]) )
		  - (     c34 - c1345 ) * tmp3 * ( pow2( 
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)]) )
		  - c1345 * tmp2 *  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (4)] );
	    a[4][1] = dt * tx2
	      * ( C1 * (  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (4)] * tmp1 )
		  - 0.50 * C2
		  * ( (  3.0* 
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)]* 
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)]
			 +  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)]* 
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)]
			 +  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)]* 
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)] ) * tmp2 ) )
	      - dt * tx1
	      * ( r43*c34 - c1345 ) * tmp2 *  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)];
	    a[4][2] = dt * tx2
	      * ( - C2 * (  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)]* 
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)] ) * tmp2 )
	      - dt * tx1
	      * (  c34 - c1345 ) * tmp2 *  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (2)];
	    a[4][3] = dt * tx2
	      * ( - C2 * (  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)]* 
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)] ) * tmp2 )
	      - dt * tx1
	      * (  c34 - c1345 ) * tmp2 *  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (3)];
	    a[4][4] = dt * tx2
	      * ( C1 * (  
                u[(i+1) * step_u_0 + (j) * step_u_1 + (k) * step_u_2 + (1)] * tmp1 ) )
	      - dt * tx1 * c1345 * tmp1
	      - dt * tx1 * dx5;

    
	    tmp1 = 1.0 /  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (0)];
	    tmp2 = tmp1 * tmp1;
	    tmp3 = tmp1 * tmp2;

	    b[0][0] = - dt * ty1 * dy1;
	    b[0][1] =   0.0;
	    b[0][2] =  dt * ty2;
	    b[0][3] =   0.0;
	    b[0][4] =   0.0;

	    b[1][0] =  dt * ty2
	      * ( - (  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (1)]* 
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)] ) * tmp2 )
	      - dt * ty1 * ( - c34 * tmp2 *  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (1)] );
	    b[1][1] =  dt * ty2 * (  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)] * tmp1 )
	      - dt * ty1 * ( c34 * tmp1 )
	      - dt * ty1 * dy2;
	    b[1][2] =  dt * ty2 * (  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (1)] * tmp1 );
	    b[1][3] = 0.0;
	    b[1][4] = 0.0;

	    b[2][0] =  dt * ty2
	      * ( - (  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)] * tmp1 ) *(  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)] * tmp1 )
		  + 0.50 * C2 * ( (   
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (1)] *  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (1)]
				     +  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)] *  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)]
				     +  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (3)] *  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (3)] )
				  * tmp2 ) )
	      - dt * ty1 * ( - r43 * c34 * tmp2 *  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)] );
	    b[2][1] =  dt * ty2
	      * ( - C2 * (  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (1)] * tmp1 ) );
	    b[2][2] =  dt * ty2 * ( ( 2.0 - C2 )
					  * (  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)] * tmp1 ) )
	      - dt * ty1 * ( r43 * c34 * tmp1 )
	      - dt * ty1 * dy3;
	    b[2][3] =  dt * ty2
	      * ( - C2 * (  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (3)] * tmp1 ) );
	    b[2][4] =  dt * ty2 * C2;

	    b[3][0] =  dt * ty2
	      * ( - (  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)]* 
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (3)] ) * tmp2 )
	      - dt * ty1 * ( - c34 * tmp2 *  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (3)] );
	    b[3][1] = 0.0;
	    b[3][2] =  dt * ty2 * (  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (3)] * tmp1 );
	    b[3][3] =  dt * ty2 * (  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)] * tmp1 )
	      - dt * ty1 * ( c34 * tmp1 )
	      - dt * ty1 * dy4;
	    b[3][4] = 0.0;

	    b[4][0] =  dt * ty2
	      * ( ( C2 * (   
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (1)] *  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (1)]
			    +  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)] *  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)]
			    +  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (3)] *  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (3)] ) * tmp2
		    - C1 * (  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (4)] * tmp1 ) )
		  * (  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)] * tmp1 ) )
	      - dt * ty1
	      * ( - (     c34 - c1345 )*tmp3*( pow2( 
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (1)]) )
		  - ( r43*c34 - c1345 )*tmp3*( pow2( 
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)]) )
		  - (     c34 - c1345 )*tmp3*( pow2( 
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (3)]) )
		  - c1345*tmp2* 
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (4)] );
	    b[4][1] =  dt * ty2
	      * ( - C2 * (  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (1)]* 
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)] ) * tmp2 )
	      - dt * ty1
	      * ( c34 - c1345 ) * tmp2 *  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (1)];
	    b[4][2] =  dt * ty2
	      * ( C1 * (  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (4)] * tmp1 )
		  - 0.50 * C2 
		  * ( (   
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (1)]* 
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (1)]
			 + 3.0 *  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)]* 
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)]
			 +  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (3)]* 
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (3)] ) * tmp2 ) )
	      - dt * ty1
	      * ( r43*c34 - c1345 ) * tmp2 *  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)];
	    b[4][3] =  dt * ty2
	      * ( - C2 * (  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)]* 
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (3)] ) * tmp2 )
	      - dt * ty1 * ( c34 - c1345 ) * tmp2 *  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (3)];
	    b[4][4] =  dt * ty2
	      * ( C1 * (  
                u[(i) * step_u_0 + (j+1) * step_u_1 + (k) * step_u_2 + (2)] * tmp1 ) )
	      - dt * ty1 * c1345 * tmp1
	      - dt * ty1 * dy5;
    
	    tmp1 = 1.0 /  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (0)];
	    tmp2 = tmp1 * tmp1;
	    tmp3 = tmp1 * tmp2;
    
	    c[0][0] = - dt * tz1 * dz1;
	    c[0][1] =   0.0;
	    c[0][2] =   0.0;
	    c[0][3] = dt * tz2;
	    c[0][4] =   0.0;
    
	    c[1][0] = dt * tz2
	      * ( - (  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (1)]* 
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)] ) * tmp2 )
	      - dt * tz1 * ( - c34 * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (1)] );
	    c[1][1] = dt * tz2 * (  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)] * tmp1 )
	      - dt * tz1 * c34 * tmp1
	      - dt * tz1 * dz2 ;
	    c[1][2] = 0.0;
	    c[1][3] = dt * tz2 * (  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (1)] * tmp1 );
	    c[1][4] = 0.0;

	    c[2][0] = dt * tz2
	      * ( - (  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (2)]* 
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)] ) * tmp2 )
	      - dt * tz1 * ( - c34 * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (2)] );
	    c[2][1] = 0.0;
	    c[2][2] = dt * tz2 * (  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)] * tmp1 )
	      - dt * tz1 * ( c34 * tmp1 )
	      - dt * tz1 * dz3;
	    c[2][3] = dt * tz2 * (  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (2)] * tmp1 );
	    c[2][4] = 0.0;

	    c[3][0] = dt * tz2
	      * ( - (  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)] * tmp1 ) *(  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)] * tmp1 )
		  + 0.50 * C2
		  * ( (  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (1)] *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (1)]
			+  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (2)] *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (2)]
			+  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)] *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)] ) * tmp2 ) )
	      - dt * tz1 * ( - r43 * c34 * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)] );
	    c[3][1] = dt * tz2
	      * ( - C2 * (  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (1)] * tmp1 ) );
	    c[3][2] = dt * tz2
	      * ( - C2 * (  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (2)] * tmp1 ) );
	    c[3][3] = dt * tz2 * ( 2.0 - C2 )
	      * (  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)] * tmp1 )
	      - dt * tz1 * ( r43 * c34 * tmp1 )
	      - dt * tz1 * dz4;
	    c[3][4] = dt * tz2 * C2;

	    c[4][0] = dt * tz2
	      * ( ( C2 * (   
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (1)] *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (1)]
			    +  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (2)] *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (2)]
			    +  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)] *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)] ) * tmp2
		    - C1 * (  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (4)] * tmp1 ) )
		  * (  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)] * tmp1 ) )
	      - dt * tz1
	      * ( - ( c34 - c1345 ) * tmp3 * ( pow2( 
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (1)]) )
		  - ( c34 - c1345 ) * tmp3 * ( pow2( 
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (2)]) )
		  - ( r43*c34 - c1345 )* tmp3 * ( pow2( 
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)]) )
		  - c1345 * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (4)] );
	    c[4][1] = dt * tz2
	      * ( - C2 * (  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (1)]* 
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)] ) * tmp2 )
	      - dt * tz1 * ( c34 - c1345 ) * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (1)];
	    c[4][2] = dt * tz2
	      * ( - C2 * (  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (2)]* 
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)] ) * tmp2 )
	      - dt * tz1 * ( c34 - c1345 ) * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (2)];
	    c[4][3] = dt * tz2
	      * ( C1 * (  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (4)] * tmp1 )
		  - 0.50 * C2
		  * ( (   
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (1)]* 
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (1)]
			 +  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (2)]* 
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (2)]
			 + 3.0* 
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)]* 
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)] ) * tmp2 ) )
	      - dt * tz1 * ( r43*c34 - c1345 ) * tmp2 *  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)];
	    c[4][4] = dt * tz2
	      * ( C1 * (  
                u[(i) * step_u_0 + (j) * step_u_1 + (k+1) * step_u_2 + (3)] * tmp1 ) )
	      - dt * tz1 * c1345 * tmp1
	      - dt * tz1 * dz5;
  	   
	    double sum[5] ;
	    for (int m = 0; m < 5; m++)
	      {
		sum[m] = 0 ;
		for (int n = 0 ; n < 5; n++)
		  sum[m] +=  (c[m][n] *  
                v[(i) * step_v_0 + (j) * step_v_1 + (k+1) * step_v_2 + (n)] + 
			      b[m][n] *  
                v[(i) * step_v_0 + (j+1) * step_v_1 + (k) * step_v_2 + (n)] + 
			      a[m][n] *  
                v[(i+1) * step_v_0 + (j) * step_v_1 + (k) * step_v_2 + (n)]);
	      }
	    
	    for (int m = 0; m < 5; m++)
	      {
		tv[m] = sum[m] * omega;
	      }
	    
	    for (int m = 0; m < 5; m++) 
	      {
		tmat[m][0] = d[m][0];
		tmat[m][1] = d[m][1];
		tmat[m][2] = d[m][2];
		tmat[m][3] = d[m][3];
		tmat[m][4] = d[m][4];	
	      }
	    
	    tmp1 = 1.0 / tmat[0][0];
	    tmp = tmp1 * tmat[1][0];
	    tmat[1][1] =  tmat[1][1]
	      - tmp * tmat[0][1];
	    tmat[1][2] =  tmat[1][2]
	      - tmp * tmat[0][2];
	    tmat[1][3] =  tmat[1][3]
	      - tmp * tmat[0][3];
	    tmat[1][4] =  tmat[1][4]
	      - tmp * tmat[0][4];
	    tv[1] = tv[1]
		  - tv[0] * tmp;
	    
	    tmp = tmp1 * tmat[2][0];
	    tmat[2][1] =  tmat[2][1]
	      - tmp * tmat[0][1];
	    tmat[2][2] =  tmat[2][2]
	  - tmp * tmat[0][2];
	    tmat[2][3] =  tmat[2][3]
	      - tmp * tmat[0][3];
	    tmat[2][4] =  tmat[2][4]
	      - tmp * tmat[0][4];
	    tv[2] = tv[2]
	      - tv[0] * tmp;
	    
	    tmp = tmp1 * tmat[3][0];
	    tmat[3][1] =  tmat[3][1]
	      - tmp * tmat[0][1];
	    tmat[3][2] =  tmat[3][2]
	      - tmp * tmat[0][2];
	    tmat[3][3] =  tmat[3][3]
	      - tmp * tmat[0][3];
	    tmat[3][4] =  tmat[3][4]
	  - tmp * tmat[0][4];
	    tv[3] = tv[3]
	      - tv[0] * tmp;
	    
	    tmp = tmp1 * tmat[4][0];
	    tmat[4][1] =  tmat[4][1]
	      - tmp * tmat[0][1];
	    tmat[4][2] =  tmat[4][2]
	  - tmp * tmat[0][2];
	    tmat[4][3] =  tmat[4][3]
	      - tmp * tmat[0][3];
	    tmat[4][4] =  tmat[4][4]
	      - tmp * tmat[0][4];
	    tv[4] = tv[4]
	      - tv[0] * tmp;

	    tmp1 = 1.0 / tmat[1][1];
	    tmp = tmp1 * tmat[2][1];
	    tmat[2][2] =  tmat[2][2]
	      - tmp * tmat[1][2];
	    tmat[2][3] =  tmat[2][3]
	      - tmp * tmat[1][3];
	    tmat[2][4] =  tmat[2][4]
	  - tmp * tmat[1][4];
	    tv[2] = tv[2]
	      - tv[1] * tmp;
	    
	    tmp = tmp1 * tmat[3][1];
	    tmat[3][2] =  tmat[3][2]
	      - tmp * tmat[1][2];
	    tmat[3][3] =  tmat[3][3]
	      - tmp * tmat[1][3];
	    tmat[3][4] =  tmat[3][4]
	      - tmp * tmat[1][4];
	    tv[3] = tv[3]
	      - tv[1] * tmp;
	    
	    tmp = tmp1 * tmat[4][1];
	    tmat[4][2] =  tmat[4][2]
	      - tmp * tmat[1][2];
	    tmat[4][3] =  tmat[4][3]
	      - tmp * tmat[1][3];
	    tmat[4][4] =  tmat[4][4]
	      - tmp * tmat[1][4];
	    tv[4] = tv[4]
	      - tv[1] * tmp;
	    
	    tmp1 = 1.0 / tmat[2][2];
	    tmp = tmp1 * tmat[3][2];
	    tmat[3][3] =  tmat[3][3]
	      - tmp * tmat[2][3];
	    tmat[3][4] =  tmat[3][4]
	      - tmp * tmat[2][4];
	    tv[3] = tv[3]
	      - tv[2] * tmp;
	    
	    tmp = tmp1 * tmat[4][2];
	    tmat[4][3] =  tmat[4][3]
	      - tmp * tmat[2][3];
	    tmat[4][4] =  tmat[4][4]
	      - tmp * tmat[2][4];
	    tv[4] = tv[4]
	      - tv[2] * tmp;
	    
	    tmp1 = 1.0 / tmat[3][3];
	    tmp = tmp1 * tmat[4][3];
	    tmat[4][4] =  tmat[4][4]
	      - tmp * tmat[3][4];
	    tv[4] = tv[4]
	      - tv[3] * tmp;
	    
	    /*--------------------------------------------------------------------
	      c   back substitution
	      --------------------------------------------------------------------*/
	    tv[4] = tv[4]
	      / tmat[4][4];
	    
	    tv[3] = tv[3]
	      - tmat[3][4] * tv[4];
	    tv[3] = tv[3]
	      / tmat[3][3];

	    tv[2] = tv[2]
	      - tmat[2][3] * tv[3]
	      - tmat[2][4] * tv[4];
	    tv[2] = tv[2]
	      / tmat[2][2];
	    
	    tv[1] = tv[1]
	      - tmat[1][2] * tv[2]
	      - tmat[1][3] * tv[3]
	      - tmat[1][4] * tv[4];
	    tv[1] = tv[1]
	      / tmat[1][1];
	    
	    tv[0] = tv[0]
	      - tmat[0][1] * tv[1]
	      - tmat[0][2] * tv[2]
	      - tmat[0][3] * tv[3]
	      - tmat[0][4] * tv[4];
	    tv[0] = tv[0]
	      / tmat[0][0];
	    
	     
                v[(i) * step_v_0 + (j) * step_v_1 + (k) * step_v_2 + (0)] =  
                v[(i) * step_v_0 + (j) * step_v_1 + (k) * step_v_2 + (0)] - tv[0];
	     
                v[(i) * step_v_0 + (j) * step_v_1 + (k) * step_v_2 + (1)] =  
                v[(i) * step_v_0 + (j) * step_v_1 + (k) * step_v_2 + (1)] - tv[1];
	     
                v[(i) * step_v_0 + (j) * step_v_1 + (k) * step_v_2 + (2)] =  
                v[(i) * step_v_0 + (j) * step_v_1 + (k) * step_v_2 + (2)] - tv[2];
	     
                v[(i) * step_v_0 + (j) * step_v_1 + (k) * step_v_2 + (3)] =  
                v[(i) * step_v_0 + (j) * step_v_1 + (k) * step_v_2 + (3)] - tv[3];
	     
                v[(i) * step_v_0 + (j) * step_v_1 + (k) * step_v_2 + (4)] =  
                v[(i) * step_v_0 + (j) * step_v_1 + (k) * step_v_2 + (4)] - tv[4];
	    
	    //cout << "end of map " << v << " " << tv[0] << endl;
	  }  
  }
};

