#include "lu.h"
#include "applu.h"
#include "ShapeH.h"
#include "MapReduceHTA.h"

double  r43;
double  c1345;
double  c34;


typedef HTA<double, 4> HTA_2H;

typedef Triplet R;
typedef Tuple<4> T;

ShapeH<4> iShape;

ShapeH<4> iShapeB;
ShapeH<4> iShapeE;
ShapeH<4> iShapeS;

ShapeH<4> iShapeF;
ShapeH<4> iShapeW;
ShapeH<4> iShapeN;


int isiz1;
int isiz2;
int isiz3;

int np1;
int np2;
int np3;
/*--------------------------------------------------------------------
  c   xi-direction flux differences
  --------------------------------------------------------------------*/

struct Xi    
{
  void operator() (HTA_2H rsd,
		   HTA_2H flux,
		   HTA_2H frct)
  {          
    int step_frct_0 = frct.memMap().linearStep()[0];
    int step_frct_1 = frct.memMap().linearStep()[1];
    int step_frct_2 = frct.memMap().linearStep()[2];
    int step_frct_3 = frct.memMap().linearStep()[3];

    int step_flux_0 = flux.memMap().linearStep()[0];
    int step_flux_1 = flux.memMap().linearStep()[1];
    int step_flux_2 = flux.memMap().linearStep()[2];
    int step_flux_3 = flux.memMap().linearStep()[3];

    int step_rsd_0 = rsd.memMap().linearStep()[0];
    int step_rsd_1 = rsd.memMap().linearStep()[1];
    int step_rsd_2 = rsd.memMap().linearStep()[2];
    int step_rsd_3 = rsd.memMap().linearStep()[3];

    Tuple<4> pos = rsd.memMap().leafPos();
    Tuple<4> size = rsd.shape().size();  
 
   //cout << "Hello " << size[0] << " " << size[1] << " " << size[2] << endl;
   
    for (int i = 1; i < size[0]  - 1; i++)
      for (int j = 2; j < size[1]  - 2; j++)
	for (int k = 2; k < size[2]  - 2; k++)
	  {
	     
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (0)] =  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)];
	    double u21 =  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)] /  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (0)];
	    double q = 0.50 * ( 
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)] *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)]
			     +  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)] *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)]
			     +  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)] *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)])
	      /  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (0)];
	     
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (1)] =  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)] * u21 + C2 * 
	      ( 
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (4)] - q);
	     
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (2)] =  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)] * u21;
	     
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (3)] =  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)] * u21;
	     
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (4)] = (C1 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (4)] - C2 * q) * u21; 	 
	  }      
    
    //    return;

    for (int i = 2; i < size[0]  - 2; i++)
      for (int j = 2; j < size[1]  - 2; j++)
	for (int k = 2; k < size[2]  - 2; k++)
	  {	    
	    for (int m = 0; m < 5; m++)
	       
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (m)] =   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (m)] -  tx2 * ( 
                flux[(i+1) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (m)] -  
                flux[(i-1) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (m)]);  
	  }
    
    for (int i = 2; i < size[0]  - 1; i++)
      for (int j = 2; j < size[1]  - 2; j++)
	for (int k = 2; k < size[2]  - 2; k++)
	  {
	    
	    double tmp =  1.0 /  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (0)];
	    double u21i = tmp *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)];
	    double u31i = tmp *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)];
	    double u41i = tmp *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)];
	    double u51i = tmp *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (4)];
	    
	    tmp = 1.0 /  
                rsd[(i-1) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (0)];
	    double u21im1 = tmp *  
                rsd[(i-1) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)];
	    double u31im1 = tmp *  
                rsd[(i-1) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)];
	    double u41im1 = tmp *  
                rsd[(i-1) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)];
	    double u51im1 = tmp *  
                rsd[(i-1) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (4)];
	    
	     
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (1)] = (4.0/3.0) * tx3 *  ( u21i - u21im1 );
	     
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (2)] = tx3 * ( u31i - u31im1 );
	     
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (3)] = tx3 * ( u41i - u41im1 );
	     
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (4)] = 0.50 * ( 1.0 - C1*C5 )
	      * tx3 * ( ( u21i * u21i + u31i * u31i + u41i * u41i )
			- ( u21im1*u21im1 + u31im1*u31im1 + u41im1*u41im1 ) )
	      + (1.0/6.0) * tx3 * ( u21i*u21i - u21im1*u21im1 )
	      + C1 * C5 * tx3 * ( u51i - u51im1 ); 	
	  }     
    
    for (int i = 2; i < size[0]  - 2; i++)
      for (int j = 2; j < size[1]  - 2; j++)
	for (int k = 2; k < size[2] - 2; k++)
	  {	  	    
	     
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (0)] =   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (0)]
	      + tx1  * dx1 * ( 
                rsd[(i-1) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (0)]
			      - 2.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (0)]
			      +       	     
                rsd[(i+1) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (0)]);    
	     
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (1)] =  
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (1)]
	      + tx3 * C3 * C4 * (  
                flux[(i+1) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (1)] -  
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (1)])
	      + dx2 * tx1 * (             
                rsd[(i-1) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)]
					 - 2.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)]
					 +            
                rsd[(i+1) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)]) ;    
	     
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (2)] =   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (2)]
	      + tx3 * C3 * C4 * (  
                flux[(i+1) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (2)] -  
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (2)] )
	      + dx3 * tx1 * (             
                rsd[(i-1) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)]
					 - 2.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)]
					 +            
                rsd[(i+1) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)]);    
	     
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (3)] =   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (3)]
	      + tx3 * C3 * C4 * (  
                flux[(i+1) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (3)] -  
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (3)] )
	      + dx4 * tx1 * (             
                rsd[(i-1) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)]
					 - 2.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)]
					 +            
                rsd[(i+1) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)]);    
	     
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (4)] = 
	       
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (4)]
	      + tx3 * C3 * C4 * (  
                flux[(i+1) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (4)] -  
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (4)] )
	      + dx5 * tx1 * (             
                rsd[(i-1) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (4)]
					 - 2.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (4)]
					 +            
                rsd[(i+1) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (4)]);
	  }
    


    if (pos[0] == 1)
      {
	for (int j = 2; j < size[1]  - 2; j++)
	  for (int k = 2; k < size[2]  - 2; k++)
	    {
	      
	      for (int m = 0; m < 5; m++) {
		 
                frct[(2) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (m)] =  
                frct[(2) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (m)] - 
		  dssp * (
			  + 5.0 *  
                rsd[(2) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (m)]
			  - 4.0 *  
                rsd[(3) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (m)]
			  +  
                rsd[(4) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (m)]);  
		
		 
                frct[(3) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (m)] =  
                frct[(3) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (m)] - 
		  dssp * (
			  - 4.0 *  
                rsd[(2) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (m)]
			  + 6.0 *  
                rsd[(3) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (m)]
			  - 4.0 *  
                rsd[(4) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (m)]
			  +  
                rsd[(5) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (m)]);  
	      }
	    }
      }
    
    int ist1 = 2;
    int iend1 = size[0] - 2;
    
    if (pos[0] == 1) ist1 += 2;

    // cout << "Yes " << pos[0] + size[0] << " " << GX << endl;

    Tuple<4> tmp = pos / Tuple<4>(isiz1, isiz2, isiz3, 1);
    if (tmp[0] == np1 - 1)  { iend1 -= 2;} 
    //if (pos[0] + size[0] == GX + reminder_x -1)  { iend1 -= 2;} 
    
    for (int i = ist1; i < iend1  ; i++)
      for (int j = 2; j < size[1]  - 2; j++)
	for (int k = 2; k < size[2]  - 2; k++)
	  {
	    
	    for (int m = 0; m < 5; m++)
	       
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (m)] =  
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (m)] - dssp * ( 
                rsd[(i-2) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (m)]
								  - 4.0 *  
                rsd[(i-1) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (m)]
								  + 6.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (m)]
								  - 4.0 *  
                rsd[(i+1) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (m)]
								  +  
                rsd[(i+2) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (m)]);  
	  }
    
     if (tmp[0] == np1 - 1)       
     //if (pos[0] + size[0] == GX + reminder_x -1)       
       {
	 for (int j = 2; j < size[1]  - 2; j++)
	   for (int k = 2; k < size[2]  - 2; k++)
	     {
	       for (int m = 0; m < 5; m++)
		 frct[T(size[0]-4, j, k, m)] = 
		   frct[T(size[0]-4, j, k, m)] - 
		   dssp * (rsd[T(size[0]-6, j, k, m)]
			   - 4.0 * rsd[T(size[0]-5, j, k, m)]
			   + 6.0 * rsd[T(size[0]-4, j, k, m)]
			   - 4.0 * rsd[T(size[0]-3, j, k, m)]);		
	       
	       for (int m = 0; m < 5; m++)
		 frct[T(size[0]-3, j, k, m)] = frct[T(size[0]-3, j, k, m)] - 
		   dssp * (rsd[T(size[0]-5, j, k, m)]
			   - 4.0 * rsd[T(size[0]-4, j, k, m)]
			   + 5.0 * rsd[T(size[0]-3, j, k, m)]);
	     }
	 
       }
     
  }

};

void erhs1 (HTA_2H rsdInner,
	    HTA_2H frctInner,
	    HTA_2H fluxInner,
	    HTA_2H rsd, 
	    HTA_2H frct, 
	    HTA_2H flux)
{   
 
  rsdInner.hmap(Xi(),
		fluxInner,
		frctInner,
		0);

}

struct Eta{
           
  void operator() (HTA_2H rsd, 
		    HTA_2H flux,
		    HTA_2H frct)
  {  
    int step_frct_0 = frct.memMap().linearStep()[0];
    int step_frct_1 = frct.memMap().linearStep()[1];
    int step_frct_2 = frct.memMap().linearStep()[2];
    int step_frct_3 = frct.memMap().linearStep()[3];

    int step_flux_0 = flux.memMap().linearStep()[0];
    int step_flux_1 = flux.memMap().linearStep()[1];
    int step_flux_2 = flux.memMap().linearStep()[2];
    int step_flux_3 = flux.memMap().linearStep()[3];

    int step_rsd_0 = rsd.memMap().linearStep()[0];
    int step_rsd_1 = rsd.memMap().linearStep()[1];
    int step_rsd_2 = rsd.memMap().linearStep()[2];
    int step_rsd_3 = rsd.memMap().linearStep()[3];
    Tuple<4> pos = rsd.memMap().leafPos();
    Tuple<4> size = flux.shape().size();    

    for (int i = 2; i < size[0]  - 2 ; i++)
      for (int j = 1; j < size[1]  - 1; j++)
	for (int k = 2; k < size[2]  - 2; k++) {
	   
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (0)] =  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)];
	  double u31 =  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)] /  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (0)];
	  double q = 0.50 * (   
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)] *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)]
			     +  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)] *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)]
			     +  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)] *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)] )
	    /  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (0)];
	   
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (1)] =  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)] * u31;
	   
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (2)] =  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)] * u31 + C2 * 
	    (  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (4)] - q );
	   
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (3)] =  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)] * u31;
	   
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (4)] = ( C1 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (4)] - C2 * q ) * u31;
	  assert (q != 0);
	  assert (u31 != 0);
	}

    for (int i = 2; i < size[0]  - 2; i++)
      for (int j = 2; j < size[1]  - 2; j++)
	for (int k = 2; k < size[2]  - 2; k++)
	  {
	   
	    for (int m = 0; m < 5; m++)
	       
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (m)] =   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (m)] -  tx2 * ( 
                flux[(i) * step_flux_0 + (j+1) * step_flux_1 + (k) * step_flux_2 + (m)] -  
                flux[(i) * step_flux_0 + (j-1) * step_flux_1 + (k) * step_flux_2 + (m)]);  
	  }
    
    for (int i = 2; i < size[0]  - 2; i++)
      for (int j = 2; j < size[1]  - 1; j++)
	for (int k = 2; k < size[2]  - 2; k++) {
	  
  
	  double tmp =  1.0 /  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (0)];
	  double u21j = tmp *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)];
	  double u31j = tmp *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)];
	  double u41j = tmp *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)];
	  double u51j = tmp *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (4)];
	  
	  tmp = 1.0 /  
                rsd[(i) * step_rsd_0 + (j-1) * step_rsd_1 + (k) * step_rsd_2 + (0)];
	  double u21jm1 = tmp *  
                rsd[(i) * step_rsd_0 + (j-1) * step_rsd_1 + (k) * step_rsd_2 + (1)];
	  double u31jm1 = tmp *  
                rsd[(i) * step_rsd_0 + (j-1) * step_rsd_1 + (k) * step_rsd_2 + (2)];
	  double u41jm1 = tmp *  
                rsd[(i) * step_rsd_0 + (j-1) * step_rsd_1 + (k) * step_rsd_2 + (3)];
	  double u51jm1 = tmp *  
                rsd[(i) * step_rsd_0 + (j-1) * step_rsd_1 + (k) * step_rsd_2 + (4)];
	  
	   
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (1)] = ty3 * ( u21j - u21jm1 );
	   
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (2)] = (4.0/3.0) * ty3 *
	    ( u31j - u31jm1 );
	   
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (3)] = ty3 * ( u41j - u41jm1 );
	   
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (4)] = 0.50 * ( 1.0 - C1*C5 )
	    * ty3 * ( ( u21j * u21j + u31j * u31j + u41j * u41j )
		      - ( u21jm1*u21jm1 + u31jm1*u31jm1 + u41jm1*u41jm1 ) )
	    + (1.0/6.0) * ty3 * ( u31j*u31j - u31jm1*u31jm1 )
	    + C1 * C5 * ty3 * ( u51j - u51jm1 ); 	
	}
    
    for (int i = 2; i < size[0]  - 2; i++)
      for (int j = 2; j < size[1]  - 2; j++)
	for (int k = 2; k < size[2]  - 2; k++) {
	  
	   
	   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (0)] =   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (0)]
	    + ty1  * dy1 * ( 
                rsd[(i) * step_rsd_0 + (j-1) * step_rsd_1 + (k) * step_rsd_2 + (0)]
			    - 2.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (0)]
			    +       	     
                rsd[(i) * step_rsd_0 + (j+1) * step_rsd_1 + (k) * step_rsd_2 + (0)]);    
	   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (1)] =  
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (1)]
	    + ty3 * C3 * C4 * (  
                flux[(i) * step_flux_0 + (j+1) * step_flux_1 + (k) * step_flux_2 + (1)] -  
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (1)])
	    + dy2 * ty1 * (             
                rsd[(i) * step_rsd_0 + (j-1) * step_rsd_1 + (k) * step_rsd_2 + (1)]
				       - 2.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)]
				       +            
                rsd[(i) * step_rsd_0 + (j+1) * step_rsd_1 + (k) * step_rsd_2 + (1)]) ;    
	   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (2)] =   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (2)]
	    + ty3 * C3 * C4 * (  
                flux[(i) * step_flux_0 + (j+1) * step_flux_1 + (k) * step_flux_2 + (2)] -  
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (2)] )
	    + dy3 * ty1 * (             
                rsd[(i) * step_rsd_0 + (j-1) * step_rsd_1 + (k) * step_rsd_2 + (2)]
				       - 2.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)]
				       +            
                rsd[(i) * step_rsd_0 + (j+1) * step_rsd_1 + (k) * step_rsd_2 + (2)]);    
	   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (3)] =   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (3)]
      + ty3 * C3 * C4 * (  
                flux[(i) * step_flux_0 + (j+1) * step_flux_1 + (k) * step_flux_2 + (3)] -  
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (3)] )
	    + dy4 * ty1 * (             
                rsd[(i) * step_rsd_0 + (j-1) * step_rsd_1 + (k) * step_rsd_2 + (3)]
				       - 2.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)]
				       +            
                rsd[(i) * step_rsd_0 + (j+1) * step_rsd_1 + (k) * step_rsd_2 + (3)]);    
	   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (4)] = 
	     
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (4)]
      + ty3 * C3 * C4 * (  
                flux[(i) * step_flux_0 + (j+1) * step_flux_1 + (k) * step_flux_2 + (4)] -  
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (4)] )
	    + dy5 * ty1 * (             
                rsd[(i) * step_rsd_0 + (j-1) * step_rsd_1 + (k) * step_rsd_2 + (4)]
				       - 2.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (4)]
				       +            
                rsd[(i) * step_rsd_0 + (j+1) * step_rsd_1 + (k) * step_rsd_2 + (4)]);
	}
    
    if (pos[1] == 1)
      {
	for (int i = 2; i < size[0]  - 2; i++)
	  for (int k = 2; k < size[2]  - 2; k++)
	    {
	      
	      for (int m = 0; m < 5; m++) {
		 
                frct[(i) * step_frct_0 + (2) * step_frct_1 + (k) * step_frct_2 + (m)] =  
                frct[(i) * step_frct_0 + (2) * step_frct_1 + (k) * step_frct_2 + (m)] - 
		  dssp * (
			  + 5.0 *  
                rsd[(i) * step_rsd_0 + (2) * step_rsd_1 + (k) * step_rsd_2 + (m)]
			  - 4.0 *  
                rsd[(i) * step_rsd_0 + (3) * step_rsd_1 + (k) * step_rsd_2 + (m)]
			  +  
                rsd[(i) * step_rsd_0 + (4) * step_rsd_1 + (k) * step_rsd_2 + (m)]);  
		
		 
                frct[(i) * step_frct_0 + (3) * step_frct_1 + (k) * step_frct_2 + (m)] =  
                frct[(i) * step_frct_0 + (3) * step_frct_1 + (k) * step_frct_2 + (m)] - 
		  dssp * (
			  - 4.0 *  
                rsd[(i) * step_rsd_0 + (2) * step_rsd_1 + (k) * step_rsd_2 + (m)]
			  + 6.0 *  
                rsd[(i) * step_rsd_0 + (3) * step_rsd_1 + (k) * step_rsd_2 + (m)]
			  - 4.0 *  
                rsd[(i) * step_rsd_0 + (4) * step_rsd_1 + (k) * step_rsd_2 + (m)]
			  +  
                rsd[(i) * step_rsd_0 + (5) * step_rsd_1 + (k) * step_rsd_2 + (m)]);  
	      }
	    }
      }
    
    int jst1 = 2;
    int jend1 = size[1] - 2;
    
    if (pos[1] == 1) jst1 += 2;

    Tuple<4> tmp = pos / Tuple<4>(isiz1, isiz2, isiz3, 1);
    if (tmp[1] == np2 - 1)  { jend1 -= 2;} 
    //if (pos[1] + size[1] == GY +reminder_y -1)  { jend1 -= 2; }
    
    for (int i = 2; i < size[0]  - 2; i++)
      for (int j = jst1; j < jend1 ; j++)
	for (int k = 2; k < size[2]  - 2; k++)
	  {	    
	    for (int m = 0; m < 5; m++)
	       
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (m)] =  
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (m)] - dssp * ( 
                rsd[(i) * step_rsd_0 + (j-2) * step_rsd_1 + (k) * step_rsd_2 + (m)]
								  - 4.0 *  
                rsd[(i) * step_rsd_0 + (j-1) * step_rsd_1 + (k) * step_rsd_2 + (m)]
								  + 6.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (m)]
								  - 4.0 *  
                rsd[(i) * step_rsd_0 + (j+1) * step_rsd_1 + (k) * step_rsd_2 + (m)]
								  +  
                rsd[(i) * step_rsd_0 + (j+2) * step_rsd_1 + (k) * step_rsd_2 + (m)]);  
	  }
    
     if (tmp[1] == np2 - 1)
     //if (pos[1] + size[1] == GY + reminder_y -1)       
       {
        cout << "Yes " << tmp[1] << " " << pos[1] << endl;
	 for (int i = 2; i < size[0] - 2; i++)
	   for (int k = 2; k < size[2] - 2; k++)
	     {
	       for (int m = 0; m < 5; m++)
		 frct[T(i, size[1]-4, k, m)] = 
		   frct[T(i, size[1]-4,  k, m)] - 
		   dssp * (rsd[T(i, size[1]-6,  k, m)]
			   - 4.0 * rsd[T(i, size[1]-5,  k, m)]
			   + 6.0 * rsd[T(i, size[1]-4,  k, m)]
			   - 4.0 * rsd[T(i, size[1]-3,  k, m)]);		
	       
	       for (int m = 0; m < 5; m++)
		 frct[T(i, size[1]-3, k, m)] = frct[T(i, size[1]-3, k, m)] - 
		   dssp * (rsd[T(i, size[1]-5, k, m)]
			   - 4.0 * rsd[T(i, size[1]-4,  k, m)]
			   + 5.0 * rsd[T(i, size[1]-3,  k, m)]);
	     }
	 
       }
     
  }

};

void erhs2 (HTA_2H rsdInner, HTA_2H frctInner, HTA_2H fluxInner,
	    HTA_2H rsd, HTA_2H frct, HTA_2H flux)
{    
 
  
  rsdInner.hmap(Eta(),
		fluxInner,
		frctInner,
		0);

//   double dsspm = dssp;
  
//   int jst = 2;
//   int jend = isiz2+1;
//   int ist = 2;
//   int iend = isiz1+1;
//   int kst = 2;
//   int kend = isiz3+1;
//   int tx = rsd.shape().size()[0];
//   int ty = rsd.shape().size()[1];
//   int tz = rsd.shape().size()[2];

//   int L1 = 1;
//   int L2 = isiz2+2;
//   int sx, sy, sz;

//   ShapeH<4> shape(T(tx, ty, tz, 1));
  
//   /* loop 1 */
//   shape =  Shape<4> ((R(ist, iend), R(L1, L2),  R(kst, kend), R(0,4)));
//   sx = (iend - ist + 1)*tx;
//   sy = (L2 - L1 + 1)*ty;
//   sz = (kend - kst + 1)*tz;
//   ShapeH<4> shape1 = shape.intersect (Shape<4>((R(1, sx-2), R(1,sy-2), R(1,sz-2), R(0,4))));

//   /*--------------------------------------------------------------------
//     c   Fourth-order dissipation
//     --------------------------------------------------------------------*/    

//   //special case (I)
//   frct((R(0, tx-1), R(0, 0), R(0, tz-1), R(0, 0)))((R(ist, iend), R(3, 3), R(kst, kend), R(0, 4))).
//     hmap (Special1(),
// 	  rsd((R(0, tx-1),  R(0, 0), R(0, tz-1), R(0, 0)))((R(ist, iend),  R(3, 3), R(kst, kend), R(0, 4))),
// 	  rsd((R(0, tx-1), R(0, 0), R(0, tz-1), R(0, 0)))((R(ist, iend), R(4, 4), R(kst, kend), R(0, 4))),
// 	  rsd((R(0, tx-1), R(0, 0), R(0, tz-1), R(0, 0)))((R(ist, iend), R(5, 5), R(kst, kend), R(0, 4))),
// 	  0);
  
//   //special case (II)
//   frct((R(0, tx-1), R(0, 0), R(0, tz-1), R(0, 0)))((R(ist, iend), R(4, 4), R(kst, kend), R(0, 4))).
//     hmap (Special2(),
// 	   rsd((R(0, tx-1), R(0, 0), R(0, tz-1), R(0, 0)))((R(ist, iend), R(4, 4), R(kst, kend), R(0, 4))),
// 	   rsd((R(0, tx-1),  R(0, 0), R(0, tz-1), R(0, 0)))((R(ist, iend),  R(3, 3), R(kst, kend), R(0, 4))),
// 	   rsd((R(0, tx-1), R(0, 0), R(0, tz-1), R(0, 0)))((R(ist, iend), R(5, 5), R(kst, kend), R(0, 4))),
// 	   rsd((R(0, tx-1), R(0, 0), R(0, tz-1), R(0, 0)))((R(ist, iend), R(6, 6), R(kst, kend), R(0, 4))),
// 	   0);
  
//   int jst1 = 2;
//   int jend1 = isiz2+1;
//   shape = Shape<4>((R(ist, iend), R(jst1, jend1), R(kst, kend), R(0, 4)));
//   sx = (iend - ist + 1)*tx;
//   sy = (jend1 - jst1 + 1)*ty;
//   sz = (kend - kst + 1)*tz;
//   ShapeH<4> shape5 = shape.intersect (Shape<4>((R(1, sx-2), R(3,sy-4), R(1,sz-2), R(0,4))));
//   ShapeH<4> shape5W = shape5-T(0, 1, 0, 0);
//   ShapeH<4> shape5W2 = shape5-T(0, 2, 0, 0);
//   ShapeH<4> shape5E = shape5+T(0, 1, 0, 0);
//   ShapeH<4> shape5E2 = shape5+T(0, 2, 0, 0);

//   frct()(shape5).hmap (Loop5(),
// 		       rsd()(shape5),
// 		       rsd()(shape5W),
// 		       rsd()(shape5W2),
// 		       rsd()(shape5E),
// 		       rsd()(shape5E2),
// 		       0);
  
//   frct((R(0, tx-1), R(ty-1, ty-1), R(0, tz-1), R(0, 0)))((R(ist, iend), R(isiz2-1, isiz2-1), R(kst, kend), R(0, 4))).
//     hmap (Special3(),
// 	  rsd((R(0, tx-1), R(ty-1, ty-1), R(0, tz-1), R(0, 0)))((R(ist, iend), R(isiz2-1, isiz2-1), R(kst, kend), R(0, 4))),
// 	  rsd((R(0, tx-1), R(ty-1, ty-1), R(0, tz-1), R(0, 0)))((R(ist, iend), R(isiz2-2, isiz2-2), R(kst, kend), R(0, 4))),
// 	  rsd((R(0, tx-1), R(ty-1, ty-1), R(0, tz-1), R(0, 0)))((R(ist, iend), R(isiz2-3, isiz2-3),  R(kst, kend), R(0, 4))),
// 	  rsd((R(0, tx-1), R(ty-1, ty-1), R(0, tz-1), R(0, 0)))((R(ist, iend), R(isiz2, isiz2), R(kst, kend), R(0, 4))),
// 	  0);

//   frct((R(0, tx-1), R(ty-1, ty-1), R(0, tz-1), R(0, 0)))((R(ist, iend), R(isiz2, isiz2), R(kst, kend), R(0, 4))).
//     hmap (Special4(),
// 	  rsd((R(0, tx-1), R(ty-1, ty-1), R(0, tz-1), R(0, 0)))((R(ist, iend), R(isiz2, isiz2), R(kst, kend), R(0, 4))),
// 	  rsd((R(0, tx-1), R(ty-1, ty-1), R(0, tz-1), R(0, 0)))((R(ist, iend), R(isiz2-1, isiz2-1), R(kst, kend), R(0, 4))),
// 	  rsd((R(0, tx-1), R(ty-1, ty-1), R(0, tz-1), R(0, 0)))((R(ist, iend), R(isiz2-2, isiz2-2), R(kst, kend), R(0, 4))),
// 	  0);
}

struct Zeta{
  
  void operator() (HTA_2H rsd,
		   HTA_2H flux,
		   HTA_2H frct)
  {  
    int step_frct_0 = frct.memMap().linearStep()[0];
    int step_frct_1 = frct.memMap().linearStep()[1];
    int step_frct_2 = frct.memMap().linearStep()[2];
    int step_frct_3 = frct.memMap().linearStep()[3];

    int step_flux_0 = flux.memMap().linearStep()[0];
    int step_flux_1 = flux.memMap().linearStep()[1];
    int step_flux_2 = flux.memMap().linearStep()[2];
    int step_flux_3 = flux.memMap().linearStep()[3];

    int step_rsd_0 = rsd.memMap().linearStep()[0];
    int step_rsd_1 = rsd.memMap().linearStep()[1];
    int step_rsd_2 = rsd.memMap().linearStep()[2];
    int step_rsd_3 = rsd.memMap().linearStep()[3];
    
    Tuple<4> pos = rsd.memMap().leafPos();
    Tuple<4> size = flux.shape().size();

     for (int i = 2; i < size[0]  - 2; i++)
      for (int j = 2; j < size[1]  - 2; j++)
	for (int k = 1; k < size[2]  - 1; k++) {
	   
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (0)] =  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)];
	  double u41 =  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)] /  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (0)];
	  double q = 0.50 * (   
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)] *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)]
			     +  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)] *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)]
			     +  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)] *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)] )
	    /  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (0)];
	   
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (1)] =  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)] * u41;
	   
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (2)] =  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)] * u41;
	   
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (3)] =  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)] * u41 + C2 * (  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (4)] - q);
	   
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (4)] = ( C1 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (4)] - C2 * q ) * u41;
	  assert (q != 0);
	  assert (u41 != 0);
	}

 
    for (int i = 2; i < size[0]  - 2; i++)
      for (int j = 2; j < size[1]  - 2; j++)
	for (int k = 2; k < size[2]  - 2; k++)
	  {
	   
	    for (int m = 0; m < 5; m++)
	       
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (m)] =   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (m)] -  tx2 * ( 
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k+1) * step_flux_2 + (m)] -  
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k-1) * step_flux_2 + (m)]);  
	  }

    for (int i = 2; i < size[0]  - 2; i++)
      for (int j = 2; j < size[1]  - 2; j++)
	for (int k = 2; k < size[2]  - 1; k++) {
	  double tmp =  1.0 /  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (0)];
	  double u21j = tmp *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)];
	  double u31j = tmp *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)];
	  double u41j = tmp *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)];
	  double u51j = tmp *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (4)];
	  
	  tmp = 1.0 /  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k-1) * step_rsd_2 + (0)];
	  double u21jm1 = tmp *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k-1) * step_rsd_2 + (1)];
	  double u31jm1 = tmp *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k-1) * step_rsd_2 + (2)];
	  double u41jm1 = tmp *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k-1) * step_rsd_2 + (3)];
	  double u51jm1 = tmp *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k-1) * step_rsd_2 + (4)];
    
	   
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (1)] = tz3 * ( u21j - u21jm1 );
	   
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (2)] =  tz3 * ( u31j - u31jm1 );     
	   
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (3)] =  (4.0/3.0) * tz3 *
	    ( u41j - u41jm1 );
	   
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (4)] = 0.50 * ( 1.0 - C1*C5 )
	    * tz3 * ( ( u21j * u21j + u31j * u31j + u41j * u41j )
		      - ( u21jm1*u21jm1 + u31jm1*u31jm1 + u41jm1*u41jm1 ) )
      + (1.0/6.0) * tz3 * ( u41j*u41j - u41jm1*u41jm1 )
	    + C1 * C5 * tz3 * ( u51j - u51jm1 ); 	
	}

     for (int i = 2; i < size[0]   - 2; i++)
      for (int j = 2; j < size[1]  - 2; j++)
	for (int k = 2; k < size[2]  - 2; k++) {
	   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (0)] =   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (0)]
	    + tz1  * dz1 * ( 
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k-1) * step_rsd_2 + (0)]
			    - 2.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (0)]
			    +       	     
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k+1) * step_rsd_2 + (0)]);    
	   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (1)] =  
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (1)]
	    + tz3 * C3 * C4 * (  
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k+1) * step_flux_2 + (1)] -  
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (1)])
	    + dz2 * tz1 * (             
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k-1) * step_rsd_2 + (1)]
				       - 2.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (1)]
				       +            
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k+1) * step_rsd_2 + (1)]) ;    
	   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (2)] =   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (2)]
	    + tz3 * C3 * C4 * (  
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k+1) * step_flux_2 + (2)] -  
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (2)] )
	    + dz3 * tz1 * (             
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k-1) * step_rsd_2 + (2)]
				       - 2.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (2)]
				       +            
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k+1) * step_rsd_2 + (2)]);    
	   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (3)] =   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (3)]
	    + tz3 * C3 * C4 * (  
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k+1) * step_flux_2 + (3)] -  
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (3)] )
      + dz4 * tz1 * (             
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k-1) * step_rsd_2 + (3)]
				 - 2.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (3)]
				 +            
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k+1) * step_rsd_2 + (3)]);    
	   
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (4)] = 
	     
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (4)]
	    + tz3 * C3 * C4 * (  
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k+1) * step_flux_2 + (4)] -  
                flux[(i) * step_flux_0 + (j) * step_flux_1 + (k) * step_flux_2 + (4)] )
      + dz5 * tz1 * (             
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k-1) * step_rsd_2 + (4)]
				 - 2.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (4)]
				 +            
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k+1) * step_rsd_2 + (4)]);
	}

      if (pos[2] == 1)
      {
	for (int i = 2; i < size[0]  - 2; i++)
	  for (int j = 2; j < size[1]  - 2; j++)
	    {
	      
	      for (int m = 0; m < 5; m++) {
		 
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (2) * step_frct_2 + (m)] =  
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (2) * step_frct_2 + (m)] - 
		  dssp * (
			  + 5.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (2) * step_rsd_2 + (m)]
			  - 4.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (3) * step_rsd_2 + (m)]
			  +  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (4) * step_rsd_2 + (m)]);  
		
		 
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (3) * step_frct_2 + (m)] =  
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (3) * step_frct_2 + (m)] - 
		  dssp * (
			  - 4.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (2) * step_rsd_2 + (m)]
			  + 6.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (3) * step_rsd_2 + (m)]
			  - 4.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (4) * step_rsd_2 + (m)]
			  +  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (5) * step_rsd_2 + (m)]);  
	      }
	    }
      }
    
    int kst1 = 2;
    int kend1 = size[2] - 2;
    
    if (pos[2] == 1) kst1 += 2;

    // cout << "Yes " << pos[0] + size[0] << " " << GX << endl;
    Tuple<4> tmp = pos / Tuple<4>(isiz1, isiz2, isiz3, 1);
    if (tmp[2] == np3 - 1)  { kend1 -= 2;} 
    //if (pos[2] + size[2] == GZ +reminder_z -1)  { kend1 -= 2; }
    
    for (int i = 2; i < size[0]  - 2; i++)
      for (int j = 2; j < size[1]  - 2; j++)
	for (int k = kst1; k < kend1 ; k++)
	  {	    
	    for (int m = 0; m < 5; m++)
	       
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (m)] =  
                frct[(i) * step_frct_0 + (j) * step_frct_1 + (k) * step_frct_2 + (m)] - dssp * ( 
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k-2) * step_rsd_2 + (m)]
								  - 4.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k-1) * step_rsd_2 + (m)]
								  + 6.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k) * step_rsd_2 + (m)]
								  - 4.0 *  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k+1) * step_rsd_2 + (m)]
								  +  
                rsd[(i) * step_rsd_0 + (j) * step_rsd_1 + (k+2) * step_rsd_2 + (m)]);  
	  }
    
    if (tmp[2] == np3 - 1)  
     //if (pos[2] + size[2] == GZ + reminder_z -1)       
       {
	 for (int i = 2; i < size[0]  - 2; i++)
	   for (int j = 2; j < size[1]  - 2; j++)
	     {
	       for (int m = 0; m < 5; m++)
		 frct[T(i, j, size[2]-4, m)] = 
		   frct[T(i, j, size[2]-4, m)] - 
		   dssp * (rsd[T(i, j, size[2]-6, m)]
			   - 4.0 * rsd[T(i, j, size[2]-5, m)]
			   + 6.0 * rsd[T(i, j, size[2]-4, m)]
			   - 4.0 * rsd[T(i, j, size[2]-3, m)]);		
	       
	       for (int m = 0; m < 5; m++)
		 frct[T(i, j, size[2]-3, m)] = frct[T(i, j, size[2]-3, m)] - 
		   dssp * (rsd[T(i, j, size[2]-5, m)]
			   - 4.0 * rsd[T(i, j, size[2]-4, m)]
			   + 5.0 * rsd[T(i, j, size[2]-3, m)]);
	     }
	 
       }    

  }

};

void erhs3 (HTA_2H rsdInner, HTA_2H frctInner, HTA_2H fluxInner, 
	    HTA_2H rsd, HTA_2H frct, HTA_2H flux)
{  

  rsdInner.hmap (Zeta(),
		 fluxInner,
		 frctInner,
		 0);

//   double dsspm = dssp;
  
//   int jst = 2;
//   int jend = isiz2+1;
//   int ist = 2;
//   int iend = isiz1+1;
//   int kst = 2;
//   int kend = isiz3+1;
//   int tx = rsd.shape().size()[0];
//   int ty = rsd.shape().size()[1];
//   int tz = rsd.shape().size()[2];

//   int L1 = 1;
//   int L2 = isiz3+2;
//   int sx, sy, sz;

//   ShapeH<4> shape(T(tx, ty, tz, 1));
  
//   /* loop 1 */
//   shape =  Shape<4> ((R(ist, iend), R(jst, jend),  R(L1, L2), R(0 ,4)));
//   sx = (iend - ist + 1)*tx;
//   sy = (jend - jst + 1)*ty;
//   sz = (L2 - L1 + 1)*tz;
//   ShapeH<4> shape1 = shape.intersect (Shape<4>((R(1, sx-2), R(1,sy-2), R(1,sz-2), R(0, 4))));

//   /*--------------------------------------------------------------------
//     c   Fourth-order dissipation
//     --------------------------------------------------------------------*/  
 
  
//   //special case (I)
//   frct((R(0, tx-1), R(0, ty-1), R(0, 0), R(0, 0)))((R(ist, iend), R(jst, jend), R(3, 3), R(0, 4))).
//     hmap (Special1(),
// 	  rsd((R(0, tx-1), R(0, ty-1), R(0, 0), R(0, 0)))((R(ist, iend),  R(jst, jend),R(3, 3), R(0, 4))),
// 	  rsd((R(0, tx-1), R(0, ty-1), R(0, 0), R(0, 0)))((R(ist, iend),  R(jst, jend),R(4, 4), R(0, 4))),
// 	  rsd((R(0, tx-1), R(0, ty-1), R(0, 0), R(0, 0)))((R(ist, iend),  R(jst, jend),R(5, 5), R(0, 4))),
// 	  0);
//   //special case (II)
//   frct((R(0, tx-1), R(0, ty-1), R(0, 0), R(0, 0)))((R(ist, iend), R(jst, jend), R(4, 4), R(0, 4))).
//     hmap (Special2(),
// 	    rsd((R(0, tx-1), R(0, ty-1), R(0, 0), R(0, 0)))((R(ist, iend),  R(jst, jend),R(4, 4), R(0, 4))),
// 	    rsd((R(0, tx-1), R(0, ty-1), R(0, 0), R(0, 0)))((R(ist, iend),  R(jst, jend),R(3, 3), R(0, 4))),
// 	    rsd((R(0, tx-1), R(0, ty-1), R(0, 0), R(0, 0)))((R(ist, iend),  R(jst, jend),R(5, 5), R(0, 4))),
// 	    rsd((R(0, tx-1), R(0, ty-1), R(0, 0), R(0, 0)))((R(ist, iend),  R(jst, jend),R(6, 6), R(0, 4))),
// 	    0);
    
//   /* loop 5 */
//   int kst1 = 2;
//   int kend1 = isiz3+1;
//   shape = Shape<4>((R(ist, iend), R(jst, jend), R(kst1, kend1), R(0, 4)));
//   sx = (iend - ist + 1)*tx;
//   sy = (jend - jst + 1)*ty;
//   sz = (kend1 - kst1 + 1)*tz;
//   ShapeH<4> shape5 = shape.intersect (Shape<4>((R(1, sx-2), R(1,sy-2), R(3,sz-4), R(0, 4))));
//   ShapeH<4> shape5B =  shape5 - T(0, 0, 1, 0);
//   ShapeH<4> shape5B2 = shape5 - T(0, 0, 2, 0);
//   ShapeH<4> shape5F =  shape5 + T(0, 0, 1, 0);
//   ShapeH<4> shape5F2 = shape5 + T(0, 0, 2, 0);
//   frct()(shape5).hmap (Loop5(),
// 		       rsd()(shape5),
// 		       rsd()(shape5B),
// 		       rsd()(shape5B2),
// 		       rsd()(shape5F),
// 		       rsd()(shape5F2),
// 		       0);
     
//   frct((R(0, tx-1), R(0, ty-1), R(tz-1, tz-1), R(0, 0)))(( R(ist, iend), R(jst, jend), R(isiz3-1, isiz3-1), R(0,4))).
//     hmap (Special3(),
// 	  rsd((R(0, tx-1), R(0, ty-1), R(tz-1, tz-1), R(0, 0)))(( R(ist, iend), R(jst, jend), R(isiz3-1, isiz3-1), R(0, 4))),
// 	  rsd((R(0, tx-1), R(0, ty-1), R(tz-1, tz-1), R(0, 0)))(( R(ist, iend), R(jst, jend), R(isiz3-2, isiz3-2), R(0, 4))),
// 	  rsd((R(0, tx-1), R(0, ty-1), R(tz-1, tz-1), R(0, 0)))(( R(ist, iend), R(jst, jend), R(isiz3-3, isiz3-3), R(0, 4))),
// 	  rsd((R(0, tx-1), R(0, ty-1), R(tz-1, tz-1), R(0, 0)))(( R(ist, iend), R(jst, jend), R(isiz3, isiz3), R(0, 4))),
// 	  0);
  
//   frct((R(0, tx-1), R(0, ty-1), R(tz-1, tz-1), R(0, 0)))(( R(ist, iend), R(jst, jend), R(isiz3, isiz3), R(0, 4))).
//     hmap (Special4(),
// 	  rsd((R(0, tx-1), R(0, ty-1), R(tz-1, tz-1), R(0, 0)))(( R(ist, iend), R(jst, jend), R(isiz3, isiz3), R(0, 4))),
// 	  rsd((R(0, tx-1), R(0, ty-1), R(tz-1, tz-1), R(0, 0)))(( R(ist, iend), R(jst, jend), R(isiz3-1, isiz3-1), R(0, 4))),
// 	  rsd((R(0, tx-1), R(0, ty-1), R(tz-1, tz-1), R(0, 0)))(( R(ist, iend), R(jst, jend), R(isiz3-2, isiz3-2), R(0, 4))),
// 	  0);    
}

static void exact( int i, int j, int k, double u000ijk[5] ) {

/*--------------------------------------------------------------------
c
c   compute the exact solution at (i,j,k)
c
--------------------------------------------------------------------*/

/*--------------------------------------------------------------------
c  local variables
--------------------------------------------------------------------*/
  int m;
  double xi, eta, zeta;

  xi  = ((double)i) / (double) (ISIZ1 - 1);
  eta  = ((double)j) / (double) (ISIZ2 - 1);
  zeta = ((double)k) / (double) (ISIZ3 - 1);

  for (m = 0; m < 5; m++) {
    u000ijk[m] =  ce[m][0]
      + ce[m][1] * xi
      + ce[m][2] * eta
      + ce[m][3] * zeta
      + ce[m][4] * xi * xi
      + ce[m][5] * eta * eta
      + ce[m][6] * zeta * zeta
      + ce[m][7] * xi * xi * xi
      + ce[m][8] * eta * eta * eta
      + ce[m][9] * zeta * zeta * zeta
      + ce[m][10] * xi * xi * xi * xi
      + ce[m][11] * eta * eta * eta * eta
      + ce[m][12] * zeta * zeta * zeta * zeta;
  }
}


static void exact (int i, int j, int k, int iL, int jL, int kL, HTA<double, 4> h) {

/*--------------------------------------------------------------------
c
c   compute the exact solution at (i,j,k)
c
--------------------------------------------------------------------*/

/*--------------------------------------------------------------------
c  local variables
--------------------------------------------------------------------*/
  int m;
  double xi, eta, zeta;

  xi  = ((double)i) / (double) (ISIZ1 - 1);
  eta  = ((double)j) / (double) (ISIZ2 - 1);
  zeta = ((double)k) / (double) (ISIZ3 - 1);

  for (m = 0; m < 5; m++) {
    h[T(iL, jL, kL, m)] =  ce[m][0]
      + ce[m][1] * xi
      + ce[m][2] * eta
      + ce[m][3] * zeta
      + ce[m][4] * xi * xi
      + ce[m][5] * eta * eta
      + ce[m][6] * zeta * zeta
      + ce[m][7] * xi * xi * xi
      + ce[m][8] * eta * eta * eta
      + ce[m][9] * zeta * zeta * zeta
      + ce[m][10] * xi * xi * xi * xi
      + ce[m][11] * eta * eta * eta * eta
      + ce[m][12] * zeta * zeta * zeta * zeta;
  }
}
