#include "htalib_serial.h"
#include "applu.h"
#include "ShapeH.h"
#include "MapReduceHTA.h"

typedef Triplet R;
typedef Tuple<3> T;


typedef HTA<double, 3> HTA_2H;

typedef Tuple<3> T;
int isiz1;
int isiz2;
int isiz3;

int np1;
int np2;
int np3;

/*--------------------------------------------------------------------
  c   xi-direction flux differences
  --------------------------------------------------------------------*/

void erhs1 (HTA_2H rsd, HTA_2H frct, HTA_2H flux)
{  
  int jst = 1;
  int jend = isiz2;
  int ist = 1;
  int iend = isiz1;
  int kst = 1;
  int kend = isiz3;
  int tx = rsd.shape().size()[0];
  int ty = rsd.shape().size()[1]; 
  int tz = rsd.shape().size()[2];

  int L1 = 0;
  int L2 = isiz1+1;
  int sx, sy, sz;

  ShapeH<3> shape(T(tx, ty, tz));


  /* loop 1 */
  shape =  Shape<3> ((R(L1, L2), R(jst, jend),  R(kst, kend)));
  sx = (L2 - L1 + 1)*tx;
  sy = (jend - jst + 1)*ty;
  sz = (kend - kst + 1)*tz;
  ShapeH<3> shape1 = shape.intersect (Shape<3>((R(1, sx-2), R(1,sy-2), R(1,sz-2))));
					      
  flux()(shape1)((R(0, 0), R(0, 0), R(0,0))) = rsd()(shape1)((R(1, 1), R(0, 0), R(0,0))); 
  HTA_2H u21 = rsd()(shape1)((R(1,1), R(0,0), R(0,0))) / rsd()(shape1)((R(0, 0), R(0,0), R(0,0)));

  HTA_2H q = 0.50 * (rsd()(shape1)((R(1,1), R(0,0), R(0,0))) * rsd()(shape1)((R(1,1), R(0,0), R(0,0)))
		     + rsd()(shape1)((R(2, 2), R(0,0), R(0,0))) * rsd()(shape1)((R(2, 2), R(0,0), R(0,0)))
		     + rsd()(shape1)((R(3,3), R(0,0), R(0,0))) * rsd()(shape1)((R(3,3), R(0,0), R(0,0))) )
    / rsd()(shape1)((R(0, 0), R(0,0), R(0,0)));
  
  flux()(shape1)((R(1, 1), R(0,0), R(0,0))) = rsd()(shape1)((R(1, 1), R(0,0), R(0,0))) * u21 +  
    ( rsd()(shape1)((R(4, 4), R(0,0), R(0,0))) - q ) * C2;
  flux()(shape1)((R(2, 2), R(0,0), R(0,0))) = rsd()(shape1)((R(2, 2), R(0,0), R(0,0))) * u21;
  flux()(shape1)((R(3, 3), R(0,0), R(0,0))) = rsd()(shape1)((R(3, 3), R(0,0), R(0,0))) * u21;
  flux()(shape1)((R(4, 4), R(0,0), R(0,0))) = ( C1 * rsd()(shape1)((R(4, 4), R(0,0), R(0,0))) - C2 * q ) * u21;


  /*loop 2 */
  shape = Shape<3>((R(ist, iend), R(jst, jend), R(kst, kend)));  
  sx = (iend-ist+1)*tx;
  sy = (jend-jst+1)*ty;
  sz = (kend-kst+1)*tz;
  ShapeH<3> shape2 = shape.intersect (Shape<3>((R(1, sx-2), R(1,sy-2), R(1,sz-2))));
 
  frct()(shape2)() =  frct()(shape2)() -  tx2 * ( flux()(shape2 + T(1, 0, 0))() - flux()(shape2 -  T(1, 0, 0))());  
 
  /* loop 3 */
  shape = Shape<3>((R(ist, L2), R(jst, jend), R(kst, kend)));  
  sx = (L2-ist+1)*tx;
  sy = (jend-jst+1)*ty;
  sz = (kend-kst+1)*tz;
  ShapeH<3> shape3 = shape.intersect (Shape<3>((R(1, sx-2), R(1,sy-2), R(1,sz-2))));

  HTA_2H tmp = 1.0 / rsd()(shape3)((R(0, 0), R(0,0), R(0,0)));  
  HTA_2H u21i = rsd()(shape3)((R(1,1), R(0,0), R(0,0))) * tmp;
  HTA_2H u31i = rsd()(shape3)((R(2,2), R(0,0), R(0,0))) * tmp;
  HTA_2H u41i = rsd()(shape3)((R(3,3), R(0,0), R(0,0))) * tmp;
  HTA_2H u51i = rsd()(shape3)((R(4, 4), R(0,0), R(0,0))) * tmp;

  tmp = 1.0 /     rsd()(shape3 -  T(1, 0, 0))((R(0, 0), R(0,0), R(0,0)));  
  HTA_2H u21im1 = rsd()(shape3 -  T(1, 0, 0))((R(1, 1), R(0,0), R(0,0))) * tmp;
  HTA_2H u31im1 = rsd()(shape3 -  T(1, 0, 0))((R(2, 2), R(0,0), R(0,0))) * tmp;
  HTA_2H u41im1 = rsd()(shape3 -  T(1, 0, 0))((R(3, 3), R(0,0), R(0,0))) * tmp;
  HTA_2H u51im1 = rsd()(shape3 -  T(1, 0, 0))((R(4, 4), R(0,0), R(0,0))) * tmp;
  
  flux()(shape3)((R(1, 1), R(0, 0), R(0, 0))) = (4.0/3.0) * tx3 * 
    (u21i - u21im1);
  flux()(shape3)((R(2, 2), R(0,0), R(0,0))) = tx3 * ( u31i - u31im1 );
  flux()(shape3)((R(3, 3), R(0,0), R(0,0))) = tx3 * ( u41i - u41im1 );
  flux()(shape3)((R(4, 4), R(0,0), R(0,0))) = 0.50 * ( 1.0 - C1*C5 )
    * tx3 * ( ( u21i * u21i + u31i * u31i + u41i * u41i )
	      - ( u21im1 * u21im1 + u31im1 * u31im1 + u41im1 * u41im1 ) )
    + (1.0/6.0) * tx3 * ( u21i*u21i - u21im1*u21im1 )
    + C1 * C5 * tx3 * ( u51i - u51im1 );

  /* loop 4 */
  shape = Shape<3>((R(ist, iend), R(jst, jend), R(kst, kend)));
  sx = (iend-ist+1)*tx;
  sy = (jend-jst+1)*ty;
  sz = (kend-kst+1)*tz;
  ShapeH<3> shape4 = shape.intersect (Shape<3>((R(1, sx-2), R(1,sy-2), R(1,sz-2))));
  
  frct()(shape4)((R(0, 0), R(0,0), R(0,0))) = 
    frct()(shape4)((R(0, 0), R(0,0), R(0,0)))
    + dx1 * tx1 * (rsd()(shape4 -  T(1, 0, 0))((R(0, 0), R(0,0), R(0,0)))
		   - 2.0 * rsd()(shape4)((R(0, 0), R(0,0), R(0,0)))
		   +       	    rsd()(shape4 + T(1, 0, 0))((R(0, 0), R(0,0), R(0,0))) );

  frct()(shape4)((R(1,1), R(0,0), R(0,0))) = 
    frct()(shape4)((R(1,1), R(0,0), R(0,0)))
    + tx3 * C3 * C4 * ( flux()(shape4 + T(1, 0, 0))((R(1,1), R(0,0), R(0,0))) - flux()(shape4)((R(1,1), R(0,0), R(0,0))))
    + dx2 * tx1 * (            rsd()(shape4 - T(1, 0, 0))((R(1,1), R(0,0), R(0,0)))
			       - 2.0 * rsd()(shape4)((R(1,1), R(0,0), R(0,0)))
			       +           rsd()(shape4 + T(1, 0, 0))((R(1,1), R(0,0), R(0,0)))) ;
  
  frct()(shape4)((R(2, 2), R(0,0), R(0,0))) = 
    frct()(shape4)((R(2,2), R(0,0), R(0,0)))
    + tx3 * C3 * C4 * ( flux()(shape4 + T(1, 0, 0))((R(2, 2), R(0,0), R(0,0))) - flux()(shape4)((R(2,2), R(0,0), R(0,0))) )
    + dx3 * tx1 * (            rsd()(shape4 -  T(1, 0, 0))((R(2,2), R(0,0), R(0,0)))
			       - 2.0 * rsd()(shape4)((R(2,2), R(0,0), R(0,0)))
			       +           rsd()(shape4 + T(1, 0, 0))((R(2,2), R(0,0), R(0,0))));
  
  frct()(shape4)((R(3,3), R(0,0), R(0,0))) = 
    frct()(shape4)((R(3,3), R(0,0), R(0,0)))
    + tx3 * C3 * C4 * ( flux()(shape4 + T(1, 0, 0))((R(3,3), R(0,0), R(0,0))) - flux()(shape4)((R(3,3), R(0,0), R(0,0))) )
    + dx4 * tx1 * (            rsd()(shape4 - T(1, 0, 0))((R(3,3), R(0,0), R(0,0)))
			       - 2.0 * rsd()(shape4)((R(3,3), R(0,0), R(0,0)))
			       +           rsd()(shape4 + T(1, 0, 0))((R(3,3), R(0,0), R(0,0))));
  frct()(shape4)((R(4, 4), R(0,0), R(0,0))) = 
    frct()(shape4)((R(4, 4), R(0,0), R(0,0)))
    + tx3 * C3 * C4 * ( flux()(shape4 + T(1, 0, 0))((R(4, 4), R(0,0), R(0,0))) - flux()(shape4)((R(4, 4), R(0,0), R(0,0))) )
    + dx5 * tx1 * (            rsd()(shape4 - T(1, 0, 0))((R(4, 4), R(0,0), R(0,0)))
			       - 2.0 * rsd()(shape4)((R(4, 4), R(0,0), R(0,0)))
			       +           rsd()(shape4 + T(1, 0, 0))((R(4, 4), R(0,0), R(0,0))));
  

  /*--------------------------------------------------------------------
    c   Fourth-order dissipation
    --------------------------------------------------------------------*/
  /*
  frct()(shape1) = frct()(shape1)
    - dsspm * ( + 5.0 * rsd()(shape1)
		- 4.0 * rsd()(shape2)
		+           rsd()(shape3));
  
  frct()(shape2) = frct()(shape2)
    - dsspm * ( - 4.0 * rsd()(shape1)
		+ 6.0 * rsd()(shape2)
		- 4.0 * rsd()(shape3)
		+           rsd()(shape4));
  
  ist1 = 3;
  iend1 = nx - 4;
  frct()(shape) = frct()(shape)
    - dsspm * (            rsd()(shape - (R(2,2), R(0,0), R(0,0)))
			   - 4.0 * rsd()(shape - (R(1,1), R(0,0), R(0,0)))
			   + 6.0 * rsd()(shape)
			   - 4.0 * rsd()(shape + (R(1,1), R(0,0), R(0,0)))
			   +           rsd()(shape + (R(2,2), R(0,0), R(0,0))));
  
  frct()(shape1)[m] = frct()(shape1)
    - dsspm * (             rsd()(shape2)
			    - 4.0 * rsd()(shape3)
			    + 6.0 * rsd()(shape4)
			    - 4.0 * rsd()(shape5));
  
  frct()(shape1) = frct()(shape2)
    - dsspm * (             rsd()(shape3)
			    - 4.0 * rsd()(shape4)
			    + 5.0 * rsd()(shape5)); 
  */ 
  //   /*--------------------------------------------------------------------
  //     c   eta-direction flux differences
//     --------------------------------------------------------------------*/
  
//   L1 = 0;
//   L2 = ny-1;
  
  
//   flux()(shape)[(R(0, 0), R(0,0), R(0,0))] = rsd()(shape)[(R(2, 2), R(0,0), R(0,0))];
//   u31 = rsd()(shape)[(R(2, 2), R(0,0), R(0,0))] / rsd()(shape)[(R(0, 0), R(0,0), R(0,0))];
//   q = 0.50 * (  rsd()(shape)[(R(1,1), R(0,0), R(0,0))] * rsd()(shape)[(R(1,1), R(0,0), R(0,0))]
// 		+ rsd()(shape)[(R(2, 2), R(0,0), R(0,0))] * rsd()(shape)[(R(2, 2), R(0,0), R(0,0))]
// 		+ rsd()(shape)[(R(3, 3), R(0,0), R(0,0))] * rsd()(shape)[(R(3, 3), R(0,0), R(0,0))] )
//     / rsd()(shape)[(R(0, 0), R(0,0), R(0,0))];
//   flux()(shape)[(R(1,1), R(0,0), R(0,0))] = rsd()(shape)[(R(1,1), R(0,0), R(0,0))] * u31;
//   flux()(shape)[(R(2, 2), R(0,0), R(0,0))] = rsd()(shape)[(R(2, 2), R(0,0), R(0,0))] * u31 + C2 * 
//     ( rsd()(shape)[(R(4, 4), R(0,0), R(0,0))] - q );
//   flux()(shape)[(R(3, 3), R(0,0), R(0,0))] = rsd()(shape)[(R(3, 3), R(0,0), R(0,0))] * u31;
//   flux()(shape)[(R(4, 4), R(0,0), R(0,0))] = ( C1 * rsd()(shape)[(R(4, 4), R(0,0), R(0,0))] - C2 * q ) * u31;
  
//   for (m = 0; m < 5; m++) {
//     frct()(shape)[m] =  frct()(shape)[m]
//       - ty2 * ( flux()(shape + T(0, 1, 0))[m] - flux()(shape - T(0, 1, 0))[m] );
//   }
  
//   tmp = 1.0 / rsd()(shape)[(R(0, 0), R(0,0), R(0,0))];
  
//   u21j = tmp * rsd()(shape)[(R(1,1), R(0,0), R(0,0))];
//   u31j = tmp * rsd()(shape)[(R(2, 2), R(0,0), R(0,0))];
//   u41j = tmp * rsd()(shape)[(R(3, 3), R(0,0), R(0,0))];
//   u51j = tmp * rsd()(shape)[(R(4, 4), R(0,0), R(0,0))];
  
//   tmp = 1.0 / rsd()(shape - T(0, 1, 0))[(R(0, 0), R(0,0), R(0,0))];
  
//   u21jm1 = tmp * rsd()(shape - T(0, 1, 0))[(R(1,1), R(0,0), R(0,0))];
//   u31jm1 = tmp * rsd()(shape - T(0, 1, 0))[(R(2, 2), R(0,0), R(0,0))];
//   u41jm1 = tmp * rsd()(shape - T(0, 1, 0))[(R(3, 3), R(0,0), R(0,0))];
//   u51jm1 = tmp * rsd()(shape - T(0, 1, 0))[(R(4, 4), R(0,0), R(0,0))];
  
//   flux()(shape)[(R(1,1), R(0,0), R(0,0))] = ty3 * ( u21j - u21jm1 );
//   flux()(shape)[(R(2, 2), R(0,0), R(0,0))] = (4.0/3.0) * ty3 * 
//     ( u31j - u31jm1 );
//   flux()(shape)[(R(3, 3), R(0,0), R(0,0))] = ty3 * ( u41j - u41jm1 );
//   flux()(shape)[(R(4, 4), R(0,0), R(0,0))] = 0.50 * ( 1.0 - C1*C5 )
//     * ty3 * ( ( u21j  *u21j + u31j  *u31j + u41j  *u41j )
// 	      - ( u21jm1*u21jm1 + u31jm1*u31jm1 + u41jm1*u41jm1 ) )
//     + (1.0/6.0)
//     * ty3 * ( u31j*u31j - u31jm1*u31jm1 )
// 	  + C1 * C5 * ty3 * ( u51j - u51jm1 );

  
//   frct()(shape)[(R(0, 0), R(0,0), R(0,0))] = frct()(shape)[(R(0, 0), R(0,0), R(0,0))]
//     + dy1 * ty1 * (            rsd()(shape - T(0, 1, 0))[(R(0, 0), R(0,0), R(0,0))]
// 			       - 2.0 * rsd()(shape)[(R(0, 0), R(0,0), R(0,0))]
// 			       +           rsd()(shape + T(0, 1, 0))[(R(0, 0), R(0,0), R(0,0))] );
//   frct()(shape)[(R(1,1), R(0,0), R(0,0))] = frct()(shape)[(R(1,1), R(0,0), R(0,0))]
//     + ty3 * C3 * C4 * ( flux()(shape + T(0, 1, 0))[(R(1,1), R(0,0), R(0,0))] - flux()(shape)[(R(1,1), R(0,0), R(0,0))] )
//     + dy2 * ty1 * (            rsd()(shape - T(0, 1, 0))[(R(1,1), R(0,0), R(0,0))]
// 			       - 2.0 * rsd()(shape)[(R(1,1), R(0,0), R(0,0))]
// 			       +           rsd()(shape + T(0, 1, 0))[(R(1,1), R(0,0), R(0,0))] );
//   frct()(shape)[(R(2, 2), R(0,0), R(0,0))] = frct()(shape)[(R(2, 2), R(0,0), R(0,0))]
//     + ty3 * C3 * C4 * ( flux()(shape + T(0, 1, 0))[(R(2, 2), R(0,0), R(0,0))] - flux()(shape)[(R(2, 2), R(0,0), R(0,0))] )
//     + dy3 * ty1 * (            rsd()(shape - T(0, 1, 0))[(R(2, 2), R(0,0), R(0,0))]
// 			       - 2.0 * rsd()(shape)[(R(2, 2), R(0,0), R(0,0))]
// 				     +           rsd()(shape + T(0, 1, 0))[(R(2, 2), R(0,0), R(0,0))] );
//   frct()(shape)[(R(3, 3), R(0,0), R(0,0))] = frct()(shape)[(R(3, 3), R(0,0), R(0,0))]
//     + ty3 * C3 * C4 * ( flux()(shape + T(0, 1, 0))[(R(3, 3), R(0,0), R(0,0))] - flux()(shape)[(R(3, 3), R(0,0), R(0,0))] )
//     + dy4 * ty1 * (            rsd()(shape - T(0, 1, 0))[(R(3, 3), R(0,0), R(0,0))]
// 			       - 2.0 * rsd()(shape)[(R(3, 3), R(0,0), R(0,0))]
// 			       +           rsd()(shape + T(0, 1, 0))[(R(3, 3), R(0,0), R(0,0))] );
//   frct()(shape)[(R(4, 4), R(0,0), R(0,0))] = frct()(shape)[(R(4, 4), R(0,0), R(0,0))]
//     + ty3 * C3 * C4 * ( flux()(shape + T(0, 1, 0))[(R(4, 4), R(0,0), R(0,0))] - flux()(shape)[(R(4, 4), R(0,0), R(0,0))] )
//     + dy5 * ty1 * (            rsd()(shape - T(0, 1, 0))[(R(4, 4), R(0,0), R(0,0))]
// 			       - 2.0 * rsd()(shape)[(R(4, 4), R(0,0), R(0,0))]
// 			       +           rsd()(shape + T(0, 1, 0))[(R(4, 4), R(0,0), R(0,0))] );

// /*--------------------------------------------------------------------
// c   fourth-order dissipation
// --------------------------------------------------------------------*/
//   for (m = 0; m < 5; m++) {
//     frct[i][(R(1,1), R(0,0), R(0,0))][k][m] = frct[i][(R(1,1), R(0,0), R(0,0))][k][m]
//       - dsspm * ( + 5.0 * rsd[i][(R(1,1), R(0,0), R(0,0))][k][m]
// 		  - 4.0 * rsd[i][(R(2, 2), R(0,0), R(0,0))][k][m]
// 		  +           rsd[i][(R(3, 3), R(0,0), R(0,0))][k][m] );
//     frct[i][(R(2, 2), R(0,0), R(0,0))][k][m] = frct[i][(R(2, 2), R(0,0), R(0,0))][k][m]
//       - dsspm * ( - 4.0 * rsd[i][(R(1,1), R(0,0), R(0,0))][k][m]
// 		  + 6.0 * rsd[i][(R(2, 2), R(0,0), R(0,0))][k][m]
// 		  - 4.0 * rsd[i][(R(3, 3), R(0,0), R(0,0))][k][m]
// 		  +           rsd[i][(R(4, 4), R(0,0), R(0,0))][k][m] );
//   }
  
//   jst1 = 3;
//   jend1 = ny - 4;
  
//   for (m = 0; m < 5; m++) {
//     frct()(shape)[m] = frct()(shape)[m]
//       - dsspm * (            rsd()(shape - T(0, 2, 0))[m]
// 			     - 4.0 * rsd()(shape - T(0, 1, 0))[m]
// 			     + 6.0 * rsd()(shape)[m]
// 			     - 4.0 * rsd()(shape + T(0, 1, 0))[m]
// 			     +           rsd[i][j+2][k][m] );
//   }
  
//   for (m = 0; m < 5; m++) {
//     frct[i][ny-3][k][m] = frct[i][ny-3][k][m]
//       - dsspm * (             rsd[i][ny-5][k][m]
// 			      - 4.0 * rsd[i][ny-4][k][m]
// 			      + 6.0 * rsd[i][ny-3][k][m]
// 			      - 4.0 * rsd[i][ny-2][k][m]  );
//     frct[i][ny-2][k][m] = frct[i][ny-2][k][m]
//       - dsspm * (             rsd[i][ny-4][k][m]
// 			      - 4.0 * rsd[i][ny-3][k][m]
// 			      + 5.0 * rsd[i][ny-2][k][m]  );
//   }
  
  
//   /*--------------------------------------------------------------------
//     c   zeta-direction flux differences
//     --------------------------------------------------------------------*/
  
//   flux()(shape)[(R(0, 0), R(0,0), R(0,0))] = rsd()(shape)[(R(3, 3), R(0,0), R(0,0))];
//   u41 = rsd()(shape)[(R(3, 3), R(0,0), R(0,0))] / rsd()(shape)[(R(0, 0), R(0,0), R(0,0))];
//   q = 0.50 * (  rsd()(shape)[(R(1,1), R(0,0), R(0,0))] * rsd()(shape)[(R(1,1), R(0,0), R(0,0))]
// 		+ rsd()(shape)[(R(2, 2), R(0,0), R(0,0))] * rsd()(shape)[(R(2, 2), R(0,0), R(0,0))]
// 		+ rsd()(shape)[(R(3, 3), R(0,0), R(0,0))] * rsd()(shape)[(R(3, 3), R(0,0), R(0,0))] )
//     / rsd()(shape)[(R(0, 0), R(0,0), R(0,0))];
//   flux()(shape)[(R(1,1), R(0,0), R(0,0))] = rsd()(shape)[(R(1,1), R(0,0), R(0,0))] * u41;
//   flux()(shape)[(R(2, 2), R(0,0), R(0,0))] = rsd()(shape)[(R(2, 2), R(0,0), R(0,0))] * u41;
//   flux()(shape)[(R(3, 3), R(0,0), R(0,0))] = rsd()(shape)[(R(3, 3), R(0,0), R(0,0))] * u41 + C2 * 
//     ( rsd()(shape)[(R(4, 4), R(0,0), R(0,0))] - q );
//   flux()(shape)[(R(4, 4), R(0,0), R(0,0))] = ( C1 * rsd()(shape)[(R(4, 4), R(0,0), R(0,0))] - C2 * q ) * u41;

//   for (m = 0; m < 5; m++) {
//     frct()(shape)[m] =  frct()(shape)[m]
//       - tz2 * ( flux()(shape + T(0, 0, 1))[m] - flux()(shape - T(0, 0, 1))[m] );
//   }
  
//   tmp = 1.0 / rsd()(shape)[(R(0, 0), R(0,0), R(0,0))];
  
//   u21k = tmp * rsd()(shape)[(R(1,1), R(0,0), R(0,0))];
//   u31k = tmp * rsd()(shape)[(R(2, 2), R(0,0), R(0,0))];
//   u41k = tmp * rsd()(shape)[(R(3, 3), R(0,0), R(0,0))];
//   u51k = tmp * rsd()(shape)[(R(4, 4), R(0,0), R(0,0))];
  
//   tmp = 1.0 / rsd()(shape - T(0, 0, 1))[(R(0, 0), R(0,0), R(0,0))];
  
//   u21km1 = tmp * rsd()(shape - T(0, 0, 1))[(R(1,1), R(0,0), R(0,0))];
//   u31km1 = tmp * rsd()(shape - T(0, 0, 1))[(R(2, 2), R(0,0), R(0,0))];
//   u41km1 = tmp * rsd()(shape - T(0, 0, 1))[(R(3, 3), R(0,0), R(0,0))];
//   u51km1 = tmp * rsd()(shape - T(0, 0, 1))[(R(4, 4), R(0,0), R(0,0))];
  
//   flux()(shape)[(R(1,1), R(0,0), R(0,0))] = tz3 * ( u21k - u21km1 );
//   flux()(shape)[(R(2, 2), R(0,0), R(0,0))] = tz3 * ( u31k - u31km1 );
//   flux()(shape)[(R(3, 3), R(0,0), R(0,0))] = (4.0/3.0) * tz3 * ( u41k 
// 					 - u41km1 );
//   flux()(shape)[(R(4, 4), R(0,0), R(0,0))] = 0.50 * ( 1.0 - C1*C5 )
//     * tz3 * ( ( u21k  *u21k + u31k  *u31k + u41k  *u41k )
// 		    - ( u21km1*u21km1 + u31km1*u31km1 + u41km1*u41km1 ) )
//     + (1.0/6.0)
//     * tz3 * ( u41k*u41k - u41km1*u41km1 )
//     + C1 * C5 * tz3 * ( u51k - u51km1 );
  
//   frct()(shape)[(R(0, 0), R(0,0), R(0,0))] = frct()(shape)[(R(0, 0), R(0,0), R(0,0))]
//     + dz1 * tz1 * (            rsd()(shape + T(0, 0, 1))[(R(0, 0), R(0,0), R(0,0))]
// 			       - 2.0 * rsd()(shape)[(R(0, 0), R(0,0), R(0,0))]
// 			       +           rsd()(shape - T(0, 0, 1))[(R(0, 0), R(0,0), R(0,0))] );
//   frct()(shape)[(R(1,1), R(0,0), R(0,0))] = frct()(shape)[(R(1,1), R(0,0), R(0,0))]
//     + tz3 * C3 * C4 * ( flux()(shape + T(0, 0, 1))[(R(1,1), R(0,0), R(0,0))] - flux()(shape)[(R(1,1), R(0,0), R(0,0))] )
//     + dz2 * tz1 * (            rsd()(shape + T(0, 0, 1))[(R(1,1), R(0,0), R(0,0))]
// 			       - 2.0 * rsd()(shape)[(R(1,1), R(0,0), R(0,0))]
// 			       +           rsd()(shape - T(0, 0, 1))[(R(1,1), R(0,0), R(0,0))] );
//   frct()(shape)[(R(2, 2), R(0,0), R(0,0))] = frct()(shape)[(R(2, 2), R(0,0), R(0,0))]
//     + tz3 * C3 * C4 * ( flux()(shape + T(0, 0, 1))[(R(2, 2), R(0,0), R(0,0))] - flux()(shape)[(R(2, 2), R(0,0), R(0,0))] )
//     + dz3 * tz1 * (            rsd()(shape + T(0, 0, 1))[(R(2, 2), R(0,0), R(0,0))]
// 			     - 2.0 * rsd()(shape)[(R(2, 2), R(0,0), R(0,0))]
// 			       +           rsd()(shape - T(0, 0, 1))[(R(2, 2), R(0,0), R(0,0))] );
//   frct()(shape)[(R(3, 3), R(0,0), R(0,0))] = frct()(shape)[(R(3, 3), R(0,0), R(0,0))]
//     + tz3 * C3 * C4 * ( flux()(shape + T(0, 0, 1))[(R(3, 3), R(0,0), R(0,0))] - flux()(shape)[(R(3, 3), R(0,0), R(0,0))] )
//     + dz4 * tz1 * (            rsd()(shape + T(0, 0, 1))[(R(3, 3), R(0,0), R(0,0))]
// 			       - 2.0 * rsd()(shape)[(R(3, 3), R(0,0), R(0,0))]
// 			       +           rsd()(shape - T(0, 0, 1))[(R(3, 3), R(0,0), R(0,0))] );
//   frct()(shape)[(R(4, 4), R(0,0), R(0,0))] = frct()(shape)[(R(4, 4), R(0,0), R(0,0))]
//     + tz3 * C3 * C4 * ( flux()(shape + T(0, 0, 1))[(R(4, 4), R(0,0), R(0,0))] - flux()(shape)[(R(4, 4), R(0,0), R(0,0))] )
//     + dz5 * tz1 * (            rsd()(shape + T(0, 0, 1))[(R(4, 4), R(0,0), R(0,0))]
// 			       - 2.0 * rsd()(shape)[(R(4, 4), R(0,0), R(0,0))]
// 			       +           rsd()(shape - T(0, 0, 1))[(R(4, 4), R(0,0), R(0,0))] );

//   /*--------------------------------------------------------------------
//     c   fourth-order dissipation
//     --------------------------------------------------------------------*/
//   for (m = 0; m < 5; m++) {
//     frct[i][j][(R(1,1), R(0,0), R(0,0))][m] = frct[i][j][(R(1,1), R(0,0), R(0,0))][m]
//       - dsspm * ( + 5.0 * rsd[i][j][(R(1,1), R(0,0), R(0,0))][m]
// 		  - 4.0 * rsd[i][j][(R(2, 2), R(0,0), R(0,0))][m]
// 		  +           rsd[i][j][(R(3, 3), R(0,0), R(0,0))][m] );
//     frct[i][j][(R(2, 2), R(0,0), R(0,0))][m] = frct[i][j][(R(2, 2), R(0,0), R(0,0))][m]
//       - dsspm * (- 4.0 * rsd[i][j][(R(1,1), R(0,0), R(0,0))][m]
// 		 + 6.0 * rsd[i][j][(R(2, 2), R(0,0), R(0,0))][m]
// 		 - 4.0 * rsd[i][j][(R(3, 3), R(0,0), R(0,0))][m]
// 		 +           rsd[i][j][(R(4, 4), R(0,0), R(0,0))][m] );
//       }
  
//   for (m = 0; m < 5; m++) {
//     frct()(shape)[m] = frct()(shape)[m]
//       - dsspm * (           rsd()(shape - T(0, 0, 2))[m]
// 			    - 4.0 * rsd()(shape - T(0, 0, 1))[m]
// 			    + 6.0 * rsd()(shape)[m]
// 			    - 4.0 * rsd()(shape + T(0, 0, 1))[m]
// 			    +           rsd()(shape + T(0, 0, 2))[m] );
//   }

//   for (m = 0; m < 5; m++) {
//     frct[i][j][nz-3][m] = frct[i][j][nz-3][m]
//       - dsspm * (            rsd[i][j][nz-5][m]
// 			     - 4.0 * rsd[i][j][nz-4][m]
// 			     + 6.0 * rsd[i][j][nz-3][m]
// 			     - 4.0 * rsd[i][j][nz-2][m]  );
//     frct[i][j][nz-2][m] = frct[i][j][nz-2][m]
//       - dsspm * (             rsd[i][j][nz-4][m]
// 			      - 4.0 * rsd[i][j][nz-3][m]
// 			      + 5.0 * rsd[i][j][nz-2][m]  );
//   }  


}




static void exact( int i, int j, int k, double u000ijk[5] ) {

/*--------------------------------------------------------------------
c
c   compute the exact solution at (i,j,k)
c
--------------------------------------------------------------------*/

/*--------------------------------------------------------------------
c  local variables
--------------------------------------------------------------------*/
  int m;
  double xi, eta, zeta;

  xi  = ((double)i) / (double) (ISIZ1 - 1);
  eta  = ((double)j) / (double) (ISIZ2 - 1);
  zeta = ((double)k) / (double) (ISIZ3 - 1);

  for (m = 0; m < 5; m++) {
    u000ijk[m] =  ce[m][0]
      + ce[m][1] * xi
      + ce[m][2] * eta
      + ce[m][3] * zeta
      + ce[m][4] * xi * xi
      + ce[m][5] * eta * eta
      + ce[m][6] * zeta * zeta
      + ce[m][7] * xi * xi * xi
      + ce[m][8] * eta * eta * eta
      + ce[m][9] * zeta * zeta * zeta
      + ce[m][10] * xi * xi * xi * xi
      + ce[m][11] * eta * eta * eta * eta
      + ce[m][12] * zeta * zeta * zeta * zeta;
  }
}


static void exact (int i, int j, int k, HTA<double, 3> h) {

/*--------------------------------------------------------------------
c
c   compute the exact solution at (i,j,k)
c
--------------------------------------------------------------------*/

/*--------------------------------------------------------------------
c  local variables
--------------------------------------------------------------------*/
  int m;
  double xi, eta, zeta;

  xi  = ((double)i) / (double) (ISIZ1 - 1);
  eta  = ((double)j) / (double) (ISIZ2 - 1);
  zeta = ((double)k) / (double) (ISIZ3 - 1);

  for (m = 0; m < 5; m++) {
    h[T(m, 0, 0)] =  ce[m][0]
      + ce[m][1] * xi
      + ce[m][2] * eta
      + ce[m][3] * zeta
      + ce[m][4] * xi * xi
      + ce[m][5] * eta * eta
      + ce[m][6] * zeta * zeta
      + ce[m][7] * xi * xi * xi
      + ce[m][8] * eta * eta * eta
      + ce[m][9] * zeta * zeta * zeta
      + ce[m][10] * xi * xi * xi * xi
      + ce[m][11] * eta * eta * eta * eta
      + ce[m][12] * zeta * zeta * zeta * zeta;
  }
}
