
double  r43;
double  c1345;
double  c34;

template<typename TYPE, int DIM>
struct Jacld{
  
  void operator() (HTA<TYPE, DIM,  Traits::HTA_DEFAULT_TRAIT<double, 3> > u, 
		   HTA<TYPE, DIM,  Traits::HTA_DEFAULT_TRAIT<double, 3> > u0,
		   HTA<TYPE, DIM,  Traits::HTA_DEFAULT_TRAIT<double, 3> > u1,
		   HTA<TYPE, DIM,  Traits::HTA_DEFAULT_TRAIT<double, 3> > u2,
		   HTA<TYPE, DIM,  Traits::HTA_DEFAULT_TRAIT<double, 3> > a,
		   HTA<TYPE, DIM,  Traits::HTA_DEFAULT_TRAIT<double, 3> > b,
		   HTA<TYPE, DIM,  Traits::HTA_DEFAULT_TRAIT<double, 3> > c,
		   HTA<TYPE, DIM,  Traits::HTA_DEFAULT_TRAIT<double, 3> > d) 
  {
    double tmp1, tmp2, tmp3;

    tmp1 = 1.0 / u[T(0, 0, 0)];
    tmp2 = tmp1 * tmp1;
    tmp3 = tmp1 * tmp2;
    
    d[T(0, 0, 0)] =  1.0
      + dt * 2.0 * (   tx1 * dx1
		       + ty1 * dy1
		       + tz1 * dz1 );
    d[T(0, 1, 0)] =  0.0;
    d[T(0, 2, 0)] =  0.0;
    d[T(0, 3, 0)] =  0.0;
    d[T(0, 4, 0)] =  0.0;
    
    d[T(1, 0, 0)] =  dt * 2.0
      * (  tx1 * ( - r43 * c34 * tmp2 * u[T(1, 0, 0)] )
	   + ty1 * ( -       c34 * tmp2 * u[T(1, 0, 0)] )
	   + tz1 * ( -       c34 * tmp2 * u[T(1, 0, 0)] ) );

    //    assert (d[T(1, 0, 0)] != 0);
    
    d[T(1, 1, 0)] =  1.0
      + dt * 2.0 
      * (  tx1 * r43 * c34 * tmp1
	   + ty1 *       c34 * tmp1
	   + tz1 *       c34 * tmp1 )
      + dt * 2.0 * (   tx1 * dx2
		       + ty1 * dy2
		       + tz1 * dz2  );
    d[T(1, 2, 0)] = 0.0;
    d[T(1, 3, 0)] = 0.0;
    d[T(1, 4, 0)] = 0.0;
    
    d[T(2, 0, 0)] = dt * 2.0
      * (  tx1 * ( -       c34 * tmp2 * u[T(2, 0, 0)] )
	   + ty1 * ( - r43 * c34 * tmp2 * u[T(2, 0, 0)] )
	   + tz1 * ( -       c34 * tmp2 * u[T(2, 0, 0)] ) );
    d[T(2, 1, 0)] = 0.0;
    d[T(2, 2, 0)] = 1.0
      + dt * 2.0
	* (  tx1 *       c34 * tmp1
	     + ty1 * r43 * c34 * tmp1
	     + tz1 *       c34 * tmp1 )
      + dt * 2.0 * (  tx1 * dx3
		      + ty1 * dy3
		      + tz1 * dz3 );
    d[T(2, 3, 0)] = 0.0;
      d[T(2, 4, 0)] = 0.0;
      
      d[T(3, 0, 0)] = dt * 2.0
	* (  tx1 * ( -       c34 * tmp2 * u[T(3, 0, 0)] )
	     + ty1 * ( -       c34 * tmp2 * u[T(3, 0, 0)] )
	     + tz1 * ( - r43 * c34 * tmp2 * u[T(3, 0, 0)] ) );
      d[T(3, 1, 0)] = 0.0;
      d[T(3, 2, 0)] = 0.0;
      d[T(3, 3, 0)] = 1.0
	+ dt * 2.0
	* (  tx1 *       c34 * tmp1
	     + ty1 *       c34 * tmp1
	     + tz1 * r43 * c34 * tmp1 )
	+ dt * 2.0 * (  tx1 * dx4
			+ ty1 * dy4
			+ tz1 * dz4 );
      d[T(3, 4, 0)] = 0.0;
      
      d[T(4, 0, 0)] = dt * 2.0
	* ( tx1 * ( - ( r43*c34 - c1345 ) * tmp3 * ( pow2(u[T(1, 0, 0)]) )
		    - ( c34 - c1345 ) * tmp3 * ( pow2(u[T(2, 0, 0)]) )
		    - ( c34 - c1345 ) * tmp3 * ( pow2(u[T(3, 0, 0)]) )
		    - ( c1345 ) * tmp2 * u[T(4, 0, 0)] )
	    + ty1 * ( - ( c34 - c1345 ) * tmp3 * ( pow2(u[T(1, 0, 0)]) )
		      - ( r43*c34 - c1345 ) * tmp3 * ( pow2(u[T(2, 0, 0)]) )
		      - ( c34 - c1345 ) * tmp3 * ( pow2(u[T(3, 0, 0)]) )
		      - ( c1345 ) * tmp2 * u[T(4, 0, 0)] )
	    + tz1 * ( - ( c34 - c1345 ) * tmp3 * ( pow2(u[T(1, 0, 0)]) )
		      - ( c34 - c1345 ) * tmp3 * ( pow2(u[T(2, 0, 0)]) )
		      - ( r43*c34 - c1345 ) * tmp3 * ( pow2(u[T(3, 0, 0)]) )
		      - ( c1345 ) * tmp2 * u[T(4, 0, 0)] ) );
      d[T(4, 1, 0)] = dt * 2.0
	* ( tx1 * ( r43*c34 - c1345 ) * tmp2 * u[T(1, 0, 0)]
	    + ty1 * (     c34 - c1345 ) * tmp2 * u[T(1, 0, 0)]
	    + tz1 * (     c34 - c1345 ) * tmp2 * u[T(1, 0, 0)] );
      d[T(4, 2, 0)] = dt * 2.0
	* ( tx1 * ( c34 - c1345 ) * tmp2 * u[T(2, 0, 0)]
	    + ty1 * ( r43*c34 -c1345 ) * tmp2 * u[T(2, 0, 0)]
	    + tz1 * ( c34 - c1345 ) * tmp2 * u[T(2, 0, 0)] );
      d[T(4, 3, 0)] = dt * 2.0
	* ( tx1 * ( c34 - c1345 ) * tmp2 * u[T(3, 0, 0)]
	    + ty1 * ( c34 - c1345 ) * tmp2 * u[T(3, 0, 0)]
	    + tz1 * ( r43*c34 - c1345 ) * tmp2 * u[T(3, 0, 0)] );
      d[T(4, 4, 0)] = 1.0
	+ dt * 2.0 * ( tx1 * c1345 * tmp1
		       + ty1 * c1345 * tmp1
		       + tz1 * c1345 * tmp1 )
        + dt * 2.0 * (  tx1 * dx5
			+  ty1 * dy5
			+  tz1 * dz5 );

      
    tmp1 = 1.0 / (double) u0[T(0, 0, 0)];
    tmp2 = tmp1 * tmp1;
    tmp3 = tmp1 * tmp2;
    
    a[T(0, 0, 0)] = - dt * tz1 * dz1;
    a[T(0, 1, 0)] =   0.0;
    a[T(0, 2, 0)] =   0.0;
    a[T(0, 3, 0)] = - dt * tz2;
    a[T(0, 4, 0)] =   0.0;
    
    a[T(1, 0, 0)] = - dt * tz2
      * ( - ( u0[T(1, 0, 0)]*u0[T(3, 0, 0)] ) * tmp2 )
      - dt * tz1 * ( - c34 * tmp2 * u0[T(1, 0, 0)] );
    a[T(1, 1, 0)] = - dt * tz2 * ( u0[T(3, 0, 0)] * tmp1 )
      - dt * tz1 * c34 * tmp1
      - dt * tz1 * dz2 ;
    a[T(1, 2, 0)] = 0.0;
    a[T(1, 3, 0)] = - dt * tz2 * ( u0[T(1, 0, 0)] * tmp1 );
    a[T(1, 4, 0)] = 0.0;
    
    a[T(2, 0, 0)] = - dt * tz2
      * ( - ( u0[T(2, 0, 0)]*u0[T(3, 0, 0)] ) * tmp2 )
      - dt * tz1 * ( - c34 * tmp2 * u0[T(2, 0, 0)] );
    a[T(2, 1, 0)] = 0.0;
    a[T(2, 2, 0)] = - dt * tz2 * ( u0[T(3, 0, 0)] * tmp1 )
      - dt * tz1 * ( c34 * tmp1 )
      - dt * tz1 * dz3;
    a[T(2, 3, 0)] = - dt * tz2 * ( u0[T(2, 0, 0)] * tmp1 );
    a[T(2, 4, 0)] = 0.0;
    
    a[T(3, 0, 0)] = - dt * tz2
      * ( - ( u0[T(3, 0, 0)] * tmp1 ) *( u0[T(3, 0, 0)] * tmp1 )
	  + 0.50 * C2
	  * ( ( u0[T(1, 0, 0)] * u0[T(1, 0, 0)]
		+ u0[T(2, 0, 0)] * u0[T(2, 0, 0)]
		+ u0[T(3, 0, 0)] * u0[T(3, 0, 0)] ) * tmp2 ) )
      - dt * tz1 * ( - r43 * c34 * tmp2 * u0[T(3, 0, 0)] );
    a[T(3, 1, 0)] = - dt * tz2
      * ( - C2 * ( u0[T(1, 0, 0)] * tmp1 ) );
    a[T(3, 2, 0)] = - dt * tz2
      * ( - C2 * ( u0[T(2, 0, 0)] * tmp1 ) );
    a[T(3, 3, 0)] = - dt * tz2 * ( 2.0 - C2 )
      * ( u0[T(3, 0, 0)] * tmp1 )
      - dt * tz1 * ( r43 * c34 * tmp1 )
      - dt * tz1 * dz4;
    a[T(3, 4, 0)] = - dt * tz2 * C2;
    
    a[T(4, 0, 0)] = - dt * tz2
      * ( ( C2 * (  u0[T(1, 0, 0)] * u0[T(1, 0, 0)]
		    + u0[T(2, 0, 0)] * u0[T(2, 0, 0)]
		    + u0[T(3, 0, 0)] * u0[T(3, 0, 0)] ) * tmp2
	    - C1 * ( u0[T(4, 0, 0)] * tmp1 ) )
	  * ( u0[T(3, 0, 0)] * tmp1 ) )
      - dt * tz1
      * ( - ( c34 - c1345 ) * tmp3 * (u0[T(1, 0, 0)]*u0[T(1, 0, 0)])
	  - ( c34 - c1345 ) * tmp3 * (u0[T(2, 0, 0)]*u0[T(2, 0, 0)])
	  - ( r43*c34 - c1345 )* tmp3 * (u0[T(3, 0, 0)]*u0[T(3, 0, 0)])
	    - c1345 * tmp2 * u0[T(4, 0, 0)] );
    a[T(4, 1, 0)] = - dt * tz2
      * ( - C2 * ( u0[T(1, 0, 0)]*u0[T(3, 0, 0)] ) * tmp2 )
      - dt * tz1 * ( c34 - c1345 ) * tmp2 * u0[T(1, 0, 0)];
    a[T(4, 2, 0)] = - dt * tz2
      * ( - C2 * ( u0[T(2, 0, 0)]*u0[T(3, 0, 0)] ) * tmp2 )
      - dt * tz1 * ( c34 - c1345 ) * tmp2 * u0[T(2, 0, 0)];
      a[T(4, 3, 0)] = - dt * tz2
	* ( C1 * ( u0[T(4, 0, 0)] * tmp1 )
            - 0.50 * C2
            * ( (  u0[T(1, 0, 0)]*u0[T(1, 0, 0)]
		   + u0[T(2, 0, 0)]*u0[T(2, 0, 0)]
		   + 3.0*u0[T(3, 0, 0)]*u0[T(3, 0, 0)] ) * tmp2 ) )
	- dt * tz1 * ( r43*c34 - c1345 ) * tmp2 * u0[T(3, 0, 0)];
      a[T(4, 4, 0)] = - dt * tz2
	* ( C1 * ( u0[T(3, 0, 0)] * tmp1 ) )
	- dt * tz1 * c1345 * tmp1
	- dt * tz1 * dz5;
 

    tmp1 = 1.0 / u1[T(0, 0, 0)];
      tmp2 = tmp1 * tmp1;
      tmp3 = tmp1 * tmp2;

      b[T(0, 0, 0)] = - dt * ty1 * dy1;
      b[T(0, 1, 0)] =   0.0;
      b[T(0, 2, 0)] = - dt * ty2;
      b[T(0, 3, 0)] =   0.0;
      b[T(0, 4, 0)] =   0.0;

      b[T(1, 0, 0)] = - dt * ty2
	* ( - ( u1[T(1, 0, 0)]*u1[T(2, 0, 0)] ) * tmp2 )
	- dt * ty1 * ( - c34 * tmp2 * u1[T(1, 0, 0)] );
      b[T(1, 1, 0)] = - dt * ty2 * ( u1[T(2, 0, 0)] * tmp1)
	- dt * ty1 * ( c34 * tmp1 )
	- dt * ty1 * dy2;
      b[T(1, 2, 0)] = - dt * ty2 * ( u1[T(1, 0, 0)] * tmp1 );
      b[T(1, 3, 0)] = 0.0;
      b[T(1, 4, 0)] = 0.0;

      b[T(2, 0, 0)] = - dt * ty2
	* ( - ( u1[T(2, 0, 0)] * tmp1 ) *( u1[T(2, 0, 0)] * tmp1 )
	    + 0.50 * C2 * ( (  u1[T(1, 0, 0)] * u1[T(1, 0, 0)]
			       + u1[T(2, 0, 0)] * u1[T(2, 0, 0)]
			       + u1[T(3, 0, 0)] * u1[T(3, 0, 0)] )
			    * tmp2 ) )
	- dt * ty1 * ( - r43 * c34 * tmp2 * u1[T(2, 0, 0)] );
      b[T(2, 1, 0)] = - dt * ty2
	* ( - C2 * ( u1[T(1, 0, 0)] * tmp1 ) );
      b[T(2, 2, 0)] = - dt * ty2 * ( ( 2.0 - C2 )
				  * ( u1[T(2, 0, 0)] * tmp1 ) )
	- dt * ty1 * ( r43 * c34 * tmp1 )
	- dt * ty1 * dy3;
      b[T(2, 3, 0)] = - dt * ty2
	* ( - C2 * ( u1[T(3, 0, 0)] * tmp1 ) );
      b[T(2, 4, 0)] = - dt * ty2 * C2;

      b[T(3, 0, 0)] = - dt * ty2
	* ( - ( u1[T(2, 0, 0)]*u1[T(3, 0, 0)] ) * tmp2 )
	- dt * ty1 * ( - c34 * tmp2 * u1[T(3, 0, 0)] );
      b[T(3, 1, 0)] = 0.0;
      b[T(3, 2, 0)] = - dt * ty2 * ( u1[T(3, 0, 0)] * tmp1 );
      b[T(3, 3, 0)] = - dt * ty2 * ( u1[T(2, 0, 0)] * tmp1 )
	- dt * ty1 * ( c34 * tmp1 )
	- dt * ty1 * dy4;
      b[T(3, 4, 0)] = 0.0;

      b[T(4, 0, 0)] = - dt * ty2
	* ( ( C2 * (  u1[T(1, 0, 0)] * u1[T(1, 0, 0)]
		      + u1[T(2, 0, 0)] * u1[T(2, 0, 0)]
		      + u1[T(3, 0, 0)] * u1[T(3, 0, 0)] ) * tmp2
	      - C1 * ( u1[T(4, 0, 0)] * tmp1 ) )
	    * ( u1[T(2, 0, 0)] * tmp1 ) )
	- dt * ty1
	* ( - (     c34 - c1345 )*tmp3*(pow2(u1[T(1, 0, 0)]))
	    - ( r43*c34 - c1345 )*tmp3*(pow2(u1[T(2, 0, 0)]))
	    - (     c34 - c1345 )*tmp3*(pow2(u1[T(3, 0, 0)]))
	    - c1345*tmp2*u1[T(4, 0, 0)] );
      b[T(4, 1, 0)] = - dt * ty2
	* ( - C2 * ( u1[T(1, 0, 0)]*u1[T(2, 0, 0)] ) * tmp2 )
	- dt * ty1
	* ( c34 - c1345 ) * tmp2 * u1[T(1, 0, 0)];
      b[T(4, 2, 0)] = - dt * ty2
	* ( C1 * ( u1[T(4, 0, 0)] * tmp1 )
	    - 0.50 * C2 
	    * ( (  u1[T(1, 0, 0)]*u1[T(1, 0, 0)]
                   + 3.0 * u1[T(2, 0, 0)]*u1[T(2, 0, 0)]
		   + u1[T(3, 0, 0)]*u1[T(3, 0, 0)] ) * tmp2 ) )
	- dt * ty1
	* ( r43*c34 - c1345 ) * tmp2 * u1[T(2, 0, 0)];
      b[T(4, 3, 0)] = - dt * ty2
	* ( - C2 * ( u1[T(2, 0, 0)]*u1[T(3, 0, 0)] ) * tmp2 )
	- dt * ty1 * ( c34 - c1345 ) * tmp2 * u1[T(3, 0, 0)];
      b[T(4, 4, 0)] = - dt * ty2
	* ( C1 * ( u1[T(2, 0, 0)] * tmp1 ) )
	- dt * ty1 * c1345 * tmp1
	- dt * ty1 * dy5;
          
    tmp1 = 1.0 / u2[T(0, 0, 0)];
    tmp2 = tmp1 * tmp1;
    tmp3 = tmp1 * tmp2;
    
    c[T(0, 0, 0)] = - dt * tx1 * dx1;
    c[T(0, 1, 0)] = - dt * tx2;
    c[T(0, 2, 0)] =   0.0;
    c[T(0, 3, 0)] =   0.0;
    c[T(0, 4, 0)] =   0.0;
    
    c[T(1, 0, 0)] = - dt * tx2
      * ( - ( u2[T(1, 0, 0)] * tmp1 ) *( u2[T(1, 0, 0)] * tmp1 )
	  + C2 * 0.50 * (  u2[T(1, 0, 0)] * u2[T(1, 0, 0)]
			   + u2[T(2, 0, 0)] * u2[T(2, 0, 0)]
			   + u2[T(3, 0, 0)] * u2[T(3, 0, 0)] ) * tmp2 )
      - dt * tx1 * ( - r43 * c34 * tmp2 * u2[T(1, 0, 0)] );
    c[T(1, 1, 0)] = - dt * tx2
      * ( ( 2.0 - C2 ) * ( u2[T(1, 0, 0)] * tmp1 ) )
      - dt * tx1 * ( r43 * c34 * tmp1 )
      - dt * tx1 * dx2;
    c[T(1, 2, 0)] = - dt * tx2
      * ( - C2 * ( u2[T(2, 0, 0)] * tmp1 ) );
    c[T(1, 3, 0)] = - dt * tx2
      * ( - C2 * ( u2[T(3, 0, 0)] * tmp1 ) );
    c[T(1, 4, 0)] = - dt * tx2 * C2;
    
    c[T(2, 0, 0)] = - dt * tx2
      * ( - ( u2[T(1, 0, 0)] * u2[T(2, 0, 0)] ) * tmp2 )
      - dt * tx1 * ( - c34 * tmp2 * u2[T(2, 0, 0)] );
    c[T(2, 1, 0)] = - dt * tx2 * ( u2[T(2, 0, 0)] * tmp1);
    c[T(2, 2, 0)] = - dt * tx2 * ( u2[T(1, 0, 0)] * tmp1)
      - dt * tx1 * ( c34 * tmp1 )
      - dt * tx1 * dx3;
    c[T(2, 3, 0)] = 0.0;
    c[T(2, 4, 0)] = 0.0;
    
    c[T(3, 0, 0)] = - dt * tx2
      * ( - ( u2[T(1, 0, 0)]*u2[T(3, 0, 0)] ) * tmp2 )
      - dt * tx1 * ( - c34 * tmp2 * u2[T(3, 0, 0)] );
    c[T(3, 1, 0)] = - dt * tx2 * ( u2[T(3, 0, 0)] * tmp1);
    c[T(3, 2, 0)] = 0.0;
    c[T(3, 3, 0)] = - dt * tx2 * ( u2[T(1, 0, 0)] * tmp1)
      - dt * tx1 * ( c34 * tmp1 )
      - dt * tx1 * dx4;
    c[T(3, 4, 0)] = 0.0;
    
    c[T(4, 0, 0)] = - dt * tx2
      * ( ( C2 * (  u2[T(1, 0, 0)] * u2[T(1, 0, 0)]
		    + u2[T(2, 0, 0)] * u2[T(2, 0, 0)]
		    + u2[T(3, 0, 0)] * u2[T(3, 0, 0)] ) * tmp2
	    - C1 * ( u2[T(4, 0, 0)] * tmp1 ) )
	  * ( u2[T(1, 0, 0)] * tmp1 ) )
      - dt * tx1
      * ( - ( r43*c34 - c1345 ) * tmp3 * ( pow2(u2[T(1, 0, 0)]) )
	  - (     c34 - c1345 ) * tmp3 * ( pow2(u2[T(2, 0, 0)]) )
	  - (     c34 - c1345 ) * tmp3 * ( pow2(u2[T(3, 0, 0)]) )
	  - c1345 * tmp2 * u2[T(4, 0, 0)] );
    c[T(4, 1, 0)] = - dt * tx2
      * ( C1 * ( u2[T(4, 0, 0)] * tmp1 )
	  - 0.50 * C2
	  * ( (  3.0*u2[T(1, 0, 0)]*u2[T(1, 0, 0)]
		 + u2[T(2, 0, 0)]*u2[T(2, 0, 0)]
		 + u2[T(3, 0, 0)]*u2[T(3, 0, 0)] ) * tmp2 ) )
      - dt * tx1
      * ( r43*c34 - c1345 ) * tmp2 * u2[T(1, 0, 0)];
    c[T(4, 2, 0)] = - dt * tx2
      * ( - C2 * ( u2[T(2, 0, 0)]*u2[T(1, 0, 0)] ) * tmp2 )
      - dt * tx1
      * (  c34 - c1345 ) * tmp2 * u2[T(2, 0, 0)];
    c[T(4, 3, 0)] = - dt * tx2
      * ( - C2 * ( u2[T(3, 0, 0)]*u2[T(1, 0, 0)] ) * tmp2 )
      - dt * tx1
      * (  c34 - c1345 ) * tmp2 * u2[T(3, 0, 0)];
    c[T(4, 4, 0)] = - dt * tx2
      * ( C1 * ( u2[T(1, 0, 0)] * tmp1 ) )
      - dt * tx1 * c1345 * tmp1
      - dt * tx1 * dx5;  
  }
};


void jacld (HTA_2H u, HTA_2H a, HTA_2H b, HTA_2H c, HTA_2H d,
	    bool* mask)
{
/*--------------------------------------------------------------------
c   compute the lower triangular part of the jacobian matrix
--------------------------------------------------------------------*/

/*--------------------------------------------------------------------
c  local variables
--------------------------------------------------------------------*/
  int i, j; 

  r43 = ( 4.0 / 3.0 );
  c1345 = C1 * C3 * C4 * C5;
  c34 = C3 * C4;
  
 
  u()(iShape).hmap(Jacld<double, 3>(),
		  u()(iShape - T(0, 0, 1)),
		  u()(iShape - T(0, 1, 0)),
		  u()(iShape - T(1, 0, 0)),
		  a()(iShape),
		  b()(iShape),
		  c()(iShape),
		  d()(iShape),
		  0,
		  mask);
}
