
template<typename TYPE, int DIM>
struct InitD0 {
  
  void operator() ( HTA<TYPE, DIM,  Traits::HTA_DEFAULT_TRAIT<double, 3> > d, 
		      HTA<TYPE, DIM,  Traits::HTA_DEFAULT_TRAIT<double, 3> > u) 
  {
    double tmp1, tmp2, tmp3;
    
      tmp1 = 1.0 / u[T(0, 0, 0)];
      tmp2 = tmp1 * tmp1;
      tmp3 = tmp1 * tmp2;

      d[T(0, 0, 0)] =  1.0
	+ dt * 2.0 * (   tx1 * dx1
			 + ty1 * dy1
			 + tz1 * dz1 );
      d[T(0, 1, 0)] =  0.0;
      d[T(0, 2, 0)] =  0.0;
      d[T(0, 3, 0)] =  0.0;
      d[T(0, 4, 0)] =  0.0;

      d[T(1, 0, 0)] =  dt * 2.0
	* (  tx1 * ( - r43 * c34 * tmp2 * u[T(1, 0, 0)] )
	     + ty1 * ( -       c34 * tmp2 * u[T(1, 0, 0)] )
	     + tz1 * ( -       c34 * tmp2 * u[T(1, 0, 0)] ) );
      d[T(1, 1, 0)] =  1.0
	+ dt * 2.0 
	* (  tx1 * r43 * c34 * tmp1
	     + ty1 *       c34 * tmp1
	     + tz1 *       c34 * tmp1 )
	+ dt * 2.0 * (   tx1 * dx2
			 + ty1 * dy2
			 + tz1 * dz2  );
     d[T(1, 2, 0)] = 0.0;
      d[T(1, 3, 0)] = 0.0;
      d[T(1, 4, 0)] = 0.0;

      d[T(2, 0, 0)] = dt * 2.0
	* (  tx1 * ( -       c34 * tmp2 * u[T(2, 0, 0)] )
	     + ty1 * ( - r43 * c34 * tmp2 * u[T(2, 0, 0)] )
	     + tz1 * ( -       c34 * tmp2 * u[T(2, 0, 0)] ) );
      d[T(2, 1, 0)] = 0.0;
      d[T(2, 2, 0)] = 1.0
	+ dt * 2.0
	* (  tx1 *       c34 * tmp1
	     + ty1 * r43 * c34 * tmp1
	     + tz1 *       c34 * tmp1 )
	+ dt * 2.0 * (  tx1 * dx3
			+ ty1 * dy3
			+ tz1 * dz3 );
      d[T(2, 3, 0)] = 0.0;
      d[T(2, 4, 0)] = 0.0;

      d[T(3, 0, 0)] = dt * 2.0
	* (  tx1 * ( -       c34 * tmp2 * u[T(3, 0, 0)] )
	     + ty1 * ( -       c34 * tmp2 * u[T(3, 0, 0)] )
	     + tz1 * ( - r43 * c34 * tmp2 * u[T(3, 0, 0)] ) );
      d[T(3, 1, 0)] = 0.0;
      d[T(3, 2, 0)] = 0.0;
      d[T(3, 3, 0)] = 1.0
	+ dt * 2.0
	* (  tx1 *       c34 * tmp1
	     + ty1 *       c34 * tmp1
	     + tz1 * r43 * c34 * tmp1 )
	+ dt * 2.0 * (  tx1 * dx4
			+ ty1 * dy4
			+ tz1 * dz4 );
      d[T(3, 4, 0)] = 0.0;

      d[T(4, 0, 0)] = dt * 2.0
	* ( tx1 * ( - ( r43*c34 - c1345 ) * tmp3 * ( pow2(u[T(1, 0, 0)]) )
		    - ( c34 - c1345 ) * tmp3 * ( pow2(u[T(2, 0, 0)]) )
		    - ( c34 - c1345 ) * tmp3 * ( pow2(u[T(3, 0, 0)]) )
		    - ( c1345 ) * tmp2 * u[T(4, 0, 0)] )
	    + ty1 * ( - ( c34 - c1345 ) * tmp3 * ( pow2(u[T(1, 0, 0)]) )
		      - ( r43*c34 - c1345 ) * tmp3 * ( pow2(u[T(2, 0, 0)]) )
		      - ( c34 - c1345 ) * tmp3 * ( pow2(u[T(3, 0, 0)]) )
		      - ( c1345 ) * tmp2 * u[T(4, 0, 0)] )
	    + tz1 * ( - ( c34 - c1345 ) * tmp3 * ( pow2(u[T(1, 0, 0)]) )
		      - ( c34 - c1345 ) * tmp3 * ( pow2(u[T(2, 0, 0)]) )
		      - ( r43*c34 - c1345 ) * tmp3 * ( pow2(u[T(3, 0, 0)]) )
		      - ( c1345 ) * tmp2 * u[T(4, 0, 0)] ) );
      d[T(4, 1, 0)] = dt * 2.0
	* ( tx1 * ( r43*c34 - c1345 ) * tmp2 * u[T(1, 0, 0)]
	    + ty1 * (     c34 - c1345 ) * tmp2 * u[T(1, 0, 0)]
	    + tz1 * (     c34 - c1345 ) * tmp2 * u[T(1, 0, 0)] );
      d[T(4, 2, 0)] = dt * 2.0
	* ( tx1 * ( c34 - c1345 ) * tmp2 * u[T(2, 0, 0)]
	    + ty1 * ( r43*c34 -c1345 ) * tmp2 * u[T(2, 0, 0)]
	    + tz1 * ( c34 - c1345 ) * tmp2 * u[T(2, 0, 0)] );
      d[T(4, 3, 0)] = dt * 2.0
	* ( tx1 * ( c34 - c1345 ) * tmp2 * u[T(3, 0, 0)]
	    + ty1 * ( c34 - c1345 ) * tmp2 * u[T(3, 0, 0)]
	    + tz1 * ( r43*c34 - c1345 ) * tmp2 * u[T(3, 0, 0)] );
      d[T(4, 4, 0)] = 1.0
        + dt * 2.0 * ( tx1 * c1345 * tmp1
		       + ty1 * c1345 * tmp1
		       + tz1 * c1345 * tmp1 )
        + dt * 2.0 * (  tx1 * dx5
			+  ty1 * dy5
			+  tz1 * dz5 );
  
  }
      
        
        
        
};
 
template<typename TYPE, int DIM>
struct InitA0 {
  
      
 
          
        
  void operator() ( HTA<TYPE, DIM,  Traits::HTA_DEFAULT_TRAIT<double, 3> > a, 
		      HTA<TYPE, DIM,  Traits::HTA_DEFAULT_TRAIT<double, 3> > u) 
  { 

    double tmp1, tmp2, tmp3;
    
    tmp1 = 1.0 / u[T(0, 0, 0)];
    tmp2 = tmp1 * tmp1;
    tmp3 = tmp1 * tmp2;
    
    a[T(0, 0, 0)] = - dt * tx1 * dx1;
    a[T(0, 1, 0)] =   dt * tx2;
    a[T(0, 2, 0)] =   0.0;
    a[T(0, 3, 0)] =   0.0;
    a[T(0, 4, 0)] =   0.0;
    
    a[T(1, 0, 0)] =  dt * tx2
      * ( - ( u[T(1, 0, 0)] * tmp1 ) *( u[T(1, 0, 0)] * tmp1 )
	  + C2 * 0.50 * (  u[T(1, 0, 0)] * u[T(1, 0, 0)]
			   + u[T(2, 0, 0)] * u[T(2, 0, 0)]
			   + u[T(3, 0, 0)] * u[T(3, 0, 0)] ) * tmp2 )
      - dt * tx1 * ( - r43 * c34 * tmp2 * u[T(1, 0, 0)] );
    a[T(1, 1, 0)] =  dt * tx2
      * ( ( 2.0 - C2 ) * ( u[T(1, 0, 0)] * tmp1 ) )
      - dt * tx1 * ( r43 * c34 * tmp1 )
      - dt * tx1 * dx2;
    a[T(1, 2, 0)] =  dt * tx2
      * ( - C2 * ( u[T(2, 0, 0)] * tmp1 ) );
    a[T(1, 3, 0)] =  dt * tx2
      * ( - C2 * ( u[T(3, 0, 0)] * tmp1 ) );
    a[T(1, 4, 0)] =  dt * tx2 * C2 ;
    
    a[T(2, 0, 0)] =  dt * tx2
      * ( - ( u[T(1, 0, 0)] * u[T(2, 0, 0)] ) * tmp2 )
      - dt * tx1 * ( - c34 * tmp2 * u[T(2, 0, 0)] );
    a[T(2, 1, 0)] =  dt * tx2 * ( u[T(2, 0, 0)] * tmp1 );
    a[T(2, 2, 0)] =  dt * tx2 * ( u[T(1, 0, 0)] * tmp1 )
      - dt * tx1 * ( c34 * tmp1 )
      - dt * tx1 * dx3;
    a[T(2, 3, 0)] = 0.0;
    a[T(2, 4, 0)] = 0.0;
    
    a[T(3, 0, 0)] = dt * tx2
      * ( - ( u[T(1, 0, 0)]*u[T(3, 0, 0)] ) * tmp2 )
      - dt * tx1 * ( - c34 * tmp2 * u[T(3, 0, 0)] );
    a[T(3, 1, 0)] = dt * tx2 * ( u[T(3, 0, 0)] * tmp1 );
    a[T(3, 2, 0)] = 0.0;
    a[T(3, 3, 0)] = dt * tx2 * ( u[T(1, 0, 0)] * tmp1 )
      - dt * tx1 * ( c34 * tmp1 )
      - dt * tx1 * dx4;
    a[T(3, 4, 0)] = 0.0;
    
    a[T(4, 0, 0)] = dt * tx2
      * ( ( C2 * (  u[T(1, 0, 0)] * u[T(1, 0, 0)]
		    + u[T(2, 0, 0)] * u[T(2, 0, 0)]
		    + u[T(3, 0, 0)] * u[T(3, 0, 0)] ) * tmp2
	    - C1 * ( u[T(4, 0, 0)] * tmp1 ) )
	  * ( u[T(1, 0, 0)] * tmp1 ) )
      - dt * tx1
      * ( - ( r43*c34 - c1345 ) * tmp3 * ( pow2(u[T(1, 0, 0)]) )
	  - (     c34 - c1345 ) * tmp3 * ( pow2(u[T(2, 0, 0)]) )
	  - (     c34 - c1345 ) * tmp3 * ( pow2(u[T(3, 0, 0)]) )
	  - c1345 * tmp2 * u[T(4, 0, 0)] );
    a[T(4, 1, 0)] = dt * tx2
      * ( C1 * ( u[T(4, 0, 0)] * tmp1 )
	  - 0.50 * C2
	  * ( (  3.0*u[T(1, 0, 0)]*u[T(1, 0, 0)]
		 + u[T(2, 0, 0)]*u[T(2, 0, 0)]
		 + u[T(3, 0, 0)]*u[T(3, 0, 0)] ) * tmp2 ) )
      - dt * tx1
      * ( r43*c34 - c1345 ) * tmp2 * u[T(1, 0, 0)];
    a[T(4, 2, 0)] = dt * tx2
      * ( - C2 * ( u[T(2, 0, 0)]*u[T(1, 0, 0)] ) * tmp2 )
      - dt * tx1
      * (  c34 - c1345 ) * tmp2 * u[T(2, 0, 0)];
    a[T(4, 3, 0)] = dt * tx2
      * ( - C2 * ( u[T(3, 0, 0)]*u[T(1, 0, 0)] ) * tmp2 )
      - dt * tx1
	* (  c34 - c1345 ) * tmp2 * u[T(3, 0, 0)];
    a[T(4, 4, 0)] = dt * tx2
	* ( C1 * ( u[T(1, 0, 0)] * tmp1 ) )
      - dt * tx1 * c1345 * tmp1
      - dt * tx1 * dx5;
  }
  
        
        
        
};
 
template<typename TYPE, int DIM>
struct InitB0  {
  
      
 
          
        
  void operator() ( HTA<TYPE, DIM,  Traits::HTA_DEFAULT_TRAIT<double, 3> > b, 
		      HTA<TYPE, DIM,  Traits::HTA_DEFAULT_TRAIT<double, 3> > u) 
  {

    double tmp1, tmp2, tmp3;
    
     tmp1 = 1.0 / u[T(0, 0, 0)];
      tmp2 = tmp1 * tmp1;
      tmp3 = tmp1 * tmp2;

      b[T(0, 0, 0)] = - dt * ty1 * dy1;
      b[T(0, 1, 0)] =   0.0;
      b[T(0, 2, 0)] =  dt * ty2;
      b[T(0, 3, 0)] =   0.0;
      b[T(0, 4, 0)] =   0.0;

      b[T(1, 0, 0)] =  dt * ty2
	* ( - ( u[T(1, 0, 0)]*u[T(2, 0, 0)] ) * tmp2 )
	- dt * ty1 * ( - c34 * tmp2 * u[T(1, 0, 0)] );
      b[T(1, 1, 0)] =  dt * ty2 * ( u[T(2, 0, 0)] * tmp1 )
	- dt * ty1 * ( c34 * tmp1 )
	- dt * ty1 * dy2;
      b[T(1, 2, 0)] =  dt * ty2 * ( u[T(1, 0, 0)] * tmp1 );
      b[T(1, 3, 0)] = 0.0;
      b[T(1, 4, 0)] = 0.0;

      b[T(2, 0, 0)] =  dt * ty2
	* ( - ( u[T(2, 0, 0)] * tmp1 ) *( u[T(2, 0, 0)] * tmp1 )
	    + 0.50 * C2 * ( (  u[T(1, 0, 0)] * u[T(1, 0, 0)]
			       + u[T(2, 0, 0)] * u[T(2, 0, 0)]
			       + u[T(3, 0, 0)] * u[T(3, 0, 0)] )
			    * tmp2 ) )
	- dt * ty1 * ( - r43 * c34 * tmp2 * u[T(2, 0, 0)] );
      b[T(2, 1, 0)] =  dt * ty2
	* ( - C2 * ( u[T(1, 0, 0)] * tmp1 ) );
      b[T(2, 2, 0)] =  dt * ty2 * ( ( 2.0 - C2 )
				 * ( u[T(2, 0, 0)] * tmp1 ) )
	- dt * ty1 * ( r43 * c34 * tmp1 )
	- dt * ty1 * dy3;
      b[T(2, 3, 0)] =  dt * ty2
	* ( - C2 * ( u[T(3, 0, 0)] * tmp1 ) );
      b[T(2, 4, 0)] =  dt * ty2 * C2;

      b[T(3, 0, 0)] =  dt * ty2
	* ( - ( u[T(2, 0, 0)]*u[T(3, 0, 0)] ) * tmp2 )
	- dt * ty1 * ( - c34 * tmp2 * u[T(3, 0, 0)] );
      b[T(3, 1, 0)] = 0.0;
      b[T(3, 2, 0)] =  dt * ty2 * ( u[T(3, 0, 0)] * tmp1 );
      b[T(3, 3, 0)] =  dt * ty2 * ( u[T(2, 0, 0)] * tmp1 )
	- dt * ty1 * ( c34 * tmp1 )
	- dt * ty1 * dy4;
      b[T(3, 4, 0)] = 0.0;

      b[T(4, 0, 0)] =  dt * ty2
	* ( ( C2 * (  u[T(1, 0, 0)] * u[T(1, 0, 0)]
		      + u[T(2, 0, 0)] * u[T(2, 0, 0)]
		      + u[T(3, 0, 0)] * u[T(3, 0, 0)] ) * tmp2
	      - C1 * ( u[T(4, 0, 0)] * tmp1 ) )
	    * ( u[T(2, 0, 0)] * tmp1 ) )
	- dt * ty1
	* ( - (     c34 - c1345 )*tmp3*( pow2(u[T(1, 0, 0)]) )
	    - ( r43*c34 - c1345 )*tmp3*( pow2(u[T(2, 0, 0)]) )
	    - (     c34 - c1345 )*tmp3*( pow2(u[T(3, 0, 0)]) )
	    - c1345*tmp2*u[T(4, 0, 0)] );
      b[T(4, 1, 0)] =  dt * ty2
	* ( - C2 * ( u[T(1, 0, 0)]*u[T(2, 0, 0)] ) * tmp2 )
	- dt * ty1
	* ( c34 - c1345 ) * tmp2 * u[T(1, 0, 0)];
      b[T(4, 2, 0)] =  dt * ty2
	* ( C1 * ( u[T(4, 0, 0)] * tmp1 )
	    - 0.50 * C2 
	    * ( (  u[T(1, 0, 0)]*u[T(1, 0, 0)]
		   + 3.0 * u[T(2, 0, 0)]*u[T(2, 0, 0)]
		   + u[T(3, 0, 0)]*u[T(3, 0, 0)] ) * tmp2 ) )
	- dt * ty1
	* ( r43*c34 - c1345 ) * tmp2 * u[T(2, 0, 0)];
      b[T(4, 3, 0)] =  dt * ty2
	* ( - C2 * ( u[T(2, 0, 0)]*u[T(3, 0, 0)] ) * tmp2 )
	- dt * ty1 * ( c34 - c1345 ) * tmp2 * u[T(3, 0, 0)];
      b[T(4, 4, 0)] =  dt * ty2
	* ( C1 * ( u[T(2, 0, 0)] * tmp1 ) )
	- dt * ty1 * c1345 * tmp1
	- dt * ty1 * dy5;
  }
      
        
        
        
};
 
template<typename TYPE, int DIM>
struct InitC0  {
  
      
 
          
        
  void operator() ( HTA<TYPE, DIM,  Traits::HTA_DEFAULT_TRAIT<double, 3> > c, 
		       HTA<TYPE, DIM,  Traits::HTA_DEFAULT_TRAIT<double, 3> > u) 
  {
    double tmp1, tmp2, tmp3;
    
    tmp1 = 1.0 / u[T(0, 0, 0)];
    tmp2 = tmp1 * tmp1;
    tmp3 = tmp1 * tmp2;
    
    c[T(0, 0, 0)] = - dt * tz1 * dz1;
    c[T(0, 1, 0)] =   0.0;
    c[T(0, 2, 0)] =   0.0;
    c[T(0, 3, 0)] = dt * tz2;
    c[T(0, 4, 0)] =   0.0;
    
    c[T(1, 0, 0)] = dt * tz2
      * ( - ( u[T(1, 0, 0)]*u[T(3, 0, 0)] ) * tmp2 )
      - dt * tz1 * ( - c34 * tmp2 * u[T(1, 0, 0)] );
    c[T(1, 1, 0)] = dt * tz2 * ( u[T(3, 0, 0)] * tmp1 )
      - dt * tz1 * c34 * tmp1
      - dt * tz1 * dz2 ;
    c[T(1, 2, 0)] = 0.0;
      c[T(1, 3, 0)] = dt * tz2 * ( u[T(1, 0, 0)] * tmp1 );
      c[T(1, 4, 0)] = 0.0;

      c[T(2, 0, 0)] = dt * tz2
	* ( - ( u[T(2, 0, 0)]*u[T(3, 0, 0)] ) * tmp2 )
	- dt * tz1 * ( - c34 * tmp2 * u[T(2, 0, 0)] );
      c[T(2, 1, 0)] = 0.0;
      c[T(2, 2, 0)] = dt * tz2 * ( u[T(3, 0, 0)] * tmp1 )
	- dt * tz1 * ( c34 * tmp1 )
	- dt * tz1 * dz3;
      c[T(2, 3, 0)] = dt * tz2 * ( u[T(2, 0, 0)] * tmp1 );
      c[T(2, 4, 0)] = 0.0;

      c[T(3, 0, 0)] = dt * tz2
	* ( - ( u[T(3, 0, 0)] * tmp1 ) *( u[T(3, 0, 0)] * tmp1 )
	    + 0.50 * C2
	    * ( ( u[T(1, 0, 0)] * u[T(1, 0, 0)]
		  + u[T(2, 0, 0)] * u[T(2, 0, 0)]
		  + u[T(3, 0, 0)] * u[T(3, 0, 0)] ) * tmp2 ) )
	- dt * tz1 * ( - r43 * c34 * tmp2 * u[T(3, 0, 0)] );
      c[T(3, 1, 0)] = dt * tz2
	* ( - C2 * ( u[T(1, 0, 0)] * tmp1 ) );
      c[T(3, 2, 0)] = dt * tz2
	* ( - C2 * ( u[T(2, 0, 0)] * tmp1 ) );
      c[T(3, 3, 0)] = dt * tz2 * ( 2.0 - C2 )
	* ( u[T(3, 0, 0)] * tmp1 )
	- dt * tz1 * ( r43 * c34 * tmp1 )
	- dt * tz1 * dz4;
      c[T(3, 4, 0)] = dt * tz2 * C2;

      c[T(4, 0, 0)] = dt * tz2
	* ( ( C2 * (  u[T(1, 0, 0)] * u[T(1, 0, 0)]
                      + u[T(2, 0, 0)] * u[T(2, 0, 0)]
                      + u[T(3, 0, 0)] * u[T(3, 0, 0)] ) * tmp2
	      - C1 * ( u[T(4, 0, 0)] * tmp1 ) )
	    * ( u[T(3, 0, 0)] * tmp1 ) )
	- dt * tz1
	* ( - ( c34 - c1345 ) * tmp3 * ( pow2(u[T(1, 0, 0)]) )
	    - ( c34 - c1345 ) * tmp3 * ( pow2(u[T(2, 0, 0)]) )
	    - ( r43*c34 - c1345 )* tmp3 * ( pow2(u[T(3, 0, 0)]) )
	    - c1345 * tmp2 * u[T(4, 0, 0)] );
      c[T(4, 1, 0)] = dt * tz2
	* ( - C2 * ( u[T(1, 0, 0)]*u[T(3, 0, 0)] ) * tmp2 )
	- dt * tz1 * ( c34 - c1345 ) * tmp2 * u[T(1, 0, 0)];
      c[T(4, 2, 0)] = dt * tz2
	* ( - C2 * ( u[T(2, 0, 0)]*u[T(3, 0, 0)] ) * tmp2 )
	- dt * tz1 * ( c34 - c1345 ) * tmp2 * u[T(2, 0, 0)];
      c[T(4, 3, 0)] = dt * tz2
	* ( C1 * ( u[T(4, 0, 0)] * tmp1 )
            - 0.50 * C2
            * ( (  u[T(1, 0, 0)]*u[T(1, 0, 0)]
		   + u[T(2, 0, 0)]*u[T(2, 0, 0)]
		   + 3.0*u[T(3, 0, 0)]*u[T(3, 0, 0)] ) * tmp2 ) )
	- dt * tz1 * ( r43*c34 - c1345 ) * tmp2 * u[T(3, 0, 0)];
      c[T(4, 4, 0)] = dt * tz2
	* ( C1 * ( u[T(3, 0, 0)] * tmp1 ) )
	- dt * tz1 * c1345 * tmp1
	- dt * tz1 * dz5;
  }
  
        
        
        
};


void jacu (HTA_2H u, HTA_2H a, HTA_2H b, HTA_2H c, HTA_2H d, bool* mask)
{
/*--------------------------------------------------------------------
c   compute the lower triangular part of the jacobian matrix
--------------------------------------------------------------------*/

/*--------------------------------------------------------------------
c  local variables
--------------------------------------------------------------------*/
  int i, j; 

  r43 = ( 4.0 / 3.0 );
  c1345 = C1 * C3 * C4 * C5;
  c34 = C3 * C4;

  InitD0<double, 3> initD0;
  //HTA_2H tmp1 = d()(iShape);
  //HTA_2H tmp2 = u()(iShape);
  //tmp1.hmap (initD0, tmp2, 0, mask);
  d()(iShape).hmap(initD0, 
		  u()(iShape),
		  0,
		  mask);

  InitA0<double, 3> initA0;
  //HTA_2H tmp3 = a()(iShape);
  //HTA_2H tmp4 = u()(iShape + T(1,0,0));
  //tmp3.hmap (initA0, tmp4, 0, mask);
  a()(iShape).hmap(initA0, 
		  u()(iShape + T(1, 0, 0)),
		  0,
		  mask);

  InitB0<double, 3> initB0;
  //HTA_2H tmp5 = b()(iShape);
  // HTA_2H tmp6 = u()(iShape + T(0,1,0));
  //tmp5.hmap (initB0, tmp6, 0, mask);
  b()(iShape).hmap(initB0, 
		  u()(iShape + T(0, 1, 0)),
		  0,
		  mask);
  
  InitC0<double, 3> initC0;
  //  HTA_2H tmp7 = c()(iShape);
  //HTA_2H tmp8 = u()(iShape + T(0,0,1));
  //tmp7.hmap (initC0, tmp8, 0, mask);
  c()(iShape).hmap(initC0, 
		  u()(iShape + T(0, 0, 1)),
		  0,
		  mask);

}
