struct Psinv{
  
  void operator () (Grid dst,
		    Grid src)
  {   
   
    double w0, w1, w2, w3;
    if (Class == 'A' || Class == 'S' || Class =='W') {
      
      w0 =  -3.0/8.0;
      w1 =  1.0/32.0;
      w2 =  -1.0/64.0;
      w3 =   0.0;
    } else {      
      w0 =  -3.0/17.0;
      w1 =  1.0/33.0;
      w2 =  -1.0/61.0;
      w3 =   0.0;
    }

    const Tuple<3> step_src = src.memMap().linearStep() * src.shape().step();
    int step_src_0 = step_src[0];
    int step_src_1 = step_src[1];
    int step_src_2 = step_src[2];

    const Tuple<3> step_dst = dst.memMap().linearStep() * dst.shape().step();
    int step_dst_0 = step_dst[0];
    int step_dst_1 = step_dst[1];

    int size_0 = src.shape().size()[0]; // most significant
    int size_1 = src.shape().size()[1];
    int size_2 = src.shape().size()[2];
    
    double* u1 = new double [size_2];
    double* u2 = new double [size_2];
    
    const double* a = src.raw();
    double* d = dst.raw();

    //    cout << "Here " << src.shape() << endl;

    for (int i = 1; i < size_0 - 1; i++) {
      for (int j = 1; j < size_1 - 1; j++) {
	
        for (int k = 0; k < size_2; k++) {
	  // can the compiler hoist + k from the index computation here ?
	  u1[k] = 
	    a[i * step_src_0    + (j-1) * step_src_1 + k] + 
	    a[i * step_src_0   + (j+1) * step_src_1  + k] + 
	    a[(i-1) * step_src_0 + j * step_src_1    + k] + 
	    a[(i+1) * step_src_0 + j * step_src_1    + k];
	  u2[k] = 
	    a[(i-1) * step_src_0 + (j-1) * step_src_1 + k] +
	    a[(i-1) * step_src_0 + (j+1) * step_src_1 + k] + 
	    a[(i+1) * step_src_0 + (j-1) * step_src_1 + k] + 
	    a[(i+1) * step_src_0 + (j+1) * step_src_1 + k];
	}
	
        for (int k = 1; k < size_2 - 1; k++) {
	  d[i * step_dst_0  + j * step_dst_1 + k] += 
	    w0 * a[i * step_src_0 + j * step_src_1 + k]  +
	    w1 * (u1[k] + a[i * step_src_0 + j * step_src_1 + k-1] + a[i * step_src_0 + j * step_src_1 + k+1]) +
	    w2 * (u2[k] + u1[k-1] + u1[k+1]);
	}
      }
    }

    delete [] u1;
    delete [] u2;
  }

};
