struct Resid{

  void operator () (Grid dst,
		   Grid src,
		   Grid src2)
  {
    double w0 = -8.0/3.0;
    double w1 =  0.0;
    double w2 =  1.0/6.0;
    double w3 =  1.0/12.0;
          
    const Tuple<3> step_src = src.memMap().linearStep() * src.shape().step();
    int step_src_0 = step_src[0];
    int step_src_1 = step_src[1];
    int step_src_2 = step_src[2];

    const Tuple<3> step_v = src2.memMap().linearStep() * src2.shape().step();
    int step_v_0 = step_v[0];
    int step_v_1 = step_v[1];
    int step_v_2 = step_v[2];

    const Tuple<3> step_dst = dst.memMap().linearStep() * dst.shape().step();
    int step_dst_0 = step_dst[0];
    int step_dst_1 = step_dst[1];

    int size_0 = src.shape().size()[0]; // most significant
    int size_1 = src.shape().size()[1];
    int size_2 = src.shape().size()[2];
    
    double* u1 = new double [size_2];
    double* u2 = new double [size_2];
    
    const double* a = src.raw();
    double* d = dst.raw();
    double* v = src2.raw();
  
    for (int i = 1; i < size_0 - 1; i++) {
      for (int j = 1; j < size_1 - 1; j++) {
	
        for (int k = 0; k < size_2; k++) {
	  // can the compiler hoist + k from the index computation here ?
	  u1[k] = 
	    a[i * step_src_0    + (j-1) * step_src_1 + k] + 
	    a[i * step_src_0   + (j+1) * step_src_1  + k] + 
	    a[(i-1) * step_src_0 + j * step_src_1    + k] + 
	    a[(i+1) * step_src_0 + j * step_src_1    + k];
	  u2[k] = 
	    a[(i-1) * step_src_0 + (j-1) * step_src_1 + k] +
	    a[(i-1) * step_src_0 + (j+1) * step_src_1 + k] + 
	    a[(i+1) * step_src_0 + (j-1) * step_src_1 + k] + 
	    a[(i+1) * step_src_0 + (j+1) * step_src_1 + k];
	}
	
        for (int k = 1; k < size_2 - 1; k++) {
	  d[i * step_dst_0  + j * step_dst_1 + k] = 
	    v[i * step_v_0  + j * step_v_1 + k] - 
	    (w0 * a[i * step_src_0 + j * step_src_1 + k]  +
	    w2 * (u2[k] + u1[k-1] + u1[k+1]) +
	    w3 * (u2[k-1] + u2[k+1]));
	}
      }
    }

    delete [] u1;
    delete [] u2;
  }

};
