
#include <cassert>
#include <iostream>

extern "C" {
#include <upc.h>
}

#ifdef IBM_UPC
extern "C" {
#include <upc_rts.h>
  int __xlc_upc_main(void);
}

/* main routine that as defined by the programmer */
extern int upc_main(int argc, char** argv);
using namespace std;

#define upc_barrier __xlc_upc_barrier
#endif

#ifndef _UPC_PTHREADS
long   cfe_pthread_getspecific(unsigned long);
#endif

#define VERBOSE0
#define DTYPE int 
#define SIZE (THREADS * 5) 

#ifndef IBM_UPC
shared DTYPE Idata[SIZE];
int main()
#else
__xlc_upc_shared_var_handle_t Idata_h;
int __xlc_upc_main () 
#endif
{
  return upc_main(0, NULL);
}

#ifdef IBM_UPC
/* init variables defined by compilation unit */
static void _init_func_module()
{
  int rc = 0;
  rc = __xlc_upc_init_handle (&Idata_h, UPC_SHR_ARRAY, sizeof(DTYPE), THREADS);
  rc += __xlc_upc_init_shared_array(Idata_h, 
                               SIZE,            /* nelts */
                               SIZE/THREADS,    /* local size */
                               1,               /* block size */
                               sizeof(DTYPE),   /* elt size */
                               UPC_SHR_SCALAR); /* array elt type */
  assert(rc == UPCRTS_OK);
}


/* init the UPC rts */
static void _init_func_main()
{
  __xlc_upc_rts_init();
}

static void _fini_func_main()
{
  /*  _upc_rts_free_svd(); */
  cout << MYTHREAD << " says: Have a nice day!" << endl;
}

int __sinit_module() __attribute__((constructor));
int __sinit_module()
{
  __xlc_upc_rts_register(_init_func_main, _fini_func_main);
  __xlc_upc_rts_register(_init_func_module, NULL);
  return 0;
}

#endif /* IBM_UPC */
