
#ifndef __MG_H__
#define __MG_H__

#include <cassert>
#include <iostream>
#include <sys/time.h>
#include "Traits.h"

#ifdef HTA_TRAIT

#if (HTA_TRAIT == HTA_TRAIT_SERIAL)
#include "htalib_serial.h"
#else

#if (HTA_TRAIT == HTA_TRAIT_UPC)
#include "htalib_upc.h"
#else

#if (HTA_TRAIT == HTA_TRAIT_MPI)
#include "htalib_mpi.h"
#else

#error "HTA_TRAIT not properly defined: 1=serial 2=upc 4=mpi"

#endif /* HTA_TRAIT == 4 */
#endif /* HTA_TRAIT == 2 */
#endif /* HTA_TRAIT == 1 */
#else

#error "HTA_TRAIT not defined"
#endif /* HTA_TRAIT */


/* TODO (cvp): if that include is hoisted above new/htalib" then the compile fails. Why? */
#include "globals.h"

#define T(i,j,k) Tuple<3>(i,j,k)
#define SR(l,u,s) Triplet(l,u,s)
typedef Triplet  R;
#define S(arg) Shape<3>(arg)

#define T_total 0
#define T_resid 1
#define T_resid_inner 2
#define T_psinv 3
#define T_psinv_inner 4
#define T_rprj3 5
#define T_rprj3_inner 6
#define T_interp 7
#define T_interp_inner 8
#define T_norm 9
#define T_comm3 10
#define T_zero3 11


#endif /* __MG_H__ */
