/*=========================== PROTOTYPES ==============================================*/
int NPROWS; int NPCOLS; const int CGITMAX = 25;
void makea(HTA_0H_SPARSE A , const Tuple<2>& index);
void makeaCRS (HTA_0H_SPARSE A , const Tuple<2>& index);
void  conj_grad(HTA_1H_SPARSE A , HTA_1H_DENSE x , HTA_1H_DENSE z , double& rnorm);
static void sprnvc(int n , int nz , double v[] , int iv[] , int nzloc[] ,    int mark[]);
static int icnvrt(double x , int ipwr2);
static void vecset(int n , double v[] , int iv[] , int *nzv , int i , double val);

/* ========================== MAIN===================================================== */
void setup ()
{ 
  int t = log2 (max (Traits::Default::nPlaces() , 4));  
    int add = t % 2 ? 1 : 0;
  t += add;
  NPROWS = sqrt (pow((double) 2 , (double)t));
  NPCOLS = NPROWS;
}
int run(int argc , char** argv) 
{
          if (NA == 1400 && NONZER == 7 && NITER == 15 && SHIFT == 10.0) {
    CLASS = 'S';
    zeta_verify_value = 8.5971775078648;
  } else if (NA == 7000 && NONZER == 8 && NITER == 15 && SHIFT == 12.0) {
    CLASS = 'W';
    zeta_verify_value = 10.362595087124;
  } else if (NA == 14000 && NONZER == 11 && NITER == 15 && SHIFT == 20.0) {
    CLASS = 'A';
	zeta_verify_value = 17.130235054029;
  } else if (NA == 75000 && NONZER == 13 && NITER == 75 && SHIFT == 60.0) {
    CLASS = 'B';
    zeta_verify_value = 22.712745482631;
  } else if (NA == 150000 && NONZER == 15 && NITER == 75 && SHIFT == 110.0) {
      CLASS = 'C';
      zeta_verify_value = 28.973605592845;
  } else {
    CLASS = 'U';
  }
  setup();
    NZ = NA*(NONZER+1)*(NONZER+1)/(NPROWS*NPCOLS)
    + NA*(NONZER+2+(NPROWS*NPCOLS)/256)/NPCOLS;  
  double rnorm = 0;
    Sequence<Tuple<2> > tiling_x (Tuple<2>(1 , NA / NPCOLS) , Tuple<2>(NPROWS , NPCOLS)); 
  HTA_1H_DENSE x = HTA_1H_DENSE::alloc(tiling_x);
  HTA_1H_DENSE z = HTA_1H_DENSE::alloc(tiling_x); 
    Sequence<Tuple<2> > tiling_row (Tuple<2>(1 , NA / NPCOLS) , Tuple<2>(NPROWS , NPCOLS)); 
  Sequence<Tuple<2> > tiling_col (Tuple<2>(NA / NPROWS , 1) , Tuple<2>(NPROWS , NPCOLS)); 
  p  = HTA_1H_DENSE::alloc(tiling_row);  
  q  = HTA_1H_DENSE::alloc(tiling_row);   
  r  = HTA_1H_DENSE::alloc(tiling_row);  
  pt = HTA_1H_DENSE::alloc(tiling_col); 
  qt = HTA_1H_DENSE::alloc(tiling_col);
  x = 1.0;
  Sequence<Tuple<2> > tiling_c (Tuple<2>(1 , 1) , Tuple<2>(NPROWS , NPCOLS));
  rho = HTA_1H_DENSE::alloc(tiling_c);
  rho0 = HTA_1H_DENSE::alloc(tiling_c);
  alpha = HTA_1H_DENSE::alloc(tiling_c);
  beta = HTA_1H_DENSE::alloc(tiling_c);
  norm0 = HTA_1H_DENSE::alloc(tiling_c);
    Sequence<Tuple<2> > tiling_a (Tuple<2>( NA / NPROWS , NA / NPCOLS) , Tuple<2> (NPROWS , NPCOLS)); 
  HTA_1H_SPARSE A = HTA_1H_SPARSE::alloc(tiling_a);  
    for(Shape<2>::iterator i = A.shape().begin(); i != A.shape().end(); ++i) {
    Tuple<2> t = *i;
    if (A(t).isLocal()) {
      makeaCRS (A (t) , t);
    }
  }
/*===================== COMP/COMM ============================================================*/
    for (int it = 0; it < NITER; it++) {
    conj_grad(A , x , z , rnorm);    
    HTA_1H_DENSE tmp1 = x * z;
    HTA_1H_DENSE tmp2 = z * z;  
    double norm_temp1 = tmp1.reduce(plus<double>());
    double norm_temp2 = tmp2.reduce(plus<double>());
    double temp2 = 1.0 / sqrt(norm_temp2); 
    zeta = 1.0 / norm_temp1 + SHIFT;
    if (Traits::Default::myPlace() == 0) {
      if (it==0) 
	IO::      IO::    }
    x = temp2 * z;
  }
/*========================= VERIFY ============================================================ */
    double t =   printf(" Benchmark completed\n");
  Traits::Default::barrier();
  if (Traits::Default::myPlace() == 0) {
    bool verified = false;
    double epsilon = 1.0e-10;
    if (CLASS != 'U') {
      if (fabs(zeta - zeta_verify_value) <= epsilon) {
	verified = true;
	printf(" VERIFICATION SUCCESSFUL\n");
	printf(" Zeta is    %20.12e\n" , zeta);
	printf(" Error is   %20.12e\n" , zeta - zeta_verify_value);
      } else {
	verified = false;
	printf(" VERIFICATION FAILED\n");
	printf(" Zeta                %20.12e\n" , zeta);
	printf(" The correct zeta is %20.12e\n" , zeta_verify_value);
      }
    } else {
      verified = false;
      printf(" Problem size unknown\n");
      printf(" NO VERIFICATION PERFORMED\n");
    }
    if ( t != 0.0 ) {
      mflops = (2.0*NITER*NA)
	* (3.0+(NONZER*(NONZER+1)) + 25.0*(5.0+(NONZER*(NONZER+1))) + 3.0 )
	/ t / 1000000.0;
    } else {
      mflops = 0.0;
    }
    c_print_results("CG" , CLASS , NA , 0 , 0 , NITER , Traits::Default::nPlaces() ,     t , mflops , "          floating point" ,     verified , NPBVERSION , COMPILETIME ,     CS1 , CS2 , CS3 , CS4 , CS5 , CS6 , CS7);
    
              }
}
/* ==========================COMP/COMM===================================================== */
void  conj_grad (HTA_1H_SPARSE A ,  HTA_1H_DENSE x ,  HTA_1H_DENSE z ,  double& rnorm) 
{     
  z = 0.0;          
  q = 0.0;          
  r = x;            
  p = r;              
  HTA_1H_DENSE tmp0 = r * r;    
  rho = tmp0.reduce(plus<double>() , 1 , 0x2); 
  for(int i = 0; i < CGITMAX; i++) {
        pt = p.ltranspose();
    HTA_1H_SPARSE::lmatmul(A , pt , &qt);
    qt = qt.reduce(plus<double>() , 1 , 0x2);  
    q = qt.transpose();
        
    HTA_1H_DENSE tmp1 = HTA_1H_DENSE::ldotproduct(p , q);
    HTA_1H_DENSE tmp3 =  tmp1.reduce(plus<double>() , 1 , 0x2);
    alpha = rho / tmp3;
    z = z + p * alpha;                        
    rho0 = rho;                               
    r = r - q * alpha;                         
    HTA_1H_DENSE tmp2 = r * r;
    rho = tmp2.reduce (plus<double>() , 1 , 0x2);
    beta = rho / rho0;                        
    p = r + p * beta;                         
  }  
      HTA_1H_DENSE zt = z.ltranspose();
  HTA_1H_SPARSE::lmatmul(A , zt , &qt); 
  qt = qt.reduce(plus<double>() , 1 , 0x2);  
  r = qt.transpose();  
  HTA_1H_DENSE f = x - r;    
  f = f * f;
  norm0 = f.reduce(plus<double>() , 1 , 0x2); 
  rnorm = sqrt(norm0[Tuple<2>(0 , 0)]);
}
/* ==========================INIT===================================================== */
void makeaCRS (HTA_0H_SPARSE A , const Tuple<2>& index) 
{  
  tran  = 314159265.0;
  amult = 1220703125.0;
  double zeta    =  RandUtils::randlc (&tran , amult);
  int nx = A.shape().size()[0];
  int ny = A.shape().size()[1];  
  int firstrow = index[0] * nx;
  int lastrow = (index[0] + 1) * nx - 1;
  int firstcol = index[1] * ny;
  int lastcol = (index[1] + 1) * ny - 1;
  int n = NA;
  double size = 1.0;
  double ratio = pow(RCOND , (1.0 / double(n)));
  int  nnza = 0;
  double *values = new double [NZ];
  int *colindex = new int [NZ];
  int* rowptr = new int [lastrow - firstrow + 2];
  double element[NZ+1];
  int arow[NZ+1];
  int acol[NZ+1];
  int rowidx[NZ+1];
  int iv[2*NA+1];
  double v[NONZER+1];
    int numelem[lastrow - firstrow + 2];
  for (int i = 0; i < lastrow - firstrow + 2; i++) {
    numelem[i] = 0;
  }
  for (int i = 0; i < n; i++) {
    assert (n+i < NZ+1);
    rowidx[n+i] = 0;
  }
  for (iouter = 0; iouter < n; iouter++) {
    int nzv = NONZER;
    sprnvc (n , nzv , v , iv , &(rowidx[0]) , &(rowidx[n]));
    vecset (n , v , iv , &nzv , iouter , (double) 0.50);
     for (int ivelt = 0; ivelt < nzv; ivelt++) {
      int jcol = iv[ivelt];
      if (jcol >= firstcol && jcol <= lastcol) {
	double scale = size * v[ivelt];
	for (int ivelt1 = 0; ivelt1 < nzv; ivelt1++) { 
	  int irow = iv[ivelt1];
	  if (irow >= firstrow && irow <= lastrow) {
	    assert (nnza <= NZ);
	    acol[nnza] = jcol - firstcol;
	    arow[nnza] = irow - firstrow;
	    element[nnza] = v[ivelt1] * scale;
	    numelem[irow - firstrow + 1]++;
	    nnza = nnza + 1;
	  }
	}
      }
    }
    size = size * ratio;
  }
    
  for (int i = firstrow; i <= lastrow; i++){
    if (i >= firstcol && i <= lastcol) {
      iouter = n + i - 1;
      assert (nnza < NZ+1);
      acol[nnza] = i - firstcol;
      arow[nnza] = i - firstrow;
      element[nnza] = RCOND - SHIFT;
      numelem[i - firstrow + 1]++;
      nnza = nnza + 1;
    }
  }
  rowptr[0] = numelem[0];
  for (int i = 1; i < lastrow - firstrow + 2; i++) {
    numelem[i] += numelem[i-1];
    rowptr[i] = numelem[i];
  }
  for (int i = 0; i < nnza; i++) {
    int j = arow[i];
    int k = numelem[j];
    values[k] = element[i];
    colindex[k] = acol[i];
    numelem[j]++;
  }
  nnza = 0;
  double x[n];
  int nzloc[n];
  bool mark[n];
  for (int i = 0; i < n; i++) {
    x[i] = 0.0;
    nzloc[i] = 0;
    mark[i] = false;
  }
  int jajpr = rowptr[0];
  for (int j = 0; j < lastrow - firstrow + 1; j++) {
    int nzrow = 0;
    for (int k = jajpr; k < rowptr[j+1]; k++) {
      int i = colindex[k];
      x[i] = x[i] + values[k];
      if (mark[i] == false && x[i] != 0.0){	
	mark[i] = true;
	nzloc[nzrow] = i;
	nzrow = nzrow + 1;
      }
    }	
    for (int k = 0; k < nzrow; k++) {
      int i = nzloc[k];
      mark[i] = false;
      double xi = x[i];  
      x[i] = 0.0;
      if (xi != 0.0) {
	values[nnza] = xi;
	colindex[nnza] = i;
	nnza = nnza + 1;      
      }
    }
    jajpr = rowptr[j+1];
    rowptr[j+1] = nnza + rowptr[0];
  }
  A.initSparse (values , rowptr , colindex);
    }
static void sprnvc(		   int n ,    int nz ,    double v[] ,    int iv[] ,    int nzloc[] ,    int mark[] ) 	
{
    int nzrow , nzv , ii , i;
  double vecelt , vecloc;
  nzv = 0;
  nzrow = 0;
  nn1 = 1;
  do {
    nn1 = 2 * nn1;
  } while (nn1 < n);
  
  while (nzv < nz) {
    vecelt = RandUtils:: randlc(&tran , amult);
    vecloc =  RandUtils::randlc(&tran , amult);
    i = icnvrt(vecloc , nn1) + 1;
    if (i > n) continue;
    if (mark[i-1] == 0) {
      nzrow = nzrow + 1;
      nzv = nzv + 1;
      mark[i-1] = 1;
      nzloc[nzrow-1] = i-1;
      v[nzv-1] = vecelt;
      iv[nzv-1] = i-1;
    }
  }
  for (ii = 0; ii < nzrow; ii++) {
    i = nzloc[ii];
    mark[i] = 0;
  }
}
static int icnvrt(double x , int ipwr2) {
  return ((int)(double(ipwr2) * x));
}
static void vecset(		   int n ,    double v[] ,    int iv[] ,    int *nzv ,    int i ,    double val)
{
    bool set;
  set = false;
  for (k = 0; k < *nzv; k++) {
    if (iv[k] == i) {
      v[k] = val;
      set  = true;
    }
  }
  if (set == false) {
    v[*nzv] = val;
    iv[*nzv] = i;
    *nzv = *nzv + 1;
  }
}
