/** Copyright (c) 2007 Basilio B. Fraguela Universidade da Coruna */

#ifndef _HELPERIDX_
#define _HELPERIDX_

#include <cassert>
#include <iostream>

#include "HelperIndxShape.h"

template<class T, int DIM, typename TRAIT>
class HTA;

template<class T, int DIM, typename TRAIT, int FILL>
class HelperIndx;

template<class T, int DIM, typename TRAIT>
class HelperIndx<T, DIM, TRAIT, 1> {

  public:

  HTA<T, DIM, TRAIT>& hta_; 
  Tuple<DIM> t;
  
  typedef HelperIndx<T, DIM, TRAIT, 1> RType;

  HelperIndx(HTA<T, DIM, TRAIT> &hta, int i)
    : hta_(hta)
    {
      //std::cout << "Helper built with " << i << std::endl;
      t[0] = i;
    }

  HelperIndx<T, DIM, TRAIT, 2> operator[] (int i)
  {
    //std::cout << "Helper indexed with [" << i << ']' << std::endl;
    return HelperIndx<T, DIM, TRAIT, 2>(*this, i);
  }

  typename HelperIndxShape<T, DIM, TRAIT, 2>::RType operator[] (const Triplet &tripet) 
  {
    //std::cout << "turned into HelperIndxShape  " << std::endl;
    return HelperIndxShape<T, DIM, TRAIT, 2>(hta_, t, tripet);
  }
  
};

template<class T, int DIM, typename TRAIT, int FILL>
class HelperIndx {
  HelperIndx<T, DIM, TRAIT, 1> &orix_;
public:

  //typedef HelperIndx<T, DIM, TRAIT, FILL> RType;
  
  HelperIndx(HelperIndx<T, DIM, TRAIT, 1> &orix, int i) 
  : orix_(orix)
  {
    //std::cout << "Helper extended with " << i << std::endl;
    orix.t[FILL - 1] = i;
  }

  HelperIndx<T, DIM, TRAIT, FILL+1> operator[] (int i)
  {
    return HelperIndx<T, DIM, TRAIT, FILL+1>(orix_, i);
  }
  
  typename HelperIndxShape<T, DIM, TRAIT, FILL+1>::RType operator[] (const Triplet &tripet) 
  {
    return HelperIndxShape<T, DIM, TRAIT, FILL+1>(orix_.hta_, orix_.t, tripet);
  }

};

template<class T, int DIM, typename TRAIT>
class HelperIndx<T, DIM, TRAIT, DIM> {
  T &v_;
public:
  //typedef T& RType;
	
  HelperIndx(HelperIndx<T, DIM, TRAIT, 1> &orix, int i)
    : v_((orix.t[DIM - 1] = i, (orix.hta_)[orix.t]))
    {
      //std::cout << "Helper extended with " << i << std::endl;
    }
    
    operator T&() { return v_; }

    operator const T&() const { return v_; }

    T& operator= (const T& val) { return v_ = val; }
};

template<class T, typename TRAIT>
class HelperIndx<T, 1, TRAIT, 1> {
  T &v_;
public:
  typedef T& RType;
	
  HelperIndx(HTA<T, 1, TRAIT> &hta, int i)
    : v_(hta[Tuple<1>(i)])
    { }
	
  operator T&() { return v_; }

  operator const T&() const { return v_; }

  T& operator= (const T& val) { return v_ = val; }
};

#endif
