/**
 * IBM SOFTWARE DISCLAIMER 
 *
 * This file is part of htalib, a library for hierarchically tiled arrays.
 * Copyright (c) 2005 IBM Corporation.
 *
 * Permission to use, copy, modify and distribute this software for
 * any noncommercial purpose and without fee is hereby granted,
 * provided that this copyright and permission notice appear on all
 * copies of the software. The name of the IBM Corporation may not be
 * used in any advertising or publicity pertaining to the use of the
 * software. IBM makes no warranty or representations about the
 * suitability of the software for any purpose.  It is provided "AS
 * IS" without any express or implied warranty, including the implied
 * warranties of merchantability, fitness for a particular purpose and
 * non-infringement.  IBM shall not be liable for any direct,
 * indirect, special or consequential damages resulting from the loss
 * of use, data or projects, whether in an action of contract or tort,
 * arising out of or in connection with the use or performance of this
 * software.  
 */

/*
 * Version: $Id: htalib.h,v 1.23 2006/05/16 14:20:22 vonpraun Exp $
 * Authors: Ganesh Bikshandi, Christoph von Praun
 */

#ifndef __HTALIB_H__
#define __HTALIB_H__

#include "MemMapping.h"
#include "HTA.h"
#include "MapReduce.h"
#include "Operators.h"
#include "Router.h"
#include "Shape.h"
#include "Triplet.h"
#include "Tuple.h"

#include "debug/Alloc.h"
#include "debug/Counters.h"
#include "debug/Timers.h"
#include "debug/Tracing.h"

#include "util/IO.h"
#include "util/Sequence.h"
#include "util/Timer.h"


#endif /* __HTALIB_H__ */
