/**
 * IBM SOFTWARE DISCLAIMER 
 *
 * This file is part of htalib, a library for hierarchically tiled arrays.
 * Copyright (c) 2005 IBM Corporation.
 *
 * Permission to use, copy, modify and distribute this software for
 * any noncommercial purpose and without fee is hereby granted,
 * provided that this copyright and permission notice appear on all
 * copies of the software. The name of the IBM Corporation may not be
 * used in any advertising or publicity pertaining to the use of the
 * software. IBM makes no warranty or representations about the
 * suitability of the software for any purpose.  It is provided "AS
 * IS" without any express or implied warranty, including the implied
 * warranties of merchantability, fitness for a particular purpose and
 * non-infringement.  IBM shall not be liable for any direct,
 * indirect, special or consequential damages resulting from the loss
 * of use, data or projects, whether in an action of contract or tort,
 * arising out of or in connection with the use or performance of this
 * software.  
 */

/*
 * Version: $Id: htalib_serial.h,v 1.5 2006/04/03 21:26:50 vonpraun Exp $
 * Authors: Ganesh Bikshandi, Christoph von Praun
 */

#ifndef __HTALIB_SERIAL_H__
#define __HTALIB_SERIAL_H__


#ifdef HTA_DEFAULT_TRAIT
#error "HTA_DEFAULT_TRAIT already defined!"
#else
#define HTA_DEFAULT_TRAIT  SerialDense
#endif

#include "Traits.h"

#ifdef HTA_TRAIT
#if (HTA_TRAIT != HTA_TRAIT_SERIAL)
#error "HTA_TRAIT must be 1 if you include htalib_serial.h"
#endif
#else
#define HTA_TRAIT 1
#endif

/* first include the trait -- this will be the default trait */

#include "serial/SerialTrait.h"

/* then include general implementation (paramterized by trait) */

#include "htalib.h"


#endif /* __HTALIB_SERIAL_H__ */
