/**
 * IBM SOFTWARE DISCLAIMER 
 *
 * This file is part of htalib, a library for hierarchically tiled arrays.
 * Copyright (c) 2005 IBM Corporation.
 *
 * Permission to use, copy, modify and distribute this software for
 * any noncommercial purpose and without fee is hereby granted,
 * provided that this copyright and permission notice appear on all
 * copies of the software. The name of the IBM Corporation may not be
 * used in any advertising or publicity pertaining to the use of the
 * software. IBM makes no warranty or representations about the
 * suitability of the software for any purpose.  It is provided "AS
 * IS" without any express or implied warranty, including the implied
 * warranties of merchantability, fitness for a particular purpose and
 * non-infringement.  IBM shall not be liable for any direct,
 * indirect, special or consequential damages resulting from the loss
 * of use, data or projects, whether in an action of contract or tort,
 * arising out of or in connection with the use or performance of this
 * software.  
 */

/*
 * Version: $Id: htalib_sparse.h,v 1.4 2006/03/17 19:59:30 vonpraun Exp $
 * Authors: Ganesh Bikshandi, Christoph von Praun
 */

#ifndef __HTALIB_SPARSE_H__
#define __HTALIB_SPARSE_H__

#ifdef HTA_DEFAULT_TRAIT
#error "HTA_DEFAULT_TRAIT already defined!"
#else
#define HTA_DEFAULT_TRAIT SerialSparse
#endif

#include "Traits.h"

#ifdef HTA_TRAIT
#if (HTA_TRAIT != HTA_TRAIT_SPARSE)
#error "HTA_TRAIT must be 3 if you include htalib_sparse.h"
#endif
#else
#define HTA_TRAIT 3
#endif

/* first include the trait -- this will be the default trait */

#include "sparse/SparseTrait.h"

/* then include general implementation (parametrized by trait) */

#include "htalib.h"

#endif /* __HTALIB_SPARSE_H__ */
