/**
 * IBM SOFTWARE DISCLAIMER 
 *
 * This file is part of htalib, a library for hierarchically tiled arrays.
 * Copyright (c) 2005 IBM Corporation.
 *
 * Permission to use, copy, modify and distribute this software for
 * any noncommercial purpose and without fee is hereby granted,
 * provided that this copyright and permission notice appear on all
 * copies of the software. The name of the IBM Corporation may not be
 * used in any advertising or publicity pertaining to the use of the
 * software. IBM makes no warranty or representations about the
 * suitability of the software for any purpose.  It is provided "AS
 * IS" without any express or implied warranty, including the implied
 * warranties of merchantability, fitness for a particular purpose and
 * non-infringement.  IBM shall not be liable for any direct,
 * indirect, special or consequential damages resulting from the loss
 * of use, data or projects, whether in an action of contract or tort,
 * arising out of or in connection with the use or performance of this
 * software.  
 */

/*
 * Version: $Id: SparseAllocator.h,v 1.6 2006/06/08 19:22:48 vonpraun Exp $
 * Authors: Christoph von Praun
 */

#ifndef  __SPARSE_ALLOCATOR_H__
#define  __SPARSE_ALLOCATOR_H__

#include <cassert>
#include <iostream>

#include "debug/Tracing.h"
#include "util/AbstractAllocator.h"

using namespace std;


/**
 * this is just a dummy allocator - the core sparse data structures are 
 * memory-managed by the programmer outside htalib
 */
template <typename T> 
class SparseAllocator : public AbstractAllocator <T> 
{

public:
  
  SparseAllocator() 
  {}

  SparseAllocator (int size, bool managed = true, T* init = NULL) 
  {}

  virtual ~SparseAllocator()
  {}


  virtual void print_(ostream& ost) const
  {
    ost << "SparseAllocator()";
  }

public:

  SparseAllocator(const SparseAllocator& o) {}

  SparseAllocator& operator=(const SparseAllocator& rhs) 
  {
    return *this;
  } 
  
  SparseAllocator clone (bool copy_values = false) const
  {
    assert (false);
    return SparseAllocator();
  }
  
  virtual T* get (int offset = 0) const 
  {
    assert (false);
    return NULL;
  }

  bool checkAddress_(int idx) const
  {
    return true; 
  }

};

#endif  /* __SPARSE_ALLOCATOR_H__ */
