  /**
 * IBM SOFTWARE DISCLAIMER 
 *
 * This file is part of htalib, a library for hierarchically tiled arrays.
 * Copyright (c) 2005 IBM Corporation.
 *
 * Permission to use, copy, modify and distribute this software for
 * any noncommercial purpose and without fee is hereby granted,
 * provided that this copyright and permission notice appear on all
 * copies of the software. The name of the IBM Corporation may not be
 * used in any advertising or publicity pertaining to the use of the
 * software. IBM makes no warranty or representations about the
 * suitability of the software for any purpose.  It is provided "AS
 * IS" without any express or implied warranty, including the implied
 * warranties of merchantability, fitness for a particular purpose and
 * non-infringement.  IBM shall not be liable for any direct,
 * indirect, special or consequential damages resulting from the loss
 * of use, data or projects, whether in an action of contract or tort,
 * arising out of or in connection with the use or performance of this
 * software.  
 */

/*
 * Version: $Id: Misc.h,v 1.1 2006/05/22 22:36:02 bikshand Exp $
 * Authors: Christoph von Praun
 */

#ifndef  __MISC_H__
#define  __MISC_H__

#include "debug/Tracing.h"
#include "Tuple.h"
#include "Tuple_1.h"
#include "Tuple_2.h"
#include "Tuple_3.h"

using namespace std;

// (i, j, k), (m, n, p) => (p, j, m)(k, n, i)

template<int DIM>
void crossSwap (Tuple<DIM> & t, Tuple<DIM> & s, Tuple<2> perm) {
  
      int tmp;

      tmp = t[perm[0]];
      t[perm[0]] = s[perm[1]];
      s[perm[1]] = tmp;  

      tmp = t[perm[1]];
      t[perm[1]] = s[perm[0]];
      s[perm[0]] = tmp;    
}

#endif 
