/*********************************************************************/
/*                     I.B.M. CONFIDENTIAL                           */
/*      (c) COPYRIGHT IBM CORP. 2005 ALL RIGHTS RESERVED.            */
/*                                                                   */
/*                LICENSED MATERIALS-PROPERTY OF IBM.                */
/*                                                                   */
/*********************************************************************/

/*
 * Version: $Id: Test_HTA_StridedOp.cc,v 1.4 2006/05/20 03:25:08 bikshand Exp $
 * Authors: Ganesh Bikshandi, Christoph von Praun
 */

#include "htalib_serial.h"
#include <complex.h>
#define T Tuple<3>
 
typedef HTA<double, 3, 1> Grid;

#define TESTNAME "TEST_HTA_STRIDEDOP"

int main (int argc, char** argv) {
  
  Tuple<3>::Seq tiling = ((T(4,4,4), T(4,4,4)));

  /* GB: temporaries -- allocate it outside the function */
  Grid u = HTA<double, 3, 1>::alloc(tiling, NULL, TILE);
  Grid s = HTA<double, 3, 1>::alloc(tiling, NULL, TILE); 
  
  s = 1.0;

  for (int i = 0; i < 4; i++)
    for (int j = 0; j < 4; j++)
      for (int k = 0; k < 4; k++)
	assert (s[T(i, j, k)] != 0);
  
  /* even points */
  Triplet I(0, 3, 2);
  Triplet J(0, 3, 2);
  Triplet K(0, 3, 2);

  /* odd points */
  Triplet II(1, 3, 2);
  Triplet JJ(1, 3, 2);
  Triplet KK(1, 3, 2);

  /* assign even points */
  u()((I, J, K)) =  (Grid) s()((I, J, K));

  /* assign odd points */
  u()((II, JJ, KK)) =  (Grid) s()((II, JJ, KK)); 

  Grid tmp0 = u()((I, J, K));
  Grid tmp1 = u()((II, JJ, KK));
  cout << tmp0(T(0,0,0)).shape() << endl;
  cout << tmp1(T(0,0,0)).shape() << endl;
  
  for (int i = 0; i < 4; i++)
      for (int j = 0; j < 4; j++)
	for (int k = 0; k < 4; k++)
	  assert (u[T(i, j, k)] != 0);

  cout << TESTNAME << " PASSED " << endl;
}
