/*
 * Copyright (c) 2005 IBM Corporation
 *
 * This file is part of htalib, a library for hierarchically tiled arrays.
 */

/*
 * Version: $Id: Test_Shape_3D.cpp,v 1.8 2006/05/16 13:16:30 vonpraun Exp $
 * Authors: Ganesh Bikshandi
 *
 * This is same as Shape_2D test except this works for 3D Case
 * See Test_Shape_2D.cpp for more details 
 */


#include <iostream>

#include "htalib_serial.h"

#define TESTNAME "Shape_3D"
#ifdef NDEBUG
#error Testing with NDEBUG is meaningless.
#endif

int main(){

  Sequence<Triplet> x_args(Triplet(1,4), Triplet(0,5), Triplet(0,8));
  Shape<3> x(x_args);
    
  assert(x.card() == 4*6*9);

  int n = 0;
  for(int i = 1; i <= 4; i++) 
    for(int j = 0; j <= 5; j++)
      for(int k = 0; k <= 8; k++) {
	cout << "n=" << n << " x.ord(" << i << "," << j << "," << k << ")=" << x.ord(Tuple<3>(i,j,k)) << endl;
	assert(n == x.ord(Tuple<3>(i,j,k)));
	n++;
      }
  
  cout << TESTNAME << " PASSED" << endl;
}
