/*
 * Copyright (c) 2005 IBM Corporation
 *
 * This file is part of htalib, a library for hierarchically tiled arrays.
 */

/*
 * Version: $Id: Test_Shape_conformable.cpp,v 1.5 2006/04/11 00:52:21 vonpraun Exp $
 * Authors: Ganesh Bikshandi, Christoph von Praun
 */

#include "Triplet.h"
#include "Shape.h"

#define TESTNAME "Shape_conformable"
#ifdef NDEBUG
#error Testing with NDEBUG is meaningless.
#endif

using namespace std;

void test_conformable() {
  Sequence<Triplet> t_args(Triplet(1,4), Triplet(1,6));
  Shape<2> s(t_args);
  Sequence<Triplet> t_args2(Triplet(2,5), Triplet(2,7));
  Shape<2> s2(t_args2);

  assert(Shape<2>::conformable(s2, s));
  assert(Shape<2>::conformable(s, s2));

  Sequence<Triplet> t_args3 (Triplet(2,5,1), Triplet(2,7,2));
  Shape<2> s3(t_args3);
  assert(!Shape<2>::conformable(s3, s));

  Sequence<Triplet> t_args4 (Triplet(1,10), Triplet(1,20,3));
  Shape<2> s4(t_args4);
  Sequence<Triplet> t_args5 (Triplet(1,10), Triplet(1,7));
  Shape<2> s5(t_args5);
  assert(Shape<2>::conformable(s4, s5));
  assert(Shape<2>::conformable(s5, s4));
}

int main( int argc, char** argv)
{
  test_conformable();
  
  cout << TESTNAME << " PASSED" << endl;
  return 0;
}
