/**
 * IBM SOFTWARE DISCLAIMER 
 *
 * This file is part of htalib, a library for hierarchically tiled arrays.
 * Copyright (c) 2005 IBM Corporation.
 *
 * Permission to use, copy, modify and distribute this software for
 * any noncommercial purpose and without fee is hereby granted,
 * provided that this copyright and permission notice appear on all
 * copies of the software. The name of the IBM Corporation may not be
 * used in any advertising or publicity pertaining to the use of the
 * software. IBM makes no warranty or representations about the
 * suitability of the software for any purpose.  It is provided "AS
 * IS" without any express or implied warranty, including the implied
 * warranties of merchantability, fitness for a particular purpose and
 * non-infringement.  IBM shall not be liable for any direct,
 * indirect, special or consequential damages resulting from the loss
 * of use, data or projects, whether in an action of contract or tort,
 * arising out of or in connection with the use or performance of this
 * software.  
 */

/*
 * Version: $Id: Test_Shape_operator+.cpp,v 1.7 2006/05/16 13:16:30 vonpraun Exp $
 * Authors: Ganesh Bikshandi, Christoph von Praun
 */

#include <iostream>

#include "htalib_serial.h"

#define TESTNAME "Shape_operator+"
#ifdef NDEBUG
#error Testing with NDEBUG is meaningless.
#endif

using namespace std;
int main (int argc, char** argv)
{
  Sequence<Triplet> s_args (Triplet(1,2), Triplet(1,2));
  Shape<2> s(s_args);

  Shape<2> bottom = s + Tuple<2> (1,0);
  Shape<2> top = s + Tuple<2> (-1,0);
  Shape<2> left = s + Tuple<2> (0, -1);
  Shape<2> right = s + Tuple<2> (0, 1);
  Shape<2> topleft = s + Tuple<2> (-1,-1);
  Shape<2> topright = s + Tuple<2> (-1,1);
  Shape<2> bottomleft = s + Tuple<2> (1, -1);
  Shape<2> bottomright = s + Tuple<2> (1, 1);

  cout << s << endl;
  cout << right.ord(Tuple<2>(0,0)) << " " << right.ord(Tuple<2>(0, 1)) << endl;
  cout << left.ord(Tuple<2>(0,0)) << " " << left.ord(Tuple<2>(0, -1)) << endl;
  cout << top.ord(Tuple<2>(0,0)) << " " << top.ord(Tuple<2>(-1, 0)) << endl;
  cout << bottom.ord(Tuple<2>(0,0)) << " " << bottom.ord(Tuple<2>(1, 0))  << endl;
 

  double* data = new double [16];
  for (int i = 0; i < 16; i++)
    data[i] = i;
  
  HTA<double, 2, 0> h = HTA<double, 2, 0>::allocLocal((Tuple<2>(4,4)), data);
  cout << h << endl;
  cout << h [top] << endl;
  cout << h [bottom] << endl;
  cout << h [left] << endl;
  cout << h [right] << endl;
  cout << h [topleft] << endl;
  cout << h [topright] << endl;
  cout << h [bottomleft] << endl;
  cout << h [bottomright] << endl;
  return 0;
}
