/*********************************************************************/
/*                     I.B.M. CONFIDENTIAL                           */
/*      (c) COPYRIGHT IBM CORP. 2005 ALL RIGHTS RESERVED.            */
/*                                                                   */
/*                LICENSED MATERIALS-PROPERTY OF IBM.                */
/*                                                                   */
/*********************************************************************/

/*
 * Version: $Id: Test_Tuple.cpp,v 1.2 2006/02/06 18:55:39 vonpraun Exp $
 * Authors: Ganesh Bikshandi, Christoph von Praun
 */

/* Description:
   Test the Tuple class. 
   Test the overloaded "<" and ">". 
   Test the var-args constructor.
   Test the "printing" by eyes.
*/

#include <cassert>
#include "Tuple.h"

#define TESTNAME "Tuple"
#ifdef NDEBUG
#error Testing with NDEBUG is meaningless.
#endif

int main() {

  Tuple<2> t(3,4);
  Tuple<3> r(3,4,5);
  
  cout << t;	
  cout << r;
  cout << t+t;
  cout << t*t;
  
  Tuple<2> u(4,5);
  Tuple<2> v(2,3);
  
  assert(t < u);
  assert(v < t);
  
  Tuple<2> u_clone = u;
  assert (u_clone == u);
  
  Tuple<2> u_clone2(0,0);
  u_clone2 = u;
  assert (u_clone2 == u);

  cout << endl;
  cout << TESTNAME << " PASSED" << endl;
}
