/*********************************************************************/
/*                     I.B.M. CONFIDENTIAL                           */
/*      (c) COPYRIGHT IBM CORP. 2005 ALL RIGHTS RESERVED.            */
/*                                                                   */
/*                LICENSED MATERIALS-PROPERTY OF IBM.                */
/*                                                                   */
/*********************************************************************/

/*
 * Version: $Id: Test_HTA_StridedOp.cpp,v 1.5 2007/08/07 19:47:29 brodman2 Exp $
 * Authors: Ganesh Bikshandi, Christoph von Praun
 */

#include "htalib_serial.h"
#include <complex>


#define T Tuple<3>
 
typedef HTA<double, 3> Grid;

#define TESTNAME "TEST_HTA_STRIDEDOP"

int main (int argc, char** argv) {
  
  Traits::Default::init(argc, argv);

  Tuple<3>::Seq tiling0 = ((T(10, 10, 10), T(4,4,4)));  
  Tuple<3>::Seq tiling1 = ((T(6, 6, 6), T(4,4,4)));

  /* GB: temporaries -- allocate it outside the function */
  Grid u = HTA<double, 3>::alloc(1, tiling1, NULL, TILE);
  Grid s = HTA<double, 3>::alloc(1, tiling0, NULL, TILE); 
  
  s = 1.0;

  for (int i = 0; i < 40; i++)
    for (int j = 0; j < 40; j++)
      for (int k = 0; k < 40; k++)
	assert (s[T(i, j, k)] != 0);
  
  /* even points */
  Triplet I(1, 8, 2);
  Triplet J(1, 8, 2);
  Triplet K(0, 9, 2);

  /* odd points */
  Triplet II(1, 4);
  Triplet JJ(1, 4);
  Triplet KK(0, 4);

  Grid tmp0 = s()((I, J-1, K));
  Grid tmp1 = u()((II, JJ, KK));
  
  cout << tmp0(T(0,0,0)).shape() << endl;
  cout << tmp1(T(0,0,0)).shape() << endl;
  
  u()((II, JJ, KK)) =  
    (Grid) s()((I, J-1, K)) + 
    (Grid) s()((I, J+1, K)) +
    (Grid) s()((I-1, J, K)) +
    (Grid) s()((I+1, J, K));
  
  cout << u << endl;

 // for (int i = 0; i < 4; i++)
 //   for (int j = 0; j < 4; j++)
 //for (int k = 0; k < 4; k++)
	  //assert (u[T(i, j, k)] != 0);
  Traits::Default::finalize();
	 
  cout << TESTNAME << " PASSED " << endl;


}
