/**
 * IBM SOFTWARE DISCLAIMER 
 *
 * This file is part of htalib, a library for hierarchically tiled arrays.
 * Copyright (c) 2005 IBM Corporation.
 *
 * Permission to use, copy, modify and distribute this software for
 * any noncommercial purpose and without fee is hereby granted,
 * provided that this copyright and permission notice appear on all
 * copies of the software. The name of the IBM Corporation may not be
 * used in any advertising or publicity pertaining to the use of the
 * software. IBM makes no warranty or representations about the
 * suitability of the software for any purpose.  It is provided "AS
 * IS" without any express or implied warranty, including the implied
 * warranties of merchantability, fitness for a particular purpose and
 * non-infringement.  IBM shall not be liable for any direct,
 * indirect, special or consequential damages resulting from the loss
 * of use, data or projects, whether in an action of contract or tort,
 * arising out of or in connection with the use or performance of this
 * software.  
 */

/*
 * Version: $Id: Test_HTA_flatten.cpp,v 1.8 2006/06/07 21:29:01 gabrielt Exp $
 * Authors: Ganesh Bikshandi
 */

#include <iostream>
#include "htalib_serial.h"

#define TESTNAME "HTA_flatten"
#ifdef NDEBUG
#warning Testing without assertions!
#endif

typedef HTA<double, 2> HTA_0H;

using namespace std;

int main( int argc, char** argv) {

  // allocate HTA
  HTA_0H h =  HTA_0H::alloc (0, Tuple<2>(4,4));
  
  // initialize array
  double* a = h.raw();
  for(int i=0; i < 16; i++) 
    a[i] = 1;

  // print 
  cout << "-----------------------------------" << endl << h << endl;
  
  // check if subref returns a scalar
  double tmp = h[Tuple<2>::zero];
  cout << "h[0,0]=" << tmp << endl;

  // take part of the array and add
  Shape<2> s(Tuple<2>(2,2));
  s += Tuple<2>(1, 2);
  h [s] += 5.0;

  // print 
  cout << h << endl;

  s -= Tuple<2>(0, 1);
  h [s] += 1.0;

  // print 
  cout << "-----------------------------------" << endl << h << endl;

  s += Tuple<2>(1, 0);
  cout << "-----------------------------------" << endl << h [s] << endl;
  

  cout << TESTNAME << " PASSED" << endl;
  return 0;
}
