/**
 * IBM SOFTWARE DISCLAIMER 
 *
 * This file is part of htalib, a library for hierarchically tiled arrays.
 * Copyright (c) 2005 IBM Corporation.
 *
 * Permission to use, copy, modify and distribute this software for
 * any noncommercial purpose and without fee is hereby granted,
 * provided that this copyright and permission notice appear on all
 * copies of the software. The name of the IBM Corporation may not be
 * used in any advertising or publicity pertaining to the use of the
 * software. IBM makes no warranty or representations about the
 * suitability of the software for any purpose.  It is provided "AS
 * IS" without any express or implied warranty, including the implied
 * warranties of merchantability, fitness for a particular purpose and
 * non-infringement.  IBM shall not be liable for any direct,
 * indirect, special or consequential damages resulting from the loss
 * of use, data or projects, whether in an action of contract or tort,
 * arising out of or in connection with the use or performance of this
 * software.  
 */

/*
 * Version: $Id: Test_HTA_flatten3.cpp,v 1.5 2006/06/07 21:29:01 gabrielt Exp $
 * Authors: Ganesh Bikshandi
 */

#include <iostream>
#include "htalib_serial.h"

#define TESTNAME "HTA_flatten"
#ifdef NDEBUG
#warning Testing without assertions!
#endif

typedef HTA<double, 2> HTA_0H;

using namespace std;

int main( int argc, char** argv) {

  // allocate HTA
  HTA_0H h =  HTA_0H::alloc (0, Tuple<2>(8,8));
  
  // initialize array
  double* a = h.raw();
  for(int i=0; i < 64; i++) 
    a[i] = i;

  // take part of the array and add
  Shape<2> s( (Triplet(1,7,2), Triplet(1,7,3)) );
  Shape<2>::iterator i = s.begin();
  Shape<2>::iterator end = s.end();

  //assert (!s.isContiguous_());
  // assert (h.shape().isContiguous_());
  cout << "shape=" << s << endl;
  cout << "shape.card() =" << s.card() << endl;
  for (; i != end; ++i) 
    cout << "t=" << *i << " it.ord=" << i.ord() << " s.ord(t)=" << s.ord(*i) << endl;

  cout << "-----------------------------------" << endl << h [s] << endl;
  

  cout << TESTNAME << " PASSED" << endl;
  return 0;
}
