/**
 * IBM SOFTWARE DISCLAIMER 
 *
 * This file is part of htalib, a library for hierarchically tiled arrays.
 * Copyright (c) 2005 IBM Corporation.
 *
 * Permission to use, copy, modify and distribute this software for
 * any noncommercial purpose and without fee is hereby granted,
 * provided that this copyright and permission notice appear on all
 * copies of the software. The name of the IBM Corporation may not be
 * used in any advertising or publicity pertaining to the use of the
 * software. IBM makes no warranty or representations about the
 * suitability of the software for any purpose.  It is provided "AS
 * IS" without any express or implied warranty, including the implied
 * warranties of merchantability, fitness for a particular purpose and
 * non-infringement.  IBM shall not be liable for any direct,
 * indirect, special or consequential damages resulting from the loss
 * of use, data or projects, whether in an action of contract or tort,
 * arising out of or in connection with the use or performance of this
 * software.  
 */

/*
 * Version: $Id: Test_HTA_flatten_multilevel.cpp,v 1.6 2006/06/07 21:29:01 gabrielt Exp $
 * Authors: Ganesh Bikshandi
 */

#include <iostream>
#include <cmath>
#include <complex>

#include "htalib_serial.h"

#define TESTNAME "Test_HTA_flatten_multilevel"
#ifdef NDEBUG
#warning Testing without assertions!
#endif

typedef Tuple<3> T;
typedef HTA<complex<double>, 3> HTA_2H;
typedef HTA<complex<double>, 3> HTA_1H;
typedef HTA<complex<double>, 3> HTA_0H;

using namespace std;


int main( int argc, char** argv) {
  int total_size = 16 * 16 * 16 * 4* 4 * 4;
  
  // create data set
  HTA_2H h = HTA_2H::alloc(2, (T(16, 16, 16), T(4, 4, 1), T(1, 1, 4)), NULL, ROW);
  
  cout << "Error #1 : " << &(h [T(2,2,2)]) << " " << &(h (T(0,0,1)) [T(2,2,0)]) << " " << &(h [T(2,2,16)]) << endl;

  /* this should be false, but this is not so*/
  assert (&(h[T(2,2,2)]) != &(h(T(0,0,1))[T(2,2,0)]) );

  /* this should be true, but it is not so */
  assert (&(h[T(2,2,16)]) == &(h(T(0,0,1))[T(2,2,0)]));

  cout << TESTNAME << " PASSED " << endl;
}


