/**
 * IBM SOFTWARE DISCLAIMER 
 *
 * This file is part of htalib, a library for hierarchically tiled arrays.
 * Copyright (c) 2005 IBM Corporation.
 *
 * Permission to use, copy, modify and distribute this software for
 * any noncommercial purpose and without fee is hereby granted,
 * provided that this copyright and permission notice appear on all
 * copies of the software. The name of the IBM Corporation may not be
 * used in any advertising or publicity pertaining to the use of the
 * software. IBM makes no warranty or representations about the
 * suitability of the software for any purpose.  It is provided "AS
 * IS" without any express or implied warranty, including the implied
 * warranties of merchantability, fitness for a particular purpose and
 * non-infringement.  IBM shall not be liable for any direct,
 * indirect, special or consequential damages resulting from the loss
 * of use, data or projects, whether in an action of contract or tort,
 * arising out of or in connection with the use or performance of this
 * software.  
 */

/*
 * Version: $Id: Test_HTA_lconv.cpp,v 1.3 2006/06/07 21:29:01 gabrielt Exp $
 * Authors: Ganesh Bikshandi
 */

#include <iostream>
#include <cmath>
#include "htalib_serial.h"

#define TESTNAME "HTA_conv"
#ifdef NDEBUG
#warning Testing without assertions!
#endif

typedef HTA<double, 2, Traits::SerialDense<double, 2> > HTA_0H;

using namespace std;

int main( int argc, char** argv) {

  HTA_0H h = HTA_0H::alloc(0, Tuple<2>(8,8));
  HTA_0H d = HTA_0H::alloc(0, Tuple<2>(8,8));

  // double weights[] = { 0.5, 0.25, 0.125 };
  double weights[] = { 0, 1, 1};

  // create data set
  double* a = h.raw();
  for(int i=0; i < 64; i++){
    a[i] = i ; //sin((double)i * theta);
  }
  
  cout << "h=" << endl << h << endl;

  // convolute
  h.lconv(weights, &d);
  
  cout << "d=" << endl << d << endl;

  cout << TESTNAME << " PASSED" << endl;
  return 0;
}
